unit ACMConvertorReg;

{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: ACMConvertorReg.pas, released August 28, 2000.

The Initial Developer of the Original Code is Peter Morris (pete@stuckindoors.com),
Portions created by Peter Morris are Copyright (C) 2000 Peter Morris.
All Rights Reserved.

Purpose of file:
A design-time editor to select formats

Contributor(s):
None as yet


Last Modified: September 14, 2000
Current Version: 1.10

You may retrieve the latest version of this file at http://www.stuckindoors.com/dib

Known Issues:
The editor dialog is not shown modally.
-----------------------------------------------------------------------------}

interface
uses
  Classes, Messages, Windows, Forms, SysUtils, Controls, MSACM, MMSystem, Dialogs,
  ACMConvertor, DsgnIntf;

type
  TACMConvertorEditor = class(TComponentEditor)
  private

  protected
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  published
  end;


procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Sound',[TACMConvertor]);
  RegisterComponentEditor(TACMConvertor, TACMConvertorEditor);
end;

{ TACMConvertorEditor }

procedure TACMConvertorEditor.ExecuteVerb(Index: Integer);
begin
  inherited;
  with TACMConvertor(Component) do
  case Index of
    0 : ChooseFormatIn(True);
    1 : ChooseFormatOut(True);
  end;
  Designer.Modified;
end;

function TACMConvertorEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0 : Result := 'Select input format...';
    1 : Result := 'Select output format...';
  end;
end;

function TACMConvertorEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

end.
 