unit main;

interface

uses Forms, acpuid, StdCtrls, Controls, Classes, ExtCtrls, Dialogs,SysUtils;
  //Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  //acpuid, StdCtrls, ExtCtrls;
type
  TForm1 = class(TForm)
    Quit: TButton;
    psn: TStaticText;
    Label1000: TLabel;
    AutoReferesh: TCheckBox;
    Label1: TLabel;
    Bevel1: TBevel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    cpuclass: TLabel;
    maxlevel: TLabel;
    cpumodel: TLabel;
    cpufamily: TLabel;
    cpustepping: TLabel;
    vendorsign: TLabel;
    eax: TEdit;
    ebx: TEdit;
    ecx: TEdit;
    edx: TEdit;
    Level: TEdit;
    Level0: TButton;
    Level1: TButton;
    Level2: TButton;
    Level3: TButton;
    Label9: TLabel;
    Label10: TLabel;
    Execute: TButton;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    GroupBox1: TGroupBox;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button1: TButton;
    Button2: TButton;
    Label16: TLabel;
    Label15: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label7: TLabel;
    Bevel2: TBevel;
    About: TButton;
    acpuid1: Tacpuid;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure AvailableClick(Sender: TObject);
    procedure psnreferesh(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure UnavailableClick(Sender: TObject);
    procedure ComprehensiveClick(Sender: TObject);
    procedure AutoRefereshClick(Sender: TObject);
    procedure Init(Sender: TObject);
    procedure Level0Click(Sender: TObject);
    procedure Level1Click(Sender: TObject);
    procedure Level2Click(Sender: TObject);
    procedure Level3Click(Sender: TObject);
    procedure GetData; //from acpuid.registers and show them on edit.texts
    procedure PutData; //from edit.texts and store them in the acpuid.registers
    procedure ExecuteClick(Sender: TObject);
    procedure AboutClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  TAB = #9;
  TAB2 = TAB+TAB;
  CRLF = #13#10;
  CRLF2 = CRLF+CRLF;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Position:=poScreenCenter;
  Caption:='aCPUID demo program';
end;

procedure TForm1.Button1Click(Sender: TObject);
const
  HEADER = '##'+TAB+'Description'+CRLF;
  TITLE = ' Cache Info';
begin
  MessageDlg (HEADER+ acpuid1.CacheInfo.Text, mtInformation, [mbOK],0);
end;

procedure TForm1.Button2Click(Sender: TObject);
const
  HEADER = '';
  TITLE = 'Global Info';
begin
  MessageDlg (acpuid1.GlobalInfoText, mtInformation, [mbOK],0);
end;



const HEADER = '##'+TAB+'Feature'+TAB2+'Description'+CRLF;

procedure TForm1.AvailableClick(Sender: TObject);
const TITLE = ' Supported Features';
begin
  MessageDlg (HEADER + acpuid1.FeaturesAvailable([]), mtInformation, [mbOK],0);
end;

procedure TForm1.UnavailableClick(Sender: TObject);
const TITLE = ' Unsupported Features';
begin
  MessageDlg (HEADER + acpuid1.FeaturesNotAvailable([]), mtInformation, [mbOK],0);
end;

procedure TForm1.ComprehensiveClick(Sender: TObject);
const
  HEADER = '##'+TAB+'Feature'+TAB2+'Avail?'+TAB+'Description'+CRLF;
  TITLE = ' Comprehensive Feature List';
begin
  MessageDlg (HEADER+ acpuid1.FeatureList.Text, mtInformation, [mbOK],0);
end;

procedure TForm1.QuitClick(Sender: TObject);
begin
  close
end;

procedure TForm1.psnreferesh(Sender: TObject);
begin
  with TStaticText(Sender), acpuid1.CPUSerialNo do
    if PentiumIII then
      Caption:=PSN_String
     else
       Caption:='NOT SUPPORTED';
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Init(Self);
end;


procedure TForm1.AutoRefereshClick(Sender: TObject);
begin
  acpuid1.Auto:=TCheckBox(Sender).Checked;
end;

procedure TForm1.Init(Sender: TObject);
begin
  psn.OnClick(psn);
  cpuclass.Caption:=inttostr(ord(acpuid1.Cpuinfo.cpuClass));
  vendorsign.Caption:=acpuid1.VendorSign;
  cpumodel.Caption:=acpuid1.CPUInfo.cpuModel;
  cpufamily.Caption:=acpuid1.CPUInfo.cpuFamily;
  maxlevel.Caption:=inttostr(acpuid1.MaxLevel);
  cpustepping.caption:=inttostr(acpuid1.CPUInfo.cpuStepping);
end;


procedure TForm1.GetData;
begin
  Level.Text:=inttostr(acpuid1.Levelno);
  eax.Text:=inttohex(acpuid1.Registers.eax,8);
  ebx.Text:=inttohex(acpuid1.Registers.ebx,8);
  ecx.Text:=inttohex(acpuid1.Registers.ecx,8);
  edx.Text:=inttohex(acpuid1.Registers.edx,8);
end;

procedure TForm1.PutData;
begin
  acpuid1.Levelno:=strtointdef(Level.Text,0);
  acpuid1.Registers.eax:=strtointdef(eax.Text,0);
  acpuid1.Registers.ebx:=strtointdef(ebx.Text,0);
  acpuid1.Registers.ecx:=strtointdef(ecx.Text,0);
  acpuid1.Registers.edx:=strtointdef(edx.Text,0);
end;

procedure TForm1.Level0Click(Sender: TObject);
begin
  with acpuid1 do if Auto then Auto:=FALSE;
  acpuid1.ExecuteLevel0;
  GetData;
end;

procedure TForm1.Level1Click(Sender: TObject);
begin
  with acpuid1 do if Auto then Auto:=FALSE;
  acpuid1.ExecuteLevel1;
  GetData;
end;

procedure TForm1.Level2Click(Sender: TObject);
begin
  with acpuid1 do if Auto then Auto:=FALSE;
  acpuid1.ExecuteLevel2;
  GetData;
end;

procedure TForm1.Level3Click(Sender: TObject);
begin
  with acpuid1 do if Auto then Auto:=FALSE;
  acpuid1.ExecuteLevel3;
  GetData;
end;

procedure TForm1.ExecuteClick(Sender: TObject);
begin
  with acpuid1 do if Auto then Auto:=FALSE;
  PutData;
  acpuid1.Execute;
  GetData;
end;

procedure TForm1.AboutClick(Sender: TObject);
begin
  acpuid1.About
end;

end.

