{***************************************************************
 *
 * Unit Name : CheckListGridColumns
 * Purpose   : Check List - Grid Visible Columns
 * Author    : Eugen Mihailescu
 * Company   : EM Quicksoft Romania SRL
 * Copyright : 1998,2002  All rights reserved.
 * Web Site  : http://www.em-quicksoft.com
 * Support   : support@em-quicksoft.com
 * History   : 03/19/2000
 *
 * Disclaimer: The objectives of this program is only educational.
 *             You MUST NOT use it without getting any material benefit on it
 *             You have the right to share this code with others without removing
 *             the copyright and/or disclaimer notice.
 *             You are allowed to include its code in your application
 *             only if it was designed for non commercial purpose,
 *             otherwise we claim $10 for each copy of your
 *             application which contains this code inside.
 ****************************************************************}

Unit CheckListGridColumns;

Interface

Uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  checklst,
  DBGrids;

Type
  TCheckListGridColumns = Class(TCheckListBox)
  private
    FGrid: TDBGrid;
  protected
    Procedure SetGrid(Value: TDBGrid);
  public
    Procedure ReList;
    Procedure ApplyChecks;
  published
    Property DBGrid: TDBGrid read FGrid write SetGrid;
  End;

Procedure Register;

Implementation
//******************* TCheckListGridColumns.SetGrid *************************

Procedure TCheckListGridColumns.SetGrid(Value: TDBGrid);
Begin
  FGrid := Value;
  Relist;
End;
//******************* TCheckListGridColumns.Relist *************************

Procedure TCheckListGridColumns.Relist;
Var
  I                 : Integer;
Begin
  Items.Clear;
  For I := 0 To FGrid.FieldCount - 1 Do
    Begin
      Items.Add(FGrid.Columns[I].Title.Caption);
      Checked[I] := (FGrid.DataSource.DataSet.Fields[I].Visible = True)
    End;
End;
//******************* TCheckListGridColumns.ApplyChecks *************************

Procedure TCheckListGridColumns.ApplyChecks;
Var
  I                 : Integer;
Begin
  For I := 0 To Items.Count - 1 Do
    FGrid.DataSource.DataSet.Fields[I].Visible := Checked[I];
  FGrid.Update;
End;

Procedure Register;
Begin
  RegisterComponents('EM-Quicksoft', [TCheckListGridColumns]);
End;

End.

