unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, PropsSaver, LayoutManager, ExtCtrls, DynProps, TwoColsComponent;

type
  TFormMain = class(TForm)
    Label1: TLabel;
    ComboBoxLayout: TComboBox;
    Button1: TButton;
    PropsSaverLayouts: TPropsSaver;
    PropsSaver: TPropsSaver;
    LayoutManager: TLayoutManager;
    Button2: TButton;
    Memo1: TMemo;
    Panel1: TPanel;
    Memo2: TMemo;
    Splitter1: TSplitter;
    Memo3: TMemo;
    Button3: TButton;
    DynPropertiesHolder: TDynPropertiesHolder;
    Label2: TLabel;
    LabelValue: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBoxLayoutChange(Sender: TObject);
    procedure PropsSaverLayoutsAfterSavingProperties(Sender: TObject);
    procedure PropsSaverLayoutsAfterLoadingProperties(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure PropsSaverLayoutsComponents2Properties0AfterLoadingProperty(
      Sender: TObject);
  private
    CurrentLayout : String;
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

uses Unit1, Unit3;

{$R *.DFM}

procedure TFormMain.Button1Click(Sender: TObject);
var
  NewLayout : string;
begin
  NewLayout := InputBox ('New Layout', 'Please enter a new layout name', '');
  if NewLayout <> ''
    then
    begin
      ComboBoxLayout.Items.Add (NewLayout);
      ComboBoxLayout.ItemIndex := ComboBoxLayout.Items.Count - 1;
      with LayoutManager.LayoutItems.Add do
        begin
          LayoutName := NewLayout;
          { Note the assignation of LayoutId. In this little application
            there are two LayoutIds, the one that saves Layout configuration information
            that's: PropsSaverLayouts that actually has not LayoutId because we don't
            want it enters in LayoutProcessing, and the other two PropsSaver that
            have MainLayout as LayoutId }
          LayoutId := 'MainLayout';
          with Parameters.Add do
            begin
              Parameter := '%1';
              Value := NewLayout;
            end;
        end;
      ComboBoxLayoutChange (nil);  
    end;
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  ComboBoxLayout.ItemIndex := 0;
end;

procedure TFormMain.ComboBoxLayoutChange(Sender: TObject);
begin
  if CurrentLayout <> ''
    then
    begin
      LayoutManager.SaveLayout (CurrentLayout);
      LayoutManager.RestoreLayout (ComboBoxLayout.Text);
      CurrentLayout := ComboBoxLayout.Text;
    end;
end;

procedure TFormMain.PropsSaverLayoutsAfterSavingProperties(
  Sender: TObject);
begin
  LayoutManager.SaveLayout (ComboBoxLayout.Text);
end;

procedure TFormMain.PropsSaverLayoutsAfterLoadingProperties(
  Sender: TObject);
begin
  CurrentLayout := ComboBoxLayout.Text;
  LayoutManager.RestoreLayout (CurrentLayout);
end;

procedure TFormMain.Button2Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TFormMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  try
    { The properties will be saved here because otherwise Form2 is always
      hidden if saved using AutoSave options }
    PropsSaverLayouts.SaveProperties;
  except
    { Ignore Exception, close anyway }
  end;
end;

procedure TFormMain.Button3Click(Sender: TObject);
begin
  Form3.Show;
end;

procedure TFormMain.PropsSaverLayoutsComponents2Properties0AfterLoadingProperty(
  Sender: TObject);
begin
  LabelValue.Caption := DynPropertiesHolder ['TestProperty'];
end;

end.
