unit DynPropsEditors;

interface

uses
  DsgnIntf;

type
  TDynPropsEditor = class (TComponentEditor)
  private
    procedure GetPropertyEditor (prop : TPropertyEditor);
  public
    procedure Edit; override;
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

implementation

uses
  LayoutManager, typinfo;

{ TDynPropsEditor }

function TDynPropsEditor.GetVerb;
begin
  Result := '';
end;

function TDynPropsEditor.GetVerbCount;
begin
  Result := 0;
end;

procedure TDynPropsEditor.GetPropertyEditor;
begin
  if prop.GetName = 'DynProperties'
    then
    begin
      prop.Edit;
      prop.Free;
    end
    else prop.Free;
end;

procedure TDynPropsEditor.Edit;
var
  Comp : TDesignerSelectionList;
begin
  Comp := TDesignerSelectionList.Create;
  try
    Comp.Add (Component);
    GetComponentProperties (Comp, [tkClass], Designer, GetPropertyEditor);
  finally
    Comp.Free;
  end;
end;

procedure TDynPropsEditor.ExecuteVerb;
begin
  Edit;
end;

end.
