{
ExDBGrid Component Suite Version 3.5 - ExDBGridCtls

Copyright () 1999 & 2000 by GJL Software
Updated 22nd November 2000 (22/11/2000)

Email:         ExDBGrid@gjl-software.co.uk
Home Page:     http://www.gjl-software.co.uk
}

{.$DEFINE ADS}
{.$Define ADO}

unit ExDBGridCtls;

interface

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    Buttons, ExtCtrls, StdCtrls, Db, DbTables, ComCtrls, AdvStatusBar,
    DBCtrls, Menus, JPEG, ExtDlgs, Printers
    {$IFDEF ADS}, AdsData, AdsFunc, AdsTable{$ENDIF}
    {$IFDEF ADO}, AdoDB{$ENDIF};

type
    TExDBGridCtlsForm = class(TForm)
        Memo1: TMemo;
        ScrollBox1: TScrollBox;
        AdvStatusBar1: TAdvStatusBar;
        DBImage: TImage;
        PopupMenu: TPopupMenu;
        Cut1: TMenuItem;
        Copy1: TMenuItem;
        Paste1: TMenuItem;
        N1: TMenuItem;
        Clear1: TMenuItem;
        OpenDialog: TOpenPictureDialog;
        SaveDialog: TSaveDialog;
        N2: TMenuItem;
        Open1: TMenuItem;
        Save1: TMenuItem;
        Panel1: TPanel;
        Okbtn: TSpeedButton;
        Panel2: TPanel;
        Cancelbtn: TSpeedButton;
        RichEdit1: TRichEdit;
        Panel3: TPanel;
        SaveAsbtn: TSpeedButton;
        Panel4: TPanel;
        PrintBtn: TSpeedButton;
        SaveAsDialog: TSaveDialog;
        PrintDialog: TPrintDialog;
        procedure CancelbtnClick(Sender: TObject);
        procedure OkbtnClick(Sender: TObject);
        procedure FormActivate(Sender: TObject);
        procedure MenuClick(Sender: TObject);
        procedure FileOpen(Sender: TObject);
        procedure SavebtnClick(Sender: TObject);
        procedure FormKeyPress(Sender: TObject; var Key: Char);
        procedure Memo1KeyPress(Sender: TObject; var Key: Char);
        procedure RichEdit1KeyPress(Sender: TObject; var Key: Char);
        procedure SaveAsbtnClick(Sender: TObject);
        procedure PrintBtnClick(Sender: TObject);
    private
        { Private declarations }
        FBlobCaption: string;
        FBlobField: TField;
        FDataSource: TDataSource;
        function GetBlobSize(Field: TBlobField): Longint;
    public
        { Public declarations }
        property BlobCaption: string read FBlobCaption write FBlobCaption;
        property BlobField: TField read FBlobField write FBlobField;
        property DataSource: TDataSource read FDataSource write FDataSource;
    end;

var
    ExDBGridCtlsForm: TExDBGridCtlsForm;

procedure PrintStrings(Strings: TStrings);

implementation

{$R *.DFM}

procedure TExDBGridCtlsForm.CancelbtnClick(Sender: TObject);
begin
    ExDBGridCtlsForm.ModalResult := mrCancel;
end;

procedure TExDBGridCtlsForm.OkbtnClick(Sender: TObject);
var
    ImageInfo: Boolean;
    BLOBStream: TBLOBStream;
begin
    if Memo1.Visible = True then
        begin
            if Assigned(FDataSource) then
                begin
                    if (FDataSource.DataSet is TTable) then
                        begin
                            if (TTable(FDataSource.DataSet).ReadOnly = False) then
                                begin
                                    FDataSource.DataSet.Edit;
                                    FBlobField.AsString := Memo1.Lines.Text;
                                end;
                        end
                    else
                        if (FDataSource.DataSet is TQuery) then
                            begin
                                if (TQuery(FDataSource.DataSet).CanModify = True) then
                                    begin
                                        FDataSource.DataSet.Edit;
                                        FBlobField.AsString := Memo1.Lines.Text;
                                    end;
                                {$IFDEF ADS}
                            end
                        else
                            if (FDataSource.DataSet is TAdsTable) then
                                begin
                                    if (TAdsTable(FDataSource.DataSet).Readonly = False) then
                                        begin
                                            FDataSource.DataSet.Edit;
                                            FBlobField.Assign(Memo1.Lines);
                                        end;
                                end
                            else
                                if (FDataSource.DataSet is TAdsQuery) then
                                    begin
                                        if (TAdsQuery(FDataSource.DataSet).CanModify = True) then
                                            begin
                                                FDataSource.DataSet.Edit;
                                                FBlobField.Assign(Memo1.Lines);
                                            end;
                                        {$ENDIF}
                                        {$IFDEF ADO}
                                    end
                                else
                                    if (FDataSource.DataSet is TAdoTable) then
                                        begin
                                            if (TAdoTable(FDataSource.DataSet).Readonly = False) then
                                                begin
                                                    FDataSource.DataSet.Edit;
                                                    FBlobField.Assign(Memo1.Lines);
                                                end;
                                        end
                                    else
                                        if (FDataSource.DataSet is TAdoQuery) then
                                            begin
                                                if (TAdoQuery(FDataSource.DataSet).CanModify = True) then
                                                    begin
                                                        FDataSource.DataSet.Edit;
                                                        FBlobField.Assign(Memo1.Lines);
                                                    end;
                                                {$ENDIF}
                                            end;
                end
            else
                raise(Exception.Create('Datasource Not Assigned'));
        end
    else
        if RichEdit1.Visible = True then
            begin
                if Assigned(FDataSource) then
                    begin
                        if (FDataSource.DataSet is TTable) then
                            begin
                                if (TTable(FDataSource.DataSet).ReadOnly = False) then
                                    begin
                                        FDataSource.DataSet.Edit;
                                        FBlobField.Assign(RichEdit1.Lines);
                                    end;
                            end
                        else
                            if (FDataSource.DataSet is TQuery) then
                                begin
                                    if (TQuery(FDataSource.DataSet).CanModify = True) then
                                        begin
                                            FDataSource.DataSet.Edit;
                                            FBlobField.Assign(RichEdit1.Lines);
                                        end;
                                    {$IFDEF ADS}
                                end
                            else
                                if (FDataSource.DataSet is TAdsTable) then
                                    begin
                                        if (TAdsTable(FDataSource.DataSet).Readonly = False) then
                                            begin
                                                FDataSource.DataSet.Edit;
                                                FBlobField.Assign(RichEdit1.Lines);
                                            end;
                                    end
                                else
                                    if (FDataSource.DataSet is TAdsQuery) then
                                        begin
                                            if (TAdsQuery(FDataSource.DataSet).CanModify = True) then
                                                begin
                                                    FDataSource.DataSet.Edit;
                                                    FBlobField.Assign(RichEdit1.Lines);
                                                end;
                                            {$ENDIF}
                                            {$IFDEF ADO}
                                        end
                                    else
                                        if (FDataSource.DataSet is TAdoTable) then
                                            begin
                                                if (TAdoTable(FDataSource.DataSet).Readonly = False) then
                                                    begin
                                                        FDataSource.DataSet.Edit;
                                                        FBlobField.Assign(RichEdit1.Lines);
                                                    end;
                                            end
                                        else
                                            if (FDataSource.DataSet is TAdoQuery) then
                                                begin
                                                    if (TAdoQuery(FDataSource.DataSet).CanModify = True) then
                                                        begin
                                                            FDataSource.DataSet.Edit;
                                                            FBlobField.Assign(RichEdit1.Lines);
                                                        end;
                                                    {$ENDIF}
                                                end;
                    end
                else
                    raise(Exception.Create('Datasource Not Assigned'));
            end
        else
            begin
                if FDataSource.State in [dsEdit, dsInsert] then
                    begin
                        ImageInfo := DBImage.Picture.Graphic is TJPEGImage;

                        if ImageInfo then
                            begin
                                BlobStream := TBLOBStream.Create(TBlobField(FBlobField), bmReadWrite);
                                BlobStream.Seek(0, soFromBeginning);
                                BlobStream.Truncate;
                                DBImage.Picture.Graphic.SaveToStream(BlobStream);
                                BlobStream.Free;
                            end
                        else
                            begin
                                FDataSource.DataSet.FieldByName(FBlobField.FieldName).Assign(DBImage.Picture);
                            end;
                    end;
            end;

    ExDBGridCtlsForm.ModalResult := mrYes;
end;

procedure TExDBGridCtlsForm.FormActivate(Sender: TObject);
var
    JPEGStream: TBLOBStream;
    JPEGImage: TJPEGImage;
    BlobSize: string;
begin
    JPEGStream := nil;
    JPEGImage := nil;

    ExDBGridCtlsForm.Caption := FBlobCaption;

    if (FBlobField is TMemoField) and (FBlobField.DataType <> ftFmtMemo) then
        begin
            Memo1.Lines.Text := FBlobField.AsString;
            if (FDataSource.DataSet is TTable) then
                begin
                    if (TTable(FDataSource.DataSet).Readonly) then
                        Memo1.ReadOnly := True;
                end
            else
                if (FDataSource.DataSet is TQuery) then
                    begin
                        if (TQuery(FDataSource.DataSet).CanModify = False) then
                            Memo1.ReadOnly := True;
                    end;
            {$IFDEF ADS}
            if (FDataSource.DataSet is TAdsTable) then
                begin
                    if (TAdsTable(FDataSource.DataSet).Readonly) then
                        Memo1.ReadOnly := True;
                end
            else
                if (FDataSource.DataSet is TAdsQuery) then
                    begin
                        if (TAdsQuery(FDataSource.DataSet).CanModify = False) then
                            Memo1.ReadOnly := True;
                    end;
            {$ENDIF}
            {$IFDEF ADO}
            if (FDataSource.DataSet is TAdoTable) then
                begin
                    if (TAdoTable(FDataSource.DataSet).Readonly) then
                        Memo1.ReadOnly := True;
                end
            else
                if (FDataSource.DataSet is TAdoQuery) then
                    begin
                        if (TAdoQuery(FDataSource.DataSet).CanModify = False) then
                            Memo1.ReadOnly := True;
                    end;
            {$ENDIF}
            Memo1.Visible := True;
            Panel3.Visible := True;
            Panel4.Visible := True;
        end
    else
        if not (FBlobField is TMemoField) and (FBlobField.DataType <> ftFmtMemo) and (FBlobField is TBlobField) then
            begin
                try
                    try
                        DBImage.Picture.Assign(FBlobField);
                        BlobSize := IntToStr(GetBlobSize(TBlobField(FBlobField)));
                        ExDBGridCtlsForm.Caption := ExDBGridCtlsForm.Caption + ' - Bitmap Image - ' + BlobSize + 'Kb';
                    except
                        try
                            JPEGStream := TBLOBStream.Create(TBlobField(FBlobField), bmRead);
                            BlobSize := IntToStr(GetBlobSize(TBlobField(FBlobField)));

                            JPegImage := TJPEGImage.Create;
                            JPegImage.LoadFromStream(JPegStream);

                            DBImage.Picture.Assign(JPegImage);
                            ExDBGridCtlsForm.Caption := ExDBGridCtlsForm.Caption + ' - Jpeg Image - ' + BlobSize + 'Kb'
                        finally
                            JPEGStream.Free;
                            JPegImage.Free;
                        end;
                    end;

                    ScrollBox1.Visible := True;
                    Panel3.Visible := False;
                    Panel4.Visible := False;
                except
                    ExDBGridCtlsForm.ModalResult := mrCancel;
                end;
            end
        else
            if (FBlobField is TMemoField) or (FBlobField.DataType = ftFmtMemo) then
                begin
                    RichEdit1.Lines.Assign(FBlobField);
                    if (FDataSource.DataSet is TTable) then
                        begin
                            if (TTable(FDataSource.DataSet).Readonly) then
                                RichEdit1.ReadOnly := True;
                        end
                    else
                        if (FDataSource.DataSet is TQuery) then
                            begin
                                if (TQuery(FDataSource.DataSet).CanModify = False) then
                                    RichEdit1.ReadOnly := True;
                            end;
                    {$IFDEF ADS}
                    if (FDataSource.DataSet is TAdsTable) then
                        begin
                            if (TAdsTable(FDataSource.DataSet).Readonly) then
                                RichEdit1.ReadOnly := True;
                        end
                    else
                        if (FDataSource.DataSet is TAdsQuery) then
                            begin
                                if (TAdsQuery(FDataSource.DataSet).CanModify = False) then
                                    RichEdit1.ReadOnly := True;
                            end;
                    {$ENDIF}
                    {$IFDEF ADO}
                    if (FDataSource.DataSet is TAdoTable) then
                        begin
                            if (TAdoTable(FDataSource.DataSet).Readonly) then
                                RichEdit1.ReadOnly := True;
                        end
                    else
                        if (FDataSource.DataSet is TAdoQuery) then
                            begin
                                if (TAdoQuery(FDataSource.DataSet).CanModify = False) then
                                    RichEdit1.ReadOnly := True;
                            end;
                    {$ENDIF}
                    RichEdit1.Visible := True;
                    Panel3.Visible := True;
                    Panel4.Visible := True;
                end;
end;

procedure TExDBGridCtlsForm.MenuClick(Sender: TObject);
begin
    case Integer(TMenuItem(Sender).Tag) of
        1: DBImage.Perform(WM_CUT, 0, 0);
        2: DBImage.Perform(WM_COPY, 0, 0);
        3: DBImage.Perform(WM_PASTE, 0, 0);
        4: DBImage.Picture.Graphic := nil;
    end;
end;

procedure TExDBGridCtlsForm.FileOpen(Sender: TObject);
begin
    with OpenDialog do
        if Execute then
            DBImage.Picture.LoadFromFile(FileName);
end;

procedure TExDBGridCtlsForm.SavebtnClick(Sender: TObject);
begin
    with SaveDialog do
        if Execute then
            begin
                DBImage.Picture.SaveToFile(FileName);
                ShowMessage(FileName + ' Saved !');
            end;
end;

procedure TExDBGridCtlsForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #27 then
        ExDBGridCtlsForm.ModalResult := mrCancel;
end;

procedure TExDBGridCtlsForm.Memo1KeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #27 then
        ExDBGridCtlsForm.ModalResult := mrCancel;
end;

procedure TExDBGridCtlsForm.RichEdit1KeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #27 then
        ExDBGridCtlsForm.ModalResult := mrCancel;
end;

function TExDBGridCtlsForm.GetBlobSize(Field: TBlobField): Longint;
begin
    with TBlobStream.Create(Field, bmRead) do
    try
        Result := Seek(0, 2);
    finally
        Free;
    end;
end;

procedure TExDBGridCtlsForm.SaveAsbtnClick(Sender: TObject);
var
    F1: TextFile;
    i: integer;
begin
    if Memo1.Visible then
        begin
            with SaveAsDialog do
                begin
                    if Execute then
                        begin
                            AssignFile(F1, FileName);
                            Rewrite(F1);
                            for i := 0 to Memo1.Lines.Count - 1 do
                                begin
                                    Write(F1, Memo1.Lines[i] + #13 + #10);
                                end;
                            CloseFile(F1);
                            ShowMessage(FileName + ' Saved !');
                        end;
                end;
        end
    else
        begin
            with SaveAsDialog do
                begin
                    if Execute then
                        begin
                            AssignFile(F1, FileName);
                            Rewrite(F1);
                            for i := 0 to RichEdit1.Lines.Count - 1 do
                                begin
                                    Write(F1, RichEdit1.Lines[i] + #13 + #10);
                                end;
                            CloseFile(F1);
                            ShowMessage(FileName + ' Saved !');
                        end;
                end;
        end;
end;

procedure TExDBGridCtlsForm.PrintBtnClick(Sender: TObject);
begin
    if Memo1.Visible then
        begin
            if PrintDialog.Execute then
                begin
                    PrintStrings(Memo1.Lines);
                end;
        end
    else
        begin
            if PrintDialog.Execute then
                begin
                    RichEdit1.Print(BlobCaption);
                end;
        end;
end;

procedure PrintStrings(Strings: TStrings);
var
    Prn: TextFile;
    i: word;
begin
    AssignPrn(Prn);
    try
        Rewrite(Prn);
        try
            for i := 0 to Strings.Count - 1 do
                writeln(Prn, Strings.Strings[i]);
        finally
            CloseFile(Prn);
        end;
    except
        on EInOutError do
            MessageDlg('Error Printing Text.', mtError, [mbOk], 0);
    end;
end;

end.

