{
ExDBGrid Component Suite Version 3.5 - ExDBQbf

Original Design By () 1995 by Rick Rutt.
Updated Copyright () 1999 & 2000 by GJL Software
Updated 22nd November 2000 (22/11/2000)

Email:         ExDBGrid@gjl-software.co.uk
Home Page:     http://www.gjl-software.co.uk
}

{.$DEFINE ADS}
{.$Define ADO}

unit ExDBQbf;

interface

uses
    Windows, Classes, Graphics, Forms, Controls, Buttons, StdCtrls, ExtCtrls,
    Grids, DBGrids
    {$IFDEF ADS}, AdsData, AdsFunc, AdsTable{$ENDIF}
    {$IFDEF ADO}, AdoDB{$ENDIF};

procedure QueryByForm(grid: TDbGrid);
procedure SortByForm(grid: TDbGrid);

type
    TdlgExDBQbf = class(TForm)
        gridQBF: TStringGrid;
        Panel1: TPanel;
        OKBtn: TSpeedButton;
        Panel2: TPanel;
        CancelBtn: TSpeedButton;
        procedure OKBtnClick(Sender: TObject);
        procedure CancelBtnClick(Sender: TObject);
        procedure FormKeyPress(Sender: TObject; var Key: Char);
        procedure gridQBFKeyPress(Sender: TObject; var Key: Char);
    private
        { Private declarations }
    public
        { Public declarations }
    end;

var
    dlgExDBQbf: TdlgExDBQbf;

implementation

uses Dialogs, Db, DbTables;

{$R *.DFM}

const
    qbfRowHeight = 16;
    qbfColWidth = 150;
    qbfFieldLabel = ' Field ';
    qbfValueLabel = ' Value ';
    qbfQueryCaption = ' Query For Table ';
    qbfSortCaption = ' Sort Order For Table ';
var
    CallingGrid: TDbGrid;
    CallingMode: (modeQuery, modeSort);

procedure SetupAndShowForm;
var
    i, j, n: integer;
    tbl: TTable;
    {$IFDEF ADS}
    adstbl: TAdsTable;
    {$ENDIF}
    {$IFDEF ADO}
    adotbl: TAdoTable;
    {$ENDIF}
    f: TField;
begin
    n := CallingGrid.FieldCount;
    if n <= 0 then
        begin
            MessageDlg('QBF called for a Grid without any Fields', mtWarning, [mbOK], 0);
        end
    else
        if CallingGrid.DataSource = nil then
            begin
                MessageDlg('QBF called for a Grid without a DataSource', mtWarning, [mbOK], 0);
            end
        else
            if CallingGrid.DataSource.DataSet = nil then
                begin
                    MessageDlg('QBF called for a Grid with a DataSource without a DataSet', mtWarning, [mbOK], 0);
                end
            else
                if not (CallingGrid.DataSource.DataSet is TTable) then
                    begin
                        MessageDlg('QBF called for a Grid with a DataSource that is not a Table', mtWarning, [mbOK], 0);
                        {$IFDEF ADS}
                    end
                else
                    if not (CallingGrid.DataSource.DataSet is TAdsTable) then
                        begin
                            MessageDlg('QBF called for a Grid with a DataSource that is not a Table', mtWarning, [mbOK], 0);
                            {$ENDIF}
                            {$IFDEF ADS}
                        end
                    else
                        if not (CallingGrid.DataSource.DataSet is TAdoTable) then
                            begin
                                MessageDlg('QBF called for a Grid with a DataSource that is not a Table', mtWarning, [mbOK], 0);
                                {$ENDIF}
                            end
                        else
                            with dlgExDBQbf.gridQBF do
                                begin
                                    DefaultRowHeight := qbfRowHeight;
                                    Scrollbars := ssVertical;
                                    ColCount := 2;
                                    RowCount := Succ(n);
                                    Cells[0, 0] := qbfFieldLabel;
                                    Options := Options + [goRowMoving];
                                    tbl := TTable(CallingGrid.DataSource.DataSet);
                                    {$IFDEF ADS}
                                    adstbl := TAdsTable(CallingGrid.DataSource.DataSet);
                                    {$ENDIF}
                                    {$IFDEF ADO}
                                    adotbl := TAdoTable(CallingGrid.DataSource.DataSet);
                                    {$ENDIF}
                                    if CallingMode = modeQuery then
                                        begin
                                            dlgExDBQbf.Caption := qbfQueryCaption + tbl.TableName;
                                            {$IFDEF ADS}
                                            dlgExDBQbf.Caption := qbfQueryCaption + adstbl.TableName;
                                            {$ENDIF}
                                            {$IFDEF ADO}
                                            dlgExDBQbf.Caption := qbfQueryCaption + adotbl.TableName;
                                            {$ENDIF}
                                            Cells[1, 0] := qbfValueLabel;
                                            Options := Options + [goEditing];
                                            DefaultColWidth := qbfColWidth;
                                        end
                                    else
                                        begin
                                            dlgExDBQbf.Caption := qbfSortCaption + tbl.TableName;
                                            Cells[1, 0] := '';
                                            Options := Options - [goEditing];
                                            DefaultColWidth := (2 * qbfColWidth);
                                        end;
                                    j := 0;
                                    for i := 1 to n do
                                        begin
                                            f := CallingGrid.Fields[Pred(i)];
                                            if f.DataType in [ftBlob, ftBytes, ftGraphic, ftMemo, ftUnknown, ftVarBytes] then
                                                RowCount := Pred(RowCount)
                                            else
                                                begin
                                                    Inc(j);
                                                    Cells[0, j] := f.FieldName;
                                                    Cells[1, j] := '';
                                                end;
                                        end;
                                    dlgExDBQbf.ShowModal;
                                end;
end;

procedure QueryByForm(Grid: TDbGrid);
begin
    CallingGrid := Grid;
    CallingMode := modeQuery;
    SetupAndShowForm;
end;

procedure SortByForm(Grid: TDbGrid);
begin
    CallingGrid := Grid;
    CallingMode := modeSort;
    SetupAndShowForm;
end;

procedure TdlgExDBQbf.CancelBtnClick(Sender: TObject);
begin
    dlgExDBQbf.ModalResult := mrCancel;
    dlgExDBQbf.Hide;
end;

procedure TdlgExDBQbf.OKBtnClick(Sender: TObject);
var
    flds, sep, val: string;
    i, n: integer;
begin
    dlgExDBQbf.ModalResult := mrOk;

    flds := '';
    sep := '';

    with dlgExDBQbf.gridQBF do
        begin
            n := Pred(RowCount);
            if n > 0 then
                for i := 1 to n do
                    begin
                        val := Cells[1, i];
                        if (CallingMode = modeSort) or (val <> '') then
                            begin
                                flds := flds + sep + Cells[0, i];
                                sep := ';';
                            end;
                    end;
            with CallingGrid.DataSource.DataSet as TTable do
                begin
                    IndexFieldNames := flds;
                    if (CallingMode = modeSort) or (flds = '') then
                        begin
                            CancelRange;
                        end
                    else
                        begin
                            SetRangeStart;
                            for i := 1 to n do
                                begin
                                    val := Cells[1, i];
                                    if val <> '' then
                                        begin
                                            FieldByName(Cells[0, i]).AsString := val;
                                        end;
                                end;
                            SetRangeEnd;
                            for i := 1 to n do
                                begin
                                    val := Cells[1, i];
                                    if val <> '' then
                                        begin
                                            FieldByName(Cells[0, i]).AsString := val;
                                        end;
                                end;
                            ApplyRange;
                        end;
                    Refresh;
                end;

            {$IFDEF ADS}
            with CallingGrid.DataSource.DataSet as TAdsTable do
                begin
                    IndexFieldNames := flds;
                    if (CallingMode = modeSort) or (flds = '') then
                        begin
                            CancelRange;
                        end
                    else
                        begin
                            SetRangeStart;
                            for i := 1 to n do
                                begin
                                    val := Cells[1, i];
                                    if val <> '' then
                                        begin
                                            FieldByName(Cells[0, i]).AsString := val;
                                        end;
                                end;
                            SetRangeEnd;
                            for i := 1 to n do
                                begin
                                    val := Cells[1, i];
                                    if val <> '' then
                                        begin
                                            FieldByName(Cells[0, i]).AsString := val;
                                        end;
                                end;
                            ApplyRange;
                        end;
                    Refresh;
                end;
            {$ENDIF}

            {$IFDEF ADS}
            with CallingGrid.DataSource.DataSet as TAdoTable do
                begin
                    IndexFieldNames := flds;
                    if (CallingMode = modeSort) or (flds = '') then
                        begin
                            CancelRange;
                        end
                    else
                        begin
                            SetRangeStart;
                            for i := 1 to n do
                                begin
                                    val := Cells[1, i];
                                    if val <> '' then
                                        begin
                                            FieldByName(Cells[0, i]).AsString := val;
                                        end;
                                end;
                            SetRangeEnd;
                            for i := 1 to n do
                                begin
                                    val := Cells[1, i];
                                    if val <> '' then
                                        begin
                                            FieldByName(Cells[0, i]).AsString := val;
                                        end;
                                end;
                            ApplyRange;
                        end;
                    Refresh;
                end;
            {$ENDIF}
        end;
    dlgExDBQbf.Hide;
end;

procedure TdlgExDBQbf.FormKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #27 then
        begin
            dlgExDBQbf.ModalResult := mrCancel;
        end;
end;

procedure TdlgExDBQbf.gridQBFKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #27 then
        begin
            dlgExDBQbf.ModalResult := mrCancel;
        end;
end;

end.

