
unit RptUn;

interface

uses SysUtils, Objects, DataUnit, QStrings, Dialogs, WaitUn, MsgOkUn, ExcelRpt;

procedure MakeMatrVedRpt;
procedure MakeSaldVedRpt;
procedure MakeSellVedRpt;
procedure MakeDayPayRpt;
procedure MakeAnProdRpt;
procedure MakeDayRashNalRpt;
procedure MakeDayRashReaRpt;
procedure MakeDayRashAllRpt;
procedure MakePerRashNalRpt;
procedure MakePerRashReaRpt;
procedure MakePerRashAllRpt;
procedure MakeDaySpisRpt;
procedure MakePerSpisRpt;
procedure MakeTovNalRpt;
procedure MakeTovReaRpt;
procedure MakeTovAllRpt;
procedure MakeOffVedRpt;
procedure MakeInvoiceRpt;

implementation

type
  PItgArr = ^TItgArr;
  TItgArr = array[0..1000000] of Integer;

var
  Rpt: TExcelReport = nil;

procedure MakeMatrVedRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldMainLN: Integer;
    fldName: string;
    fldProvName: string;
    fldTypeOfPay: Integer;
    fldCostIn: Double;
    fldCostOut: Double;
    fldStartOst: Double;
    fldPrihod: Double;
    fldPrihSum: Double;
    fldRealiz: Double;
    fldRealSum: Double;
    fldSpis: Double;
    fldSpisSum: Double;
    fldEndOst: Double;
    fldAdvSum: Double;
  end;
var
  In1,Out1,Spis1: Double;
  KI,KO,KS: Double;
  Ost1,Ost2: Double;
  In1_P,Out1_P,Spis1_P: Double;
  KI_P,KO_P,KS_P: Double;
  Ost1_P,Ost2_P: Double;
  I,J,K,N,MainLN: Integer;
  ItLCnt,NiCnt: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  ItgArr,NiArr: PItgArr;
  ArFlag: Boolean;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItLCnt := 0;
  NiCnt := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      IOsColl.SwitchToIndex(IndexBy_TovarRec);
      ArFlag := True;
      MainLN := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        Ost1 := 0;
        In1 := 0;
        Out1 := 0;
        Spis1 := 0;
        with IOsObj do
        begin
          if InvoiceObj.DateOfPost < RgStart then
            Ost1 := IOsObj.Kolvo
          else if InvoiceObj.DateOfPost <= RgEnd then
            In1 := IOsObj.Kolvo;
          if RashColl <> nil then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              with RashObj do
              begin
                if DateRash < RgStart then
                  Ost1 := Ost1 - Kolvo
                else if DateRash <= RgEnd then
                  if VidRash <> trWriteOff then
                    Out1 := Out1 + Kolvo
                  else
                    Spis1 := Spis1+Kolvo;
              end;
            end;
        end;
        if (In1<>0) or (Out1<>0) or (Spis1<>0) then
        begin
          if ArFlag then
            Inc(N);
          GetMem(LR,SizeOf(TLineRec));
          with LR^ do
          begin
            fldNumber := N;
            Pointer(fldName) := nil;
            if ArFlag then
            begin
              fldName := ArtObj.Name;
              fldMainLN := -1;
              MainLN := Lines.Count;
              Inc(NiCnt);
            end else
            begin
              fldMainLN := MainLn;
              if PLineRec(Lines.List^[Lines.Count-1])^.fldMainLN = -1 then
              begin
                Inc(ItLCnt);
                Dec(NiCnt);
              end;
            end;
            Pointer(fldProvName) := nil;
            fldProvName := Providers.GetNameByNumber(IOsObj.InvoiceObj.ProvRef);
            fldTypeOfPay := IOsObj.TypeOfPay;
            fldCostIn := IOsObj.CostIn;
            fldCostOut := IOsObj.CostOut;
            fldStartOst := Ost1;
            fldPrihod := In1;
            fldPrihSum := In1*IOsObj.CostIn;
            fldRealiz := Out1;
            fldRealSum := Out1*IOsObj.CostOut;
            fldSpis := Spis1;
            fldSpisSum := Spis1*IOsObj.CostIn;
            fldEndOst := Ost1+In1-Out1-Spis1;
            fldAdvSum := fldRealSum-fldPrihSum;
          end;
          ArFlag := False;
          Lines.Add(LR);
        end;
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('  ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+ItLCnt+1,1,15], varVariant);
  GetMem(ItgArr,ItLCnt*SizeOf(Integer));
  GetMem(NiArr,NiCnt*SizeOf(Integer));
  J := 0;
  N := 0;
  In1 := 0;
  Out1 := 0;
  Spis1 := 0;
  KI := 0;
  KO := 0;
  KS := 0;
  Ost1 := 0;
  Ost2 := 0;
  In1_P := 0;
  Out1_P := 0;
  Spis1_P := 0;
  KI_P := 0;
  KO_P := 0;
  KS_P := 0;
  Ost1_P := 0;
  Ost2_P := 0;
  K := 0;
  for I := 0 to Lines.Count-1 do
  begin
    Inc(K);
    LR := Lines.List^[I];
    with LR^ do
    begin
      if fldMainLN = -1 then
      begin
        V[K,1] := fldNumber;
        V[K,2] := fldName;
        ArFlag := True;
      end else
        ArFlag := False;
      V[K,3] := fldProvName;
      case fldTypeOfPay of
        tpNalich: V[K,4] := ' ';
        tpRealiz: V[K,4] := ' ';
        tpCosign: V[K,4] := '';
      end;
      V[K,5] := fldCostIn;
      V[K,6] := fldCostOut;
      V[K,7] := fldStartOst;
      V[K,8] := fldPrihod;
      V[K,9] := fldPrihSum;
      V[K,10] := fldRealiz;
      V[K,11] := fldRealSum;
      V[K,12] := fldSpis;
      V[K,13] := fldSpisSum;
      V[K,14] := fldEndOst;
      V[K,15] := fldAdvSum;
      In1 := In1 + fldPrihSum;
      Out1 := Out1 + fldRealSum;
      Spis1 := Spis1 + fldSpisSum;
      KI := KI + fldPrihod;
      KO := KO + fldRealiz;
      KS := KS + fldSpis;
      Ost1 := Ost1+fldStartOst;
      Ost2 := Ost2+fldEndOst;
      In1_P := In1_P + fldPrihSum;
      Out1_P := Out1_P + fldRealSum;
      Spis1_P := Spis1_P + fldSpisSum;
      KI_P := KI_P + fldPrihod;
      KO_P := KO_P + fldRealiz;
      KS_P := KS_P + fldSpis;
      Ost1_P := Ost1_P+fldStartOst;
      Ost2_P := Ost2_P+fldEndOst;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
    if (I=Lines.Count-1) or (PLineRec(Lines.List^[I+1])^.fldMainLN=-1) then
    begin
      if not ArFlag then
      begin
        Inc(K);
        V[K,2] := '     :';
        V[K,7] := Ost1_P;
        V[K,8] := KI_P;
        V[K,9] := In1_P;
        V[K,10] := KO_P;
        V[K,11] := Out1_P;
        V[K,12] := KS_P;
        V[K,13] := Spis1_P;
        V[K,14] := Ost2_P;
        V[K,15] := Out1_P-In1_P;
        ItgArr^[J] := K;
        Inc(J);
      end else
      begin
        NiArr^[N] := K;
        Inc(N);
      end;
      In1_P := 0;
      Out1_P := 0;
      Spis1_P := 0;
      KI_P := 0;
      KO_P := 0;
      KS_P := 0;
      Ost1_P := 0;
      Ost2_P := 0;
    end;
  end;
  Inc(K);
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,7] := Ost1;
  V[K,8] := KI;
  V[K,9] := In1;
  V[K,10] := KO;
  V[K,11] := Out1;
  V[K,12] := KS;
  V[K,13] := Spis1;
  V[K,14] := Ost2;
  V[K,15] := Out1-In1;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+MatrRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+MatrRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := ' ';
      WinCaption1 := ' 1';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[4,2] := '   '+FormatDateTime('dd.mm.yyyy',RgStart)+'  '+
        FormatDateTime('dd.mm.yyyy',RgEnd);
      FontBold := True;
      FontSize := 12;
      Cells[6,2] := ': '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      AlignVertical(11,2,10+K,16,xlVAlignCenter);
      AlignHorizontal(11,5,10+K,5,xlHAlignCenter);
      ApplyNumberFormat(11,6,10+K,7,'0,00');
      ApplyNumberFormat(11,8,10+K,9,'0');
      ApplyNumberFormat(11,10,10+K,10,'0,00');
      ApplyNumberFormat(11,11,10+K,11,'0');
      ApplyNumberFormat(11,12,10+K,12,'0,00');
      ApplyNumberFormat(11,13,10+K,13,'0');
      ApplyNumberFormat(11,14,10+K,14,'0,00');
      ApplyNumberFormat(11,15,10+K,15,'0');
      ApplyNumberFormat(11,16,10+K,16,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(11,2,10+K,16);
      DrawRightLines(11,16,10+K,16);
      for J := 0 to ItLCnt-1 do
        DrawBottomLines(10+ItgArr^[J],2,10+ItgArr^[J],16);
      for N := 0 to NiCnt-1 do
        DrawBottomLines(10+NiArr^[N],2,10+NiArr^[N],16);
      DrawBottomLines(10+K,2,10+K,16);
      CreateTable(V,11,2,False);
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  FreeMem(ItgArr);
  FreeMem(NiArr);
  WaitForm.Hide;
end;

procedure MakeSaldVedRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldCostIn: Double;
    fldCostOut: Double;
    fldOst: Double;
    fldSum: Double;
    fldFLn: Boolean;
  end;
var
  Ost,Sum: Double;
  Ost_P,Sum_P: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  ItgCnt,NiCnt: Integer;
  ItgArr,NiArr: PItgArr;
  ArFlag,PostFlag: Boolean;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItgCnt := 0;
  NiCnt := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      IOsColl.SwitchToIndex(IndexBy_TovarRec);
      ArFlag := True;
      PostFlag := True;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        Ost := 0;
        with IOsObj do
        begin
          if InvoiceObj.DateOfPost <= RsDate then
            Ost := IOsObj.Kolvo;
          if RashColl <> nil then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              if RashObj.DateRash <= RsDate then
                Ost := Ost - RashObj.Kolvo;
            end;
        end;
        if Ost <> 0 then
        begin
          GetMem(LR,SizeOf(TLineRec));
          with LR^ do
          begin
            Pointer(fldName) := nil;
            if ArFlag then
            begin
              Inc(N);
              fldNumber := N;
              fldFLn := True;
              ArFlag := False;
              fldName := ArtObj.Name;
              Inc(NiCnt);
            end else
            begin
              fldFLn := False;
              if PostFlag then
              begin
                Dec(NiCnt);
                Inc(ItgCnt);
                PostFlag := False;
              end;
            end;
            fldCostIn := IOsObj.CostIn;
            fldCostOut := IOsObj.CostOut;
            fldOst := Ost;
            fldSum := Ost*fldCostIn;
          end;
          Lines.Add(LR);
        end;
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('  ');
    FreeAndNil(Lines);
    Exit;
  end;
  GetMem(ItgArr,ItgCnt*SizeOf(Integer));
  GetMem(NiArr,NiCnt*SizeOf(Integer));
  V := VarArrayCreate([1,Lines.Count+ItgCnt+1,1,6], varVariant);
  Ost := 0;
  Sum := 0;
  Ost_P := 0;
  Sum_P := 0;
  J := 0;
  N := 0;
  K := 0;
  for I := 0 to Lines.Count-1 do
  begin
    Inc(K);
    LR := Lines.List^[I];
    with LR^ do
    begin
      if fldFLn then
      begin
        ArFlag := True;
        V[K,1] := fldNumber;
        V[K,2] := fldName;
      end else
        ArFlag := False;
      V[K,3] := fldCostIn;
      V[K,4] := fldCostOut;
      V[K,5] := fldOst;
      V[K,6] := fldSum;
      Ost := Ost+fldOst;
      Sum := Sum+fldSum;
      Ost_P := Ost_P+fldOst;
      Sum_P := Sum_P+fldSum;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
    if (I=Lines.Count-1) or PLineRec(Lines.List^[I+1])^.fldFLn then
    begin
      if not ArFlag then
      begin
        Inc(K);
        V[K,2] := '     :';
        V[K,5] := Ost_P;
        V[K,6] := Sum_P;
        ItgArr^[J] := K;
        Inc(J);
      end else
      begin
        NiArr^[N] := K;
        Inc(N);
      end;
      Ost_P := 0;
      Sum_P := 0;
    end;
  end;
  Inc(K);
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,5] := Ost;
  V[K,6] := Sum;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+SaldRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+SaldRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := ' ';
      WinCaption1 := ' 2';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[4,2] := ' '+Q_GetDateStr(RsDate);
      FontBold := True;
      FontSize := 12;
      Cells[6,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(11,4,10+K,5,'0,00');
      ApplyNumberFormat(11,6,10+K,6,'0');
      ApplyNumberFormat(11,7,10+K,7,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(11,2,10+K,7);
      DrawRightLines(11,7,10+K,7);
      for J := 0 to ItgCnt-1 do
        DrawBottomLines(10+ItgArr^[J],2,10+ItgArr^[J],7);
      for N := 0 to NiCnt-1 do
        DrawBottomLines(10+NiArr^[N],2,10+NiArr^[N],7);
      DrawBottomLines(10+K,2,10+K,7);
      CreateTable(V,11,2,False);
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  FreeMem(ItgArr);
  FreeMem(NiArr);
  WaitForm.Hide;
end;

procedure MakeSellVedRpt;
var
  I,K: Integer;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  K := 0;
  if Sellers.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('  ');
    Exit;
  end;
  V := VarArrayCreate([1,Sellers.Count,1,3], varVariant);
  for I := 0 to Sellers.Count-1 do
  begin
    Inc(K);
    V[K,1] := K;
    with TSellerObj(Sellers.List^[I]) do
    begin
      V[K,2] := Name;
      if ShopObj <> nil then
        V[K,3] := ShopObj.Name;
    end;
  end;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+SellRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+SellRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      WinCaption2 := ' ';
      WinCaption1 := ' 3';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := ' '+Q_GetDateStr(RsDate);
      BordersWeight := xlThin;
      DrawLeftLines(9,2,8+K,4);
      DrawRightLines(9,4,8+K,4);
      DrawBottomLines(9,2,8+K,4);
      CreateTable(V,9,2,False);
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakeDayPayRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldCostOut: Double;
    fldSum: Double;
  end;
var
  Kol,Sum: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  Sum := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
        begin
          Kol := 0;
          if RashColl <> nil then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              with RashObj do
                if (DateRash=RsDate) and (VidRash<>trWriteOff) then
                  Kol := Kol + Kolvo;
            end;
        end;
        if Kol <> 0 then
        begin
          Inc(N);
          GetMem(LR,SizeOf(TLineRec));
          with LR^ do
          begin
            fldNumber := N;
            Pointer(fldName) := nil;
            fldName := ArtObj.Name;
            fldKolvo := Kol;
            fldCostOut := IOsObj.CostOut;
            fldSum := Kol*IOsObj.CostOut;
            Sum := Sum+fldSum;
          end;
          Lines.Add(LR);
        end;
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('    ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,5], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldCostOut;
      V[K,5] := fldSum;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,5] := Sum;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+DayPRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+DayPRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '  ';
      WinCaption1 := ' 4';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := ' '+Q_GetDateStr(RsDate);
      FontBold := True;
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(11,5,10+K,6,'0,00');
      ApplyNumberFormat(11,4,10+K,4,'0');
      BordersWeight := xlThin;
      DrawLeftLines(11,2,10+K,6);
      DrawRightLines(11,6,10+K,6);
      DrawBottomLines(11,2,10+K,6);
      CreateTable(V,11,2,False);
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakeAnProdRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldOstat: Double;
    fldProdano: Double;
    fldNacProc: Double;
  end;
var
  Ost,Kol: Double;
  ItKol,ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItKol := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      Ost := 0;
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
        begin
          Ost := Ost+Kolvo;
          if RashColl <> nil then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              with RashObj do
              begin
                if DateRash < RgStart then
                  Ost := Ost-Kolvo
                else if (DateRash>=RgStart) and (DateRash<=RgEnd) and
                    (VidRash<>trWriteOff) then
                begin
                  Kol := Kol + Kolvo;
                  SumIn := SumIn + Kolvo*IOsObj.CostIn;
                  SumOut := SumOut + Kolvo*IOsObj.CostOut;
                end;
              end;
            end;
        end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldOstat := Ost;
          fldProdano := Kol;
          fldNacProc := (SumOut-SumIn)/SumIn*100;
          ItKol := ItKol+Kol;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('      ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,5], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldOstat;
      V[K,4] := fldProdano;
      V[K,5] := fldNacProc;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItKol;
  V[K,5] := (ItSumOut-ItSumIn)/ItSumIn*100;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+AnPrRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+AnPrRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '   ';
      WinCaption1 := ' 5';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,3] := '   '+Q_GetDateStr(RgStart)+'  '+Q_GetDateStr(RgEnd);
      Cells[7,3] := ': '+Shops.GetNameByNumber(CurrShopNum);
      Cells[9,4] := '  '+FormatDateTime('dd.mm.yyyy',RgStart);
      ApplyNumberFormat(11,4,10+K,5,'0');
      ApplyNumberFormat(11,6,10+K,6,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(11,2,10+K,6);
      DrawRightLines(11,6,10+K,6);
      DrawBottomLines(11,2,10+K,6);
      CreateTable(V,11,2,False);
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakeDayRashNalRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldSumIn: Double;
    fldSumOut: Double;
  end;
var
  Kol: Double;
  ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
          if (Q_ScanInteger(InvoiceObj.ProvRef,ProvMarks,ProvMkCnt)<>-1) and
              (RashColl<>nil) then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              with RashObj do
              begin
                if (DateRash=RsDate) and (VidRash=trZaNalich) then
                begin
                  Kol := Kol + Kolvo;
                  SumIn := SumIn + Kolvo*IOsObj.CostIn;
                  SumOut := SumOut + Kolvo*IOsObj.CostOut;
                end;
              end;
            end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldKolvo := Kol;
          fldSumIn := SumIn;
          fldSumOut := SumOut;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('  ,   , ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,6], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldSumIn;
      V[K,5] := fldSumOut;
      V[K,6] := fldSumOut-fldSumIn;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItSumIn;
  V[K,5] := ItSumOut;
  V[K,6] := ItSumOut-ItSumIn;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+RashRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+RashRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '   ,   ';
      WinCaption1 := ' 6';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := ' '+Q_GetDateStr(RsDate);
      FontSize := 20;
      FontBold := True;
      Cells[2,2] := '  ()';
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(14,4,13+K,4,'0');
      ApplyNumberFormat(14,5,13+K,7,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(14,2,13+K,7);
      DrawRightLines(14,7,13+K,7);
      DrawBottomLines(14,2,13+K,7);
      CreateTable(V,14,2,False);
      if ProvMkCnt = 1 then
        Cells[9,2] := ': '+Providers.GetNameByNumber(ProvMarks^[0])
      else if ProvMkAll then
        Cells[9,2] := ' '
      else
      begin
        InsertRows(10,ProvMkCnt);
        FontBold := True;
        Cells[9,2] := ' :';
        FontBold := False;
        for I := 0 to ProvMkCnt-1 do
          Cells[10+I,2] := Providers.GetNameByNumber(ProvMarks^[I]);
      end;
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakeDayRashReaRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldSumIn: Double;
    fldSumOut: Double;
  end;
var
  Kol: Double;
  ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
          if (Q_ScanInteger(InvoiceObj.ProvRef,ProvMarks,ProvMkCnt)<>-1) and
              (RashColl<>nil) then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              with RashObj do
              begin
                if (DateRash=RsDate) and (VidRash=trPodRealz) then
                begin
                  Kol := Kol + Kolvo;
                  SumIn := SumIn + Kolvo*IOsObj.CostIn;
                  SumOut := SumOut + Kolvo*IOsObj.CostOut;
                end;
              end;
            end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldKolvo := Kol;
          fldSumIn := SumIn;
          fldSumOut := SumOut;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('  ,   , ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,6], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldSumIn;
      V[K,5] := fldSumOut;
      V[K,6] := fldSumOut-fldSumIn;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItSumIn;
  V[K,5] := ItSumOut;
  V[K,6] := ItSumOut-ItSumIn;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+RashRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+RashRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '   ,   ';
      WinCaption1 := ' 7';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := ' '+Q_GetDateStr(RsDate);
      FontSize := 20;
      FontBold := True;
      Cells[2,2] := '  ( )';
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(14,4,13+K,4,'0');
      ApplyNumberFormat(14,5,13+K,7,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(14,2,13+K,7);
      DrawRightLines(14,7,13+K,7);
      DrawBottomLines(14,2,13+K,7);
      CreateTable(V,14,2,False);
      if ProvMkCnt = 1 then
        Cells[9,2] := ': '+Providers.GetNameByNumber(ProvMarks^[0])
      else if ProvMkAll then
        Cells[9,2] := ' '
      else
      begin
        InsertRows(10,ProvMkCnt);
        FontBold := True;
        Cells[9,2] := ' :';
        FontBold := False;
        for I := 0 to ProvMkCnt-1 do
          Cells[10+I,2] := Providers.GetNameByNumber(ProvMarks^[I]);
      end;
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakeDayRashAllRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldSumIn: Double;
    fldSumOut: Double;
  end;
var
  Kol: Double;
  ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
          if (Q_ScanInteger(InvoiceObj.ProvRef,ProvMarks,ProvMkCnt)<>-1) and
              (RashColl<>nil) then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              with RashObj do
              begin
                if (DateRash=RsDate) and (VidRash<>trWriteOff) then
                begin
                  Kol := Kol + Kolvo;
                  SumIn := SumIn + Kolvo*IOsObj.CostIn;
                  SumOut := SumOut + Kolvo*IOsObj.CostOut;
                end;
              end;
            end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldKolvo := Kol;
          fldSumIn := SumIn;
          fldSumOut := SumOut;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('     ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,6], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldSumIn;
      V[K,5] := fldSumOut;
      V[K,6] := fldSumOut-fldSumIn;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItSumIn;
  V[K,5] := ItSumOut;
  V[K,6] := ItSumOut-ItSumIn;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+RashRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+RashRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '   ';
      WinCaption1 := ' 8';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := ' '+Q_GetDateStr(RsDate);
      FontSize := 20;
      FontBold := True;
      Cells[2,2] := '  ( )';
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(14,4,13+K,4,'0');
      ApplyNumberFormat(14,5,13+K,7,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(14,2,13+K,7);
      DrawRightLines(14,7,13+K,7);
      DrawBottomLines(14,2,13+K,7);
      CreateTable(V,14,2,False);
      if ProvMkCnt = 1 then
        Cells[9,2] := ': '+Providers.GetNameByNumber(ProvMarks^[0])
      else if ProvMkAll then
        Cells[9,2] := ' '
      else
      begin
        InsertRows(10,ProvMkCnt);
        FontBold := True;
        Cells[9,2] := ' :';
        FontBold := False;
        for I := 0 to ProvMkCnt-1 do
          Cells[10+I,2] := Providers.GetNameByNumber(ProvMarks^[I]);
      end;
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakePerRashNalRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldSumIn: Double;
    fldSumOut: Double;
  end;
var
  Kol: Double;
  ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
          if (Q_ScanInteger(InvoiceObj.ProvRef,ProvMarks,ProvMkCnt)<>-1) and
              (RashColl<>nil) then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              with RashObj do
              begin
                if (DateRash>=RgStart) and (DateRash<=RgEnd) and
                  (VidRash=trZaNalich) then
                begin
                  Kol := Kol + Kolvo;
                  SumIn := SumIn + Kolvo*IOsObj.CostIn;
                  SumOut := SumOut + Kolvo*IOsObj.CostOut;
                end;
              end;
            end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldKolvo := Kol;
          fldSumIn := SumIn;
          fldSumOut := SumOut;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('  ,   , ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,6], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldSumIn;
      V[K,5] := fldSumOut;
      V[K,6] := fldSumOut-fldSumIn;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItSumIn;
  V[K,5] := ItSumOut;
  V[K,6] := ItSumOut-ItSumIn;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+RashRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+RashRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := ' ,   ';
      WinCaption1 := ' 9';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := '   '+Q_GetDateStr(RgStart)+'  '+Q_GetDateStr(RgEnd);
      FontSize := 20;
      FontBold := True;
      Cells[2,2] := '  ()';
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(14,4,13+K,4,'0');
      ApplyNumberFormat(14,5,13+K,7,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(14,2,13+K,7);
      DrawRightLines(14,7,13+K,7);
      DrawBottomLines(14,2,13+K,7);
      CreateTable(V,14,2,False);
      if ProvMkCnt = 1 then
        Cells[9,2] := ': '+Providers.GetNameByNumber(ProvMarks^[0])
      else if ProvMkAll then
        Cells[9,2] := ' '
      else
      begin
        InsertRows(10,ProvMkCnt);
        FontBold := True;
        Cells[9,2] := ' :';
        FontBold := False;
        for I := 0 to ProvMkCnt-1 do
          Cells[10+I,2] := Providers.GetNameByNumber(ProvMarks^[I]);
      end;
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakePerRashReaRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldSumIn: Double;
    fldSumOut: Double;
  end;
var
  Kol: Double;
  ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
          if (Q_ScanInteger(InvoiceObj.ProvRef,ProvMarks,ProvMkCnt)<>-1) and
              (RashColl<>nil) then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              with RashObj do
              begin
                if (DateRash>=RgStart) and (DateRash<=RgEnd) and
                  (VidRash=trPodRealz) then
                begin
                  Kol := Kol + Kolvo;
                  SumIn := SumIn + Kolvo*IOsObj.CostIn;
                  SumOut := SumOut + Kolvo*IOsObj.CostOut;
                end;
              end;
            end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldKolvo := Kol;
          fldSumIn := SumIn;
          fldSumOut := SumOut;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('  ,   , ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,6], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldSumIn;
      V[K,5] := fldSumOut;
      V[K,6] := fldSumOut-fldSumIn;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItSumIn;
  V[K,5] := ItSumOut;
  V[K,6] := ItSumOut-ItSumIn;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+RashRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+RashRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := ' ,   ';
      WinCaption1 := ' 10';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := '   '+Q_GetDateStr(RgStart)+'  '+Q_GetDateStr(RgEnd);
      FontSize := 20;
      FontBold := True;
      Cells[2,2] := '  ()';
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(14,4,13+K,4,'0');
      ApplyNumberFormat(14,5,13+K,7,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(14,2,13+K,7);
      DrawRightLines(14,7,13+K,7);
      DrawBottomLines(14,2,13+K,7);
      CreateTable(V,14,2,False);
      if ProvMkCnt = 1 then
        Cells[9,2] := ': '+Providers.GetNameByNumber(ProvMarks^[0])
      else if ProvMkAll then
        Cells[9,2] := ' '
      else
      begin
        InsertRows(10,ProvMkCnt);
        FontBold := True;
        Cells[9,2] := ' :';
        FontBold := False;
        for I := 0 to ProvMkCnt-1 do
          Cells[10+I,2] := Providers.GetNameByNumber(ProvMarks^[I]);
      end;
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakePerRashAllRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldSumIn: Double;
    fldSumOut: Double;
  end;
var
  Kol: Double;
  ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
          if (Q_ScanInteger(InvoiceObj.ProvRef,ProvMarks,ProvMkCnt)<>-1) and
              (RashColl<>nil) then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              with RashObj do
              begin
                if (DateRash>=RgStart) and (DateRash<=RgEnd) and
                  (VidRash<>trWriteOff) then
                begin
                  Kol := Kol + Kolvo;
                  SumIn := SumIn + Kolvo*IOsObj.CostIn;
                  SumOut := SumOut + Kolvo*IOsObj.CostOut;
                end;
              end;
            end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldKolvo := Kol;
          fldSumIn := SumIn;
          fldSumOut := SumOut;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('    ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,6], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldSumIn;
      V[K,5] := fldSumOut;
      V[K,6] := fldSumOut-fldSumIn;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItSumIn;
  V[K,5] := ItSumOut;
  V[K,6] := ItSumOut-ItSumIn;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+RashRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+RashRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '  ( )';
      WinCaption1 := ' 11';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := '   '+Q_GetDateStr(RgStart)+'  '+Q_GetDateStr(RgEnd);
      FontSize := 20;
      FontBold := True;
      Cells[2,2] := ' ';
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(14,4,13+K,4,'0');
      ApplyNumberFormat(14,5,13+K,7,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(14,2,13+K,7);
      DrawRightLines(14,7,13+K,7);
      DrawBottomLines(14,2,13+K,7);
      CreateTable(V,14,2,False);
      if ProvMkCnt = 1 then
        Cells[9,2] := ': '+Providers.GetNameByNumber(ProvMarks^[0])
      else if ProvMkAll then
        Cells[9,2] := ' '
      else
      begin
        InsertRows(10,ProvMkCnt);
        FontBold := True;
        Cells[9,2] := ' :';
        FontBold := False;
        for I := 0 to ProvMkCnt-1 do
          Cells[10+I,2] := Providers.GetNameByNumber(ProvMarks^[I]);
      end;
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakeDaySpisRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldSumIn: Double;
    fldSumOut: Double;
  end;
var
  Kol: Double;
  ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
          if (Q_ScanInteger(InvoiceObj.ProvRef,ProvMarks,ProvMkCnt)<>-1) and
              (RashColl<>nil) then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              with RashObj do
              begin
                if (DateRash=RsDate) and (VidRash=trWriteOff) then
                begin
                  Kol := Kol + Kolvo;
                  SumIn := SumIn + Kolvo*IOsObj.CostIn;
                  SumOut := SumOut + Kolvo*IOsObj.CostOut;
                end;
              end;
            end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldKolvo := Kol;
          fldSumIn := SumIn;
          fldSumOut := SumOut;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('     ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,6], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldSumIn;
      V[K,5] := fldSumOut;
      V[K,6] := fldSumOut-fldSumIn;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItSumIn;
  V[K,5] := ItSumOut;
  V[K,6] := ItSumOut-ItSumIn;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+SpisRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+SpisRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '   ';
      WinCaption1 := ' 12';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := ' '+Q_GetDateStr(RsDate);
      FontBold := True;
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(14,4,13+K,4,'0');
      ApplyNumberFormat(14,5,13+K,7,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(14,2,13+K,7);
      DrawRightLines(14,7,13+K,7);
      DrawBottomLines(14,2,13+K,7);
      CreateTable(V,14,2,False);
      if ProvMkCnt = 1 then
        Cells[9,2] := ': '+Providers.GetNameByNumber(ProvMarks^[0])
      else if ProvMkAll then
        Cells[9,2] := ' '
      else
      begin
        InsertRows(10,ProvMkCnt);
        FontBold := True;
        Cells[9,2] := ' :';
        FontBold := False;
        for I := 0 to ProvMkCnt-1 do
          Cells[10+I,2] := Providers.GetNameByNumber(ProvMarks^[I]);
      end;
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakePerSpisRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldSumIn: Double;
    fldSumOut: Double;
  end;
var
  Kol: Double;
  ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  RashObj: TRashObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
          if (Q_ScanInteger(InvoiceObj.ProvRef,ProvMarks,ProvMkCnt)<>-1) and
              (RashColl<>nil) then
            for K := 0 to RashColl.Count-1 do
            begin
              RashObj := RashColl.List^[K];
              with RashObj do
              begin
                if (DateRash>=RgStart) and (DateRash<=RgEnd) and
                  (VidRash=trWriteOff) then
                begin
                  Kol := Kol + Kolvo;
                  SumIn := SumIn + Kolvo*IOsObj.CostIn;
                  SumOut := SumOut + Kolvo*IOsObj.CostOut;
                end;
              end;
            end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldKolvo := Kol;
          fldSumIn := SumIn;
          fldSumOut := SumOut;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('     ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,6], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldSumIn;
      V[K,5] := fldSumOut;
      V[K,6] := fldSumOut-fldSumIn;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItSumIn;
  V[K,5] := ItSumOut;
  V[K,6] := ItSumOut-ItSumIn;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+SpisRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+SpisRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '    ';
      WinCaption1 := ' 13';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := '   '+Q_GetDateStr(RgStart)+'  '+Q_GetDateStr(RgEnd);
      FontBold := True;
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(14,4,13+K,4,'0');
      ApplyNumberFormat(14,5,13+K,7,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(14,2,13+K,7);
      DrawRightLines(14,7,13+K,7);
      DrawBottomLines(14,2,13+K,7);
      CreateTable(V,14,2,False);
      if ProvMkCnt = 1 then
        Cells[9,2] := ': '+Providers.GetNameByNumber(ProvMarks^[0])
      else if ProvMkAll then
        Cells[9,2] := ' '
      else
      begin
        InsertRows(10,ProvMkCnt);
        FontBold := True;
        Cells[9,2] := ' :';
        FontBold := False;
        for I := 0 to ProvMkCnt-1 do
          Cells[10+I,2] := Providers.GetNameByNumber(ProvMarks^[I]);
      end;
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakeTovNalRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldSumIn: Double;
    fldSumOut: Double;
  end;
var
  Kol,K2: Double;
  ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
          if (TypeOfPay=tpNalich) and
            (Q_ScanInteger(InvoiceObj.ProvRef,ProvMarks,ProvMkCnt)<>-1) then
          begin
            K2 := Kolvo;
            if RashColl <> nil then
              for K := 0 to RashColl.Count-1 do
                K2 := K2-TRashObj(RashColl.List^[K]).Kolvo;
            Kol := Kol+K2;
            SumIn := SumIn+K2*CostIn;
            SumOut := SumOut+K2*CostOut;
          end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldKolvo := Kol;
          fldSumIn := SumIn;
          fldSumOut := SumOut;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('    ,   , ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,7], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldSumIn;
      V[K,5] := fldSumOut;
      V[K,6] := fldSumOut-fldSumIn;
      V[K,7] := (fldSumOut-fldSumIn)/fldSumIn*100;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItSumIn;
  V[K,5] := ItSumOut;
  V[K,6] := ItSumOut-ItSumIn;
  V[K,7] := (ItSumOut-ItSumIn)/ItSumIn*100;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+NalcRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+NalcRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '   ,   ';
      WinCaption1 := ' 14';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := ' '+Q_GetDateStr(RsDate);
      FontSize := 20;
      FontBold := True;
      Cells[2,2] := '  (  )';
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(14,4,13+K,4,'0');
      ApplyNumberFormat(14,5,13+K,8,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(14,2,13+K,8);
      DrawRightLines(14,8,13+K,8);
      DrawBottomLines(14,2,13+K,8);
      CreateTable(V,14,2,False);
      if ProvMkCnt = 1 then
        Cells[9,2] := ': '+Providers.GetNameByNumber(ProvMarks^[0])
      else if ProvMkAll then
        Cells[9,2] := ' '
      else
      begin
        InsertRows(10,ProvMkCnt);
        FontBold := True;
        Cells[9,2] := ' :';
        FontBold := False;
        for I := 0 to ProvMkCnt-1 do
          Cells[10+I,2] := Providers.GetNameByNumber(ProvMarks^[I]);
      end;
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakeTovReaRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldSumIn: Double;
    fldSumOut: Double;
  end;
var
  Kol,K2: Double;
  ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
          if (TypeOfPay=tpRealiz) and
            (Q_ScanInteger(InvoiceObj.ProvRef,ProvMarks,ProvMkCnt)<>-1) then
          begin
            K2 := Kolvo;
            if RashColl <> nil then
              for K := 0 to RashColl.Count-1 do
                K2 := K2-TRashObj(RashColl.List^[K]).Kolvo;
            Kol := Kol+K2;
            SumIn := SumIn+K2*CostIn;
            SumOut := SumOut+K2*CostOut;
          end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldKolvo := Kol;
          fldSumIn := SumIn;
          fldSumOut := SumOut;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('    ,   , ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,7], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldSumIn;
      V[K,5] := fldSumOut;
      V[K,6] := fldSumOut-fldSumIn;
      V[K,7] := (fldSumOut-fldSumIn)/fldSumIn*100;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItSumIn;
  V[K,5] := ItSumOut;
  V[K,6] := ItSumOut-ItSumIn;
  V[K,7] := (ItSumOut-ItSumIn)/ItSumIn*100;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+NalcRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+NalcRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '   ,   ';
      WinCaption1 := ' 15';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := ' '+Q_GetDateStr(RsDate);
      FontSize := 20;
      FontBold := True;
      Cells[2,2] := '  (  )';
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(14,4,13+K,4,'0');
      ApplyNumberFormat(14,5,13+K,8,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(14,2,13+K,8);
      DrawRightLines(14,8,13+K,8);
      DrawBottomLines(14,2,13+K,8);
      CreateTable(V,14,2,False);
      if ProvMkCnt = 1 then
        Cells[9,2] := ': '+Providers.GetNameByNumber(ProvMarks^[0])
      else if ProvMkAll then
        Cells[9,2] := ' '
      else
      begin
        InsertRows(10,ProvMkCnt);
        FontBold := True;
        Cells[9,2] := ' :';
        FontBold := False;
        for I := 0 to ProvMkCnt-1 do
          Cells[10+I,2] := Providers.GetNameByNumber(ProvMarks^[I]);
      end;
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakeTovAllRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldKolvo: Double;
    fldSumIn: Double;
    fldSumOut: Double;
  end;
var
  Kol,K2: Double;
  ItSumIn,ItSumOut: Double;
  SumIn,SumOut: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  ItSumIn := 0;
  ItSumOut := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      IOsColl.UpdateLink(Invoices_Link,Invoices);
      Kol := 0;
      SumIn := 0;
      SumOut := 0;
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        with IOsObj do
          if Q_ScanInteger(InvoiceObj.ProvRef,ProvMarks,ProvMkCnt) <> -1 then
          begin
            K2 := Kolvo;
            if RashColl <> nil then
              for K := 0 to RashColl.Count-1 do
                K2 := K2-TRashObj(RashColl.List^[K]).Kolvo;
            Kol := Kol+K2;
            SumIn := SumIn+K2*CostIn;
            SumOut := SumOut+K2*CostOut;
          end;
      end;
      if Kol <> 0 then
      begin
        Inc(N);
        GetMem(LR,SizeOf(TLineRec));
        with LR^ do
        begin
          fldNumber := N;
          Pointer(fldName) := nil;
          fldName := ArtObj.Name;
          fldKolvo := Kol;
          fldSumIn := SumIn;
          fldSumOut := SumOut;
          ItSumIn := ItSumIn+SumIn;
          ItSumOut := ItSumOut+SumOut;
        end;
        Lines.Add(LR);
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('      ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count+1,1,7], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldKolvo;
      V[K,4] := fldSumIn;
      V[K,5] := fldSumOut;
      V[K,6] := fldSumOut-fldSumIn;
      V[K,7] := (fldSumOut-fldSumIn)/fldSumIn*100;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count+1;
  Lines.Clear;
  FreeAndNil(Lines);
  V[K,2] := '   :';
  V[K,4] := ItSumIn;
  V[K,5] := ItSumOut;
  V[K,6] := ItSumOut-ItSumIn;
  V[K,7] := (ItSumOut-ItSumIn)/ItSumIn*100;
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+NalcRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+NalcRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '    ( )';
      WinCaption1 := ' 16';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := ' '+Q_GetDateStr(RsDate);
      FontBold := True;
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(14,4,13+K,4,'0');
      ApplyNumberFormat(14,5,13+K,8,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(14,2,13+K,8);
      DrawRightLines(14,8,13+K,8);
      DrawBottomLines(14,2,13+K,8);
      CreateTable(V,14,2,False);
      if ProvMkCnt = 1 then
        Cells[9,2] := ': '+Providers.GetNameByNumber(ProvMarks^[0])
      else if ProvMkAll then
        Cells[9,2] := ' '
      else
      begin
        InsertRows(10,ProvMkCnt);
        FontBold := True;
        Cells[9,2] := ' :';
        FontBold := False;
        for I := 0 to ProvMkCnt-1 do
          Cells[10+I,2] := Providers.GetNameByNumber(ProvMarks^[I]);
      end;
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakeOffVedRpt;
type
  PLineRec = ^TLineRec;
  TLineRec = record
    fldNumber: Integer;
    fldName: string;
    fldCostIn: Double;
    fldCostOut: Double;
  end;
var
  Kol: Double;
  I,J,K,N: Integer;
  Lines: TVCollection;
  LR: PLineRec;
  ArtObj: TArticleObj;
  IOsColl: TIOsColl;
  IOsObj: TIOsObj;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  Lines := TVCollection.Create;
  Lines.Capacity := Articles.Count;
  N := 0;
  for I := 0 to Articles.Count-1 do
  begin
    ArtObj := Articles.List^[I];
    IOsColl := TIOsColl(Stg.Get(ArtObj.Number));
    if IOsColl <> nil then
    begin
      for J := 0 to IOsColl.Count-1 do
      begin
        IOsObj := IOsColl.List^[J];
        Kol := 0;
        with IOsObj do
        begin
          Kol := Kol+Kolvo;
          if RashColl <> nil then
            for K := 0 to RashColl.Count-1 do
              Kol := Kol-TRashObj(RashColl.List^[K]).Kolvo;
        end;
        if Kol = 0 then
        begin
          Inc(N);
          GetMem(LR,SizeOf(TLineRec));
          with LR^ do
          begin
            fldNumber := N;
            Pointer(fldName) := nil;
            fldName := ArtObj.Name;
            fldCostIn := IOsObj.CostIn;
            fldCostOut := IOsObj.CostOut;
          end;
          Lines.Add(LR);
        end;
      end;
      IOsColl.Free;
    end;
  end;
  if Lines.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('   ');
    FreeAndNil(Lines);
    Exit;
  end;
  V := VarArrayCreate([1,Lines.Count,1,4], varVariant);
  for I := 0 to Lines.Count-1 do
  begin
    K := I+1;
    LR := Lines.List^[I];
    with LR^ do
    begin
      V[K,1] := fldNumber;
      V[K,2] := fldName;
      V[K,3] := fldCostIn;
      V[K,4] := fldCostOut;
    end;
    Finalize(PLineRec(Lines.List^[I])^);
    FreeMem(Lines.List^[I]);
  end;
  K := Lines.Count;
  Lines.Clear;
  FreeAndNil(Lines);
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+OffVRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+OffVRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '  ';
      WinCaption1 := ' 17';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := ' '+Q_GetDateStr(RsDate);
      FontBold := True;
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(12,4,11+K,5,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(12,2,11+K,5);
      DrawRightLines(12,5,11+K,5);
      DrawBottomLines(12,2,11+K,5);
      CreateTable(V,12,2,False);
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

procedure MakeInvoiceRpt;
var
  SmSum: Double;
  D: Double;
  ArtRec: PArtRec;
  IOsColl: TIOsColl;
  AIOsObj: TIOsObj;
  OneInv: TInvoiceObj;
  TovCount: Integer;
  I,J,K: Integer;
  V: Variant;
begin
  with WaitForm do
  begin
    Show;
    Update;
  end;
  OneInv := Invoices.List^[SelInvInd];
  if OneInv.InvArtSet <> nil then
  begin
    TovCount := OneInv.InvArtSet.Count;
    GetMem(IndexArr,TovCount*SizeOf(TArtIndex));
    with OneInv.InvArtSet do
      for I := 0 to Count-1 do
      begin
        IndexArr^[I].Number := List^[I];
        IndexArr^[I].Index := Articles.SearchNumberIndex(List^[I]);
      end;
    if TovCount > 1 then
      TovQuickSort(0,TovCount-1);
  end else
  begin
    IndexArr := nil;
    TovCount := 0;
  end;
  ArtColl := TVCollection.Create;
  ArtColl.Capacity := TovCount;
  for I := 0 to TovCount-1 do
  begin
    IOsColl := TIOsColl(Stg.Get(IndexArr^[I].Number));
    if IOsColl <> nil then
    begin
      IOsColl.SwitchToIndex(IndexBy_TovarRec);
      for J := 0 to IOsColl.Count-1 do
      begin
        AIOsObj := IOsColl.List^[J];
        if AIOsObj.InvoiceRef = OneInv.Number then
        begin
          GetMem(ArtRec,SizeOf(TArtRec));
          with ArtRec^ do
          begin
            TovNum := IndexArr^[I].Number;
            IOsObj := TIOsObj(AIOsObj.Clone);
          end;
          ArtColl.Add(ArtRec);
        end;
      end;
    end;
    FreeAndNil(IOsColl);
  end;
  FreeMem(IndexArr);
  IndexArr := nil;
  if ArtColl.Count = 0 then
  begin
    WaitForm.Hide;
    Msg('        ');
    ClearArtColl;
    FreeAndNil(ArtColl);
    Exit;
  end;
  V := VarArrayCreate([1,ArtColl.Count+1,1,5],varVariant);
  K := 0;
  SmSum := 0;
  for I := 0 to ArtColl.Count-1 do
  begin
    Inc(K);
    ArtRec := ArtColl.List^[I];
    with ArtRec^ do
    begin
      V[K,1] := K;
      V[K,2] := Articles.GetNameByNumber(TovNum);
      V[K,3] := IOsObj.Kolvo;
      V[K,4] := IOsObj.CostOut;
      D := IOsObj.Kolvo*IOsObj.CostOut;
      V[K,5] := D;
      SmSum := SmSum+D;
    end;
  end;
  Inc(K);
  V[K,2] := '  :';
  V[K,5] := SmSum;
  ClearArtColl;
  FreeAndNil(ArtColl);
  if Rpt <> nil then
    Rpt.OpenNewFile(ReportsPath+MInvRptFN)
  else
    Rpt := TExcelReport.OpenFile(ReportsPath+MInvRptFN);
  if Rpt.ExcelWasFound then
    with Rpt do
    begin
      DisplayGridLines := False;
      DisplayPageBreaks := False;
      DisplayZeros := False;
      WinCaption2 := '  ';
      WinCaption1 := ' 18';
      Cells[1,2] := FormatDateTime('dd.mm.yyyy',Now);
      Cells[5,2] := Q_GetDateStr(RsDate);
      FontBold := True;
      FontSize := 18;
      Cells[2,2] := ' '+Q_IntToStr(OneInv.OrdNum);
      FontSize := 12;
      Cells[7,2] := ' '+Shops.GetNameByNumber(CurrShopNum);
      FontBold := False;
      FontSize := 10;
      ApplyNumberFormat(12,4,11+K,4,'0');
      ApplyNumberFormat(12,5,11+K,6,'0,00');
      BordersWeight := xlThin;
      DrawLeftLines(12,2,11+K,6);
      DrawRightLines(12,6,11+K,6);
      DrawBottomLines(12,2,11+K,6);
      CreateTable(V,12,2,False);
      Cells[14+K,3] := ' ____________________';
      Cells[14+K,4] := ' ______________________';
      ProtectSheet('');
      ToggleScrollLockOn;
      Visible := True;
    end;
  WaitForm.Hide;
end;

initialization

finalization
  ToggleScrollLockOff;
  FreeAndNil(Rpt);

end.

