unit LayoutManagerEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TwoColsEditor, Menus, ImgList, StdCtrls, Buttons, ExtCtrls;

type
  TFormLayoutManagerEditor = class(TFormTwoColsEditor)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  protected
    function GetOwnerOfRigthItem (RigthItem : TcollectionItem) : TCollectionItem; override;
    function CollectionLeft : TCollection; override;
    function CollectionRigth : TCollection; override;
  public
    { Public declarations }
  end;

var
  FormLayoutManagerEditor: TFormLayoutManagerEditor;

implementation

uses
  LayoutManager;

{$R *.DFM}

function TFormLayoutManagerEditor.GetOwnerOfRigthItem (RigthItem : TcollectionItem) : TCollectionItem;
begin
  Result := (RigthItem as TLayoutParameter).Collection.LayoutItem;
end;

function TFormLayoutManagerEditor.CollectionLeft : TCollection;
begin
  Result := (component as TLayoutManager).LayoutItems;
end;

function TFormLayoutManagerEditor.CollectionRigth : TCollection;
begin
  if (ListBoxLeft.ItemIndex >= 0) and (ListBoxLeft.Items.Count > 0)
    then Result := (ListBoxLeft.Items.Objects [ListBoxLeft.ItemIndex] as TLayoutItem).Parameters
    else Result := nil
end;

procedure TFormLayoutManagerEditor.FormCreate(Sender: TObject);
begin
  LeftItemClass := TLayoutItem;
  RigthItemclass := TLayoutParameter;
  inherited;
end;

end.
