{
 Project UML Component Factory
 Unit ElementTest.pas

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with the
 License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 the specific language governing rights and limitations under the License.

 The Original Code is ElementTest.pas

 The Initial Developer of the Original Code is Thierry.Coq
 Portions created by this individual are Copyright (C)
 2000 of this individual.

 Last modified: 25 oct 2000
 Version 0.0

 purpose :
 ElementTest is here to show how to use the Dynamic Element Library in order
 to load packages dynamically and use the objects contained in those packages.
 The class ElementTest provides the minimum required services to link to an
 calling application.
}
unit ElementTest;

interface

uses ShareMem, Classes, DynamicLibraryElement, Dialogs;

type
  TElementTest = class( TDynamicLibraryElement)
  public
    constructor Create( anOwner : TComponent); override;
    destructor Destroy; override;
    procedure Execute; override;
    class function GetDescription: String; override;
    class function GetHelp : String; override;
    class function GetCommandText: String; override;
  end;

  TElementTestClass = class of TElementTest;

Procedure InitialiseUnitElements( aManager : TDLEManager);

implementation

uses SysUtils, Forms;
{ TModuleTest }

constructor TElementTest.Create(anOwner: TComponent);
begin
  inherited;
end;

destructor TElementTest.Destroy;
begin
  ShowMessage( 'Destroying TElementTest');
  inherited;
end;

procedure TElementTest.Execute;
begin
  inherited;
  ShowMessage( 'First Test Element is executed now!');
end;

Procedure InitialiseUnitElements( aManager : TDLEManager);
begin
  if assigned( aManager) then
    aManager.AddElement( TElementTest);
end;

class function TElementTest.GetCommandText: String;
begin
  result := 'Module Test';
end;

class function TElementTest.GetDescription: String;
begin
 result := '"Element Test is a small reusable component",'+
    '"that can be dynamically loaded and executed from its package"';
end;

class function TElementTest.GetHelp: String;
begin
  result := 'Small Test Module| with lots of help';
end;

end.
