{
 Project UML Component Factory
 Unit ElementTest2.pas

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with the
 License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 the specific language governing rights and limitations under the License.

 The Original Code is ElementTest2.pas

 The Initial Developer of the Original Code is Thierry.Coq
 Portions created by this individual are Copyright (C)
 2000 of this individual.

 Last modified: 25 oct 2000
 Version 0.0

 purpose :
 ElementTest2 is for the same purpose as ElementTest. See ElementTest.pas for
 details.
}
unit ElementTest2;

interface

uses ShareMem, Classes, DynamicLibraryElement;

type
  TTest2 = class( TDynamicLibraryElement)
  public
    destructor Destroy; override;
    procedure Execute; override;
    class function GetDescription: String; override;
    class function GetHelp : String; override;
    class function GetCommandText: String; override;
  end;

Procedure InitialiseUnitElements( aManager : TDLEManager);

implementation

uses SysUtils,Dialogs;

Procedure InitialiseUnitElements( aManager : TDLEManager);
begin
  aManager.AddElement( TTest2);
end;


{ TTest2 }

destructor TTest2.Destroy;
begin
  ShowMessage( 'Destroying TTest2');
  inherited;
end;

procedure TTest2.Execute;
begin
  inherited;
  ShowMessage( 'Test2 Element is executed now!');
end;

class function TTest2.GetCommandText: String;
begin
  result := '';
end;

class function TTest2.GetDescription: String;
begin
  result := '"Element Test2 is another small reusable component",'+
    '"that can be dynamically loaded and executed from its package",'+
    '"Both are intended as templates for your own reusable elements."' ;
end;

class function TTest2.GetHelp: String;
begin
  result := '';
end;

end.
