library PlugDemo;

uses
  ShareMem, SysUtils, Windows, dwsComp;

{$R *.RES}

type
  // Declare the plugin functions
  TPlugDemoFunc = class (TFunction) 
    function Evaluate (argpat : Integer; Args : TArgList) : Variant; override; 
  end;


procedure Load(Script: TDelphiWebScript);
begin
  // Register function in TDelphiWebScript
  Script.AddFunction(TPlugDemoFunc.CreateArg('PlugDemo', atString, [atString]));

  // Register a constant in TDelphiWebScript
  Script.SetGlobalConst('PlugDemoConst', 'Hello, I''m PlugDemo.dll!');  
end;

procedure Unload(Script: TDelphiWebScript);
begin
  // Functions are automatically deregistred!!
  
  // Deregister a constant from TDelphiWebScript
  Script.DeleteGlobal('PlugDemoConst');  
end;

function Info: string;
begin
  Result := 
    'Title=Demo Plugin for DelphiWebScript'#13#10 + 
    'Version=1.0'#13#10 + 
    'Author=Matthias Ackermann'#13#10;
end;

exports
  Info, Load, Unload;

{ TTestFunc }

function TPlugDemoFunc.Evaluate;
begin
  Result := 'Hello ' + args[0].Eval + '!';
end;

begin
end.
 