library PlugSmtp;

uses
  ShareMem, SysUtils, Forms, dwsComp, NMsmtp;

{$R *.RES}

type
  TSendMailFunc = class (TFunction) 
    function Evaluate (argpat : Integer; Args : TArgList) : Variant; override; 
  end;


procedure Load(Script: TDelphiWebScript);
begin
  Script.AddFunction(TSendMailFunc.CreateArg('SendMail', atVoid, [atString, atString, atString, atString, atString]));
end;

function Info: string;
begin
  Result := 
    'Title=SMTP Plugin for DelphiWebScript'#13#10 + 
    'VERSION=1.0'#13#10 + 
    'Author=Matthias Ackermann'#13#10;
end;

exports
  Info, Load;

{ TTestFunc }

function TSendMailFunc.Evaluate;
var
  smtp: TNMSMTP;
begin
  try
    smtp := TNMSmtp.Create(Application);
    try
      smtp.Host := TExpr(args[0]).Eval;
      smtp.UserId := '';
      smtp.Connect;
      smtp.PostMessage.LocalProgram := 'DelphiWebScript ' + FScript.Version + ' SMTP Plugin';
      smtp.PostMessage.Date := FormatDateTime('c', Now);
      smtp.PostMessage.FromAddress := TExpr(args[1]).Eval;
      smtp.PostMessage.ToAddress.Add(TExpr(args[2]).Eval);
      smtp.PostMessage.Subject := TExpr(args[3]).Eval;
      smtp.PostMessage.Body.Text := TExpr(args[4]).Eval;
      smtp.SendMail;
      smtp.Disconnect;
    finally
      smtp.Free;
    end;
  except
  end;
end;

begin
end.
 