{ This is meant to be used only at design time by the TPropsSaver editor form }

unit PropsSaverDsgnColTranslator;

interface

uses
  PropsSaver;

function PropCollectionToString (Obj : TObject; PropItem : TPropInfoItem) : string;
procedure StringToPropCollection (const s : string; Obj : TObject; PropItem : TPropInfoItem);

implementation

uses
  Classes, PropsSaverBasicClassTranslators;

function PropCollectionToString;
var
  i : Integer;
  ColItems : TStringList;
  ItemProps : TStringList;
begin
  if Obj <> nil
    then
    begin
      colItems := TStringList.Create;
      try
        with Obj as TCollection do
          begin
            for i := 0 to Count - 1 do
              with Items [i] as TPropInfoItem do
                begin
                  ItemProps := TStringList.Create;
                  try
                    ItemProps.Add ('PropertyName=' + GetProperty (Items [i], 'PropertyName'));
                    ItemProps.Add ('PropertyType=' + GetProperty (Items [i], 'PropertyType'));
                    ItemProps.Add ('IfClassStoreAsLink=' + GetProperty (Items [i], 'IfClassStoreAsLink'));
                    ItemProps.Add ('Mode=' + GetProperty (Items [i], 'Mode'));
                    ItemProps.Add ('Encrypted=' + GetProperty (Items [i], 'Encrypted'));
                    if SubProperties.Count > 0
                      then ItemProps.Add ('SubProperties=' + PropCollectionToString (SubProperties, PropItem));
                    ColItems.Add ('<' + ItemProps.CommaText + '>');
                  finally
                    ItemProps.Free;
                  end;
                end;
          end;
        Result := ColItems.CommaText;
      finally
        colItems.Free;
      end;
    end;
end;

procedure StringToPropCollection;
var
  i, j : Integer;
  ColItems : TStringList;
  ItemProps : TStringList;
  Item : TPropInfoItem;
begin
  if Obj <> nil
    then
    begin
      colItems := TStringList.Create;
      try
        ColItems.CommaText := s;
        with Obj as TCollection do
          begin
            Clear;
            for i := 0 to ColItems.Count - 1 do
              begin
                Item := Add as TPropInfoItem;
                try
                  ItemProps := TStringList.Create;
                  try
                    ItemProps.CommaText := Copy (ColItems [i], 2, Length (ColItems [i]) - 2);
                    for j := 0 to ItemProps.Count - 1 do
                      if ItemProps.Names [j] <> 'SubProperties'
                        then SetProperty (Item, ItemProps.Names [j], ItemProps.Values [ItemProps.Names [j]])
                        else StringToPropCollection (ItemProps.Values ['SubProperties'], Item.SubProperties, PropItem);
                  finally
                    ItemProps.Free;
                  end;
                except
                  Item.Free;
                  raise;
                end;
              end;
          end;
      finally
        colItems.Free;
      end;
    end;
end;

end.
