unit PropsSaverEditorWizzardName;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFormPropertiesWizzardName = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    EditSetName: TEdit;
    ButtonOk: TButton;
    ButtonCancel: TButton;
    Label3: TLabel;
    ListBoxBaseClasses: TListBox;
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure ListBoxBaseClassesDblClick(Sender: TObject);
  private
    FObj : TObject;
  public
    property Obj : TObject read FObj Write FObj;
  end;

var
  FormPropertiesWizzardName: TFormPropertiesWizzardName;

implementation

resourcestring
  MSG_NoName = 'You have to write a name before continuing';

{$R *.DFM}

procedure TFormPropertiesWizzardName.ButtonCancelClick(Sender: TObject);
begin
  Close;
  ModalResult := mrCancel;
end;

procedure TFormPropertiesWizzardName.ButtonOkClick(Sender: TObject);
begin
  Close;
  ModalResult := mrOk;
end;

procedure TFormPropertiesWizzardName.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if (ModalResult = mrOk) and (Trim (EditSetName.Text) = '')
    then
    begin
      MessageDlg (MSG_NoName, mtError, [mbOk], 0);
      EditSetName.SetFocus;
      CanClose := False;
    end;
end;

procedure TFormPropertiesWizzardName.FormKeyPress(Sender: TObject;
  var Key: Char);
begin
  case Key of
    #13 : ButtonOk.Click;
    #27 : ButtonCancel.Click;
  end;
  if Key in [#13, #27]
    then Key := #0;
end;

procedure TFormPropertiesWizzardName.FormShow(Sender: TObject);
  procedure AddBaseClass (cl : TClass);
  begin
    ListBoxBaseClasses.Items.Add (cl.ClassName);
    if cl.ClassParent <> nil
      then AddBaseClass (cl.ClassParent);
  end;
begin
  AddBaseClass (Obj.ClassType);
  ListBoxBaseClasses.ItemIndex := 0;
end;

procedure TFormPropertiesWizzardName.ListBoxBaseClassesDblClick(
  Sender: TObject);
begin
  ButtonOk.Click;
end;

end.
