unit PropsSaverFrameWizzards;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type
  TFramePropertiesWizzards = class(TFrame)
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    ListViewWizzards: TListView;
    ListViewBaseClass: TListView;
    procedure ListViewBaseClassClick(Sender: TObject);
  private
    FObj : TObject;
    FBaseKey : string;
    procedure SetObj (aObj : TObject);
    procedure FillClasses;
  public
    property Obj : TObject read FObj Write SetObj;
    property BaseKey : string read FBaseKey Write FBaseKey;
  end;

implementation

uses
  Registry;

{$R *.DFM}

procedure TFramePropertiesWizzards.SetObj;
begin
  FObj := aObj;
  FillClasses;
end;

procedure TFramePropertiesWizzards.FillClasses;
var
  Reg : TRegistry;
  Keys : TStringList;
  i : integer;
  procedure CheckBaseClass (cl : TClass);
  begin
    if Reg.OpenKey (BaseKey + '\Wizzards\' + cl.ClassName, False)
      then with ListViewBaseClass.Items.Add do
        Caption := cl.ClassName;
    if cl.ClassParent <> nil
      then CheckBaseClass (cl.ClassParent);
  end;
begin
  Reg := TRegistry.Create;
  try
    if Obj <> nil
      then CheckBaseClass (Obj.ClassType)
      else
      begin
        if Reg.OpenKey (BaseKey + '\Wizzards\', False)
          then
          begin
            Keys := TStringList.Create;
            try
              Reg.GetKeyNames (Keys);
              for i := 0 to Keys.Count - 1 do
                with ListViewBaseClass.Items.Add do
                  Caption := Keys [i];
            finally
              Keys.Free;
            end;
          end;
      end;
    if ListViewBaseClass.Items.Count > 0
      then
      begin
        ListViewBaseClass.Selected := ListViewBaseClass.Items [0];
        ListviewBaseClassClick (nil);
      end;
  finally
    Reg.Free;
  end;
end;

procedure TFramePropertiesWizzards.ListViewBaseClassClick(Sender: TObject);
var
  Reg : TRegistry;
  Keys : TStringList;
  i : integer;
begin
  if ListViewBaseClass.Selected = nil
    then Exit;
  Reg := TRegistry.Create;
  try
    ListViewWizzards.Items.Clear;
    if Reg.OpenKey (BaseKey + '\Wizzards\' + ListViewBaseClass.Selected.Caption, False)
      then
      begin
        Keys := TstringList.Create;
        try
          reg.GetKeyNames (Keys);
          for i := 0 to Keys.Count - 1 do
            with ListViewWizzards.Items.Add do
              Caption := Keys [i];
        finally
          Keys.Free;
        end;
      end;
    if ListViewWizzards.Items.Count > 0
      then ListViewWizzards.Selected := ListViewWizzards.Items [0];
  finally
    Reg.Free;
  end;
end;

end.
