unit PropsSaverWizSetsList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, PropsSaverFrameWizzards;

type
  TFormWizSetList = class(TForm)
    Panel1: TPanel;
    ButtonOk: TButton;
    ButtonCancel: TButton;
    FramePropertiesWizzards: TFramePropertiesWizzards;
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListViewWizzardsDblClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    FObj : TObject;
    FBaseKey : string;
    procedure SetObj (aObj : TObject);
    procedure SetBaseKey (const AKey : string);
  public
    property Obj : TObject read FObj Write SetObj;
    property BaseKey : string read FBaseKey Write SetBaseKey;
  end;

var
  FormWizSetList: TFormWizSetList;

implementation

uses
  Registry;

{$R *.DFM}

procedure TFormWizSetList.ButtonCancelClick(Sender: TObject);
begin
  Close;
  ModalResult := mrCancel;
end;

procedure TFormWizSetList.ButtonOkClick(Sender: TObject);
begin
  Close;
  ModalResult := mrOk;
end;

procedure TFormWizSetList.FormShow(Sender: TObject);
begin
  FramePropertiesWizzards.ListViewWizzards.Selected := FramePropertiesWizzards.ListViewWizzards.Items [0];
end;

procedure TFormWizSetList.ListViewWizzardsDblClick(Sender: TObject);
begin
  ButtonOk.Click;
end;

procedure TFormWizSetList.FormKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
    #13 : ButtonOk.Click;
    #27 : ButtonCancel.Click;
  end;
  if Key in [#13, #27]
    then Key := #0;
end;

procedure TFormWizSetList.SetObj;
begin
  FObj := aObj;
  FramePropertiesWizzards.Obj := aObj;
end;

procedure TformWizSetList.SetBaseKey;
begin
  FBaseKey := AKey;
  FramePropertiesWizzards.BaseKey := AKey;
end;

end.
