unit MainUn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    Button1: TButton;
    StatusBar: TStatusBar;
    btnClose: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    procedure AppIdle(Sender: TObject; var Done: Boolean);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses QMemory;

{$R *.DFM}

var
  A: array[1..10000] of Pointer;

  StdAllocSize: Integer = 0;
  IsStdManager: Boolean = False;

procedure TMainForm.AppIdle(Sender: TObject; var Done: Boolean);
begin
  QMemCompact;
  StatusBar.Panels[0].Text := 'QMemTotalAllocated = '+IntToStr(QMemTotalAllocated);
  StatusBar.Panels[1].Text := 'System.AllocMemSize = '+IntToStr(StdAllocSize);
end;

const
  StdManager: TMemoryManager = (
    GetMem: SysGetMem;
    FreeMem: SysFreeMem;
    ReallocMem: SysReallocMem);
var
  QMemManager: TMemoryManager;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  GetMemoryManager(QMemManager);
  Application.OnIdle := AppIdle;
  Randomize;
end;

procedure TMainForm.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.RadioButton1Click(Sender: TObject);
begin
  IsStdManager := False;
end;

procedure TMainForm.RadioButton2Click(Sender: TObject);
begin
  IsStdManager := True;
end;

procedure TMainForm.Button1Click(Sender: TObject);
var
  I,J: Integer;
  D: LongWord;
begin
  if IsStdManager then
    SetMemoryManager(StdManager);
  FillChar(A,SizeOf(A),0);
  D := GetTickCount;
  for I := 1 to 100 do
    for J := 1 to 10000 do
    begin
      FreeMem(A[J]);
      GetMem(A[J],Random(10)+1);
    end;
  D := GetTickCount-D;
  if IsStdManager then
  begin
    StdAllocSize := AllocMemSize;
    SetMemoryManager(QMemManager);
  end;
  ShowMessage('Array filled in '+IntToStr(D)+' ms');
  for J := 1 to 10000 do
    FreeMem(A[J]);
  StdAllocSize := 0;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var
  I,J: Integer;
  D: LongWord;
begin
  if IsStdManager then
    SetMemoryManager(StdManager);
  FillChar(A,SizeOf(A),0);
  D := GetTickCount;
  for I := 1 to 100 do
    for J := 1 to 10000 do
    begin
      FreeMem(A[J]);
      GetMem(A[J],Random(100)+1);
    end;
  D := GetTickCount-D;
  if IsStdManager then
  begin
    StdAllocSize := AllocMemSize;
    SetMemoryManager(QMemManager);
  end;
  ShowMessage('Array filled in '+IntToStr(D)+' ms');
  for J := 1 to 10000 do
    FreeMem(A[J]);
  StdAllocSize := 0;
end;

procedure TMainForm.Button3Click(Sender: TObject);
var
  I,J: Integer;
  D: LongWord;
begin
  if IsStdManager then
    SetMemoryManager(StdManager);
  FillChar(A,SizeOf(A),0);
  D := GetTickCount;
  for I := 1 to 100 do
    for J := 1 to 10000 do
    begin
      FreeMem(A[J]);
      GetMem(A[J],Random(1000)+1);
    end;
  D := GetTickCount-D;
  if IsStdManager then
  begin
    StdAllocSize := AllocMemSize;
    SetMemoryManager(QMemManager);
  end;
  ShowMessage('Array filled in '+IntToStr(D)+' ms');
  for J := 1 to 10000 do
    FreeMem(A[J]);
  StdAllocSize := 0;
end;

procedure TMainForm.Button4Click(Sender: TObject);
var
  I,J: Integer;
  D: LongWord;
begin
  if IsStdManager then
    SetMemoryManager(StdManager);
  FillChar(A,SizeOf(A),0);
  D := GetTickCount;
  for I := 1 to 100 do
    for J := 1 to 10000 do
    begin
      FreeMem(A[J]);
      GetMem(A[J],Random(4096)+1);
    end;
  D := GetTickCount-D;
  if IsStdManager then
  begin
    StdAllocSize := AllocMemSize;
    SetMemoryManager(QMemManager);
  end;
  ShowMessage('Array filled in '+IntToStr(D)+' ms');
  for J := 1 to 10000 do
    FreeMem(A[J]);
  StdAllocSize := 0;
end;

procedure TMainForm.Button5Click(Sender: TObject);
var
  I,J: Integer;
  D: LongWord;
begin
  if IsStdManager then
    SetMemoryManager(StdManager);
  FillChar(A,SizeOf(A),0);
  D := GetTickCount;
  for I := 1 to 100 do
    for J := 1 to 5000 do
    begin
      FreeMem(A[J]);
      GetMem(A[J],Random(10000)+1);
    end;
  D := GetTickCount-D;
  if IsStdManager then
  begin
    StdAllocSize := AllocMemSize;
    SetMemoryManager(QMemManager);
  end;
  ShowMessage('Array filled in '+IntToStr(D)+' ms');
  for J := 1 to 5000 do
    FreeMem(A[J]);
  StdAllocSize := 0;
end;

procedure TMainForm.Button6Click(Sender: TObject);
var
  I,J: Integer;
  D: LongWord;
begin
  if IsStdManager then
    SetMemoryManager(StdManager);
  FillChar(A,SizeOf(A),0);
  D := GetTickCount;
  for I := 1 to 100 do
    for J := 1 to 3000 do
    begin
      FreeMem(A[J]);
      GetMem(A[J],Random(5903)+4097);
    end;
  D := GetTickCount-D;
  if IsStdManager then
  begin
    StdAllocSize := AllocMemSize;
    SetMemoryManager(QMemManager);
  end;
  ShowMessage('Array filled in '+IntToStr(D)+' ms');
  for J := 1 to 3000 do
    FreeMem(A[J]);
  StdAllocSize := 0;
end;

procedure TMainForm.Button7Click(Sender: TObject);
var
  I,J: Integer;
  D: LongWord;
begin
  if IsStdManager then
    SetMemoryManager(StdManager);
  FillChar(A,SizeOf(A),0);
  D := GetTickCount;
  for I := 1 to 100 do
    for J := 1 to 300 do
    begin
      FreeMem(A[J]);
      GetMem(A[J],Random(100000)+1);
    end;
  D := GetTickCount-D;
  if IsStdManager then
  begin
    StdAllocSize := AllocMemSize;
    SetMemoryManager(QMemManager);
  end;
  ShowMessage('Array filled in '+IntToStr(D)+' ms');
  for J := 1 to 300 do
    FreeMem(A[J]);
  StdAllocSize := 0;
end;

procedure TMainForm.Button8Click(Sender: TObject);
var
  I,J: Integer;
  D: LongWord;
begin
  if IsStdManager then
    SetMemoryManager(StdManager);
  FillChar(A,SizeOf(A),0);
  D := GetTickCount;
  for I := 1 to 1000 do
    for J := 1 to 30 do
    begin
      FreeMem(A[J]);
      GetMem(A[J],Random(1000000)+1);
    end;
  D := GetTickCount-D;
  if IsStdManager then
  begin
    StdAllocSize := AllocMemSize;
    SetMemoryManager(QMemManager);
  end;
  ShowMessage('Array filled in '+IntToStr(D)+' ms');
  for J := 1 to 30 do
    FreeMem(A[J]);
  StdAllocSize := 0;
end;

end.
