unit fHLDlgPropTestMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RARegAuto, ComCtrls, RACt, RAEditor, RAHLEditor, StdCtrls, ExtCtrls,
  ClipBrd, RAHLEdPropDlg;

type
  TEditorMain = class(TForm)
    RAHLEditor1: TRAHLEditor;
    RAStatusBar1: TRAStatusBar;
    RegAuto1: TRegAuto;
    Panel1: TPanel;
    Button1: TButton;
    bEditorProperties: TButton;
    RAHLEdPropDlg1: TRAHLEdPropDlg;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure bEditorPropertiesClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EditorMain: TEditorMain;

implementation

uses RAUtils;

{$R *.DFM}

type
  TMyEditor = class(TRAHLEditor);

procedure TEditorMain.FormCreate(Sender: TObject);
begin
  if FileExists(GetParameter) then
    RAHLEditor1.Lines.LoadFromFile(GetParameter);
  RAHLEditor1.SelBlockFormat := bfColumn;
  if RAHLEdPropDlg1.RegAuto <> nil then
  begin
    RAHLEdPropDlg1.Restore;
    RAHLEdPropDlg1.LoadCurrentHighlighterColors;
  end;
end;

procedure TEditorMain.FormDestroy(Sender: TObject);
begin
  if RAHLEdPropDlg1.RegAuto <> nil then
    RAHLEdPropDlg1.Save;
end;

procedure TEditorMain.Button2Click(Sender: TObject);
var
  BlockTypeFormat: Integer;
  MemStream: TMemoryStream;
begin
  BlockTypeFormat := RegisterClipboardFormat('Borland IDE Block Type');
  if not Clipboard.HasFormat(BlockTypeFormat) then
    Error('"Borland IDE Block Type" not found in clipboard');
  MemStream := TMemoryStream.Create;
  ClipBoardToMemStream(MemStream, BlockTypeFormat);
  MemStream.SaveToFile(ExePath + 'BlockTypeFormat.txt');
end;

procedure TEditorMain.Button1Click(Sender: TObject);
const
  FormatStr: array[TSelBlockFormat] of string = ('sbInclusive', 'sbLine', 'sbColumn', 'sbNonInclusive');
var
  FM: TSelBlockFormat;
begin
  FM := TMyEditor(RAHLEditor1).GetClipboardBlockFormat;
  Button1.Caption := FormatStr[FM];
end;

procedure TEditorMain.bEditorPropertiesClick(Sender: TObject);
begin
  if RAHLEdPropDlg1.Execute then
  begin
    //RAHLEdPropDlg1.LoadCurrentHighlighterColors;
    RAHLEditor1.Invalidate;
  end;
end;


end.

