unit dbImages;
{       Copyright  1999 by Peter Ivan Dunne all rights reserved }
{       Portions Copyright (c) 1995,99 Borland International     }

{ ever wanted to use image components in your program
  only to find that you had to add the popup menu's & file dialog's
  which should have been part of the component ?
  I wrote TImagePlus & TDBimagePlus so I can forget all that coding and get
  on with the programming

  to use these components you simply install them on your component palette
  and use them as you would tImage or tDbImage
  the new properties are as follows
  Aspect (TImagePlus) like stretch except maintains aspect ratio
  OpenDialog, SaveDialog (Delphi 2)
  OpenPictureDialog, SavePictureDialog (Delphi 3,4,5)
  allows you to specify your own open & save dialogs
  if you do not specify any dialogs they are created as needed

  Note: assigning a popup menu defeats the built-in menu
  if you want to extend the menu then you can access the MENU variable of the
  TImagePlus or TDbImagePlus components

 who am I ?
    Peter Ivan Dunne
    35 year old computer technician
    My Email is host@codesource.co.uk
    web http://www.codesource.co.uk
    Copyright  1999 Peter Ivan Dunne
    Job offers ??
    Money ???
    Free Code ???

 Licence:
  for personal use only.
  May not be used for Profit
  May not be used by servants, agents or employees of the governments of the United Kingdom or
  the Republic of Ireland under any circumstances not even personal use!!
  If governments violate the rights of individuals then they should not expect our co-operation!

 Exceptions
  May be used by Registered charities without payment for their internal software
  Registered charities may distribute programs using this code provided the program(s)
  are provided without charge and only to their staff or other Registered Charities

 Warranty
  NONE - you use it at your own risk
  The author shall not be held liable for any costs/damages arising from the use
  or inability to use this code

 Support
  Email me with requests or bugs and I will try but unless I get paid!!
  Priority will always be given to bug squashing! (I hate em.)

 History
  1996 first version - Unreleased basic cut & paste functions
  1997 rewrite of code and changed the base class due to problems
       implementing the aspect ratio function, also added dialogs for open/save
  1999 rewrite (again) to make it work with Delphi versions 1-4
       also added Twain support using eztwain.dll
  2000 First Public Release

  Things to do
       Get Twain support to work under C++ Builder
       Use dynamic loading of the EZTWAIN/EZTW32 dll file
       Recent file list ??
       I am currently working on a set of Language neutral components for Delphi
       which support Unicode and dynamic language support using standardized
       dll files to provide automated translation of messages, captions, hints etc
       when this is ready (currently only working on Delphi 2 due to bugs)
       I will change these components to support full NLS capability
       Also in the pipe-line is an image filter component which makes use of
       the registry to update graphic format support without recompiling
       your application
 }

interface
(*{$IFDEF Win32}
{$R *.RES}
{$ELSE}
{$R *.R16}
{$ENDIF}*)
{$I Defines.inc}
uses
{$IFDEF Win32} Windows, ShellAPI, {$ELSE} WinTypes, WinProcs, {$ENDIF}
   Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
{$IFDEF Delphi_3_Up}
  ExtDlgs,
{$ENDIF}
{$IFDEF NLS}
  nlsControls,
{$Endif}
  Menus,ClipBrd,DBTables,DB,dbctrls,StdCtrls,DsgnIntf,ExtCtrls,imaging;


type
  TPictureChange = procedure (sender:tobject) of object;

  TDBImagePlus = class(TDBImage)
  private
    { Private declarations }
    OnPictureChange:TPictureChange;
    FPictureLoaded: Boolean;
    fFlip,fMirror:boolean;
    FAspect:Boolean;
    fBeforeLoad,fAfterLoad,
    fBeforeSave,fAfterSave:TImageDialogEvent;
{$IFDEF DELPHI_3_UP}
    FOnProgress: TProgressEvent;
    FIncrementalDisplay: Boolean;
    FDrawing: Boolean;
{ Peter I. Dunne }
    AOpenDialog:TOpenPictureDialog;
    ASaveDialog:TSavePictureDialog;
{$ELSE}
    AOpenDialog:TOpenDialog;
    ASaveDialog:TSaveDialog;
{$ENDIF}
    APopup:TNotifyEvent;
    procedure PictureChanged(Sender: TObject);
    procedure SetAspect(Value:Boolean);
    procedure CMEnter(var Message: TCMEnter); message CM_ENTER;
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
    procedure setPreview(Value:boolean);
    function getPreview:boolean;
    procedure setFlip(value:boolean);
    procedure setMirror(value:boolean);
  protected
    { Protected declarations }
    fDialogOptions:TDialogOptions;
    MenuBar: TMenuItem;
    MenuBar1: TMenuItem;
    MenuBar2: TMenuItem;
    MenuBar3: TMenuItem;
    MenuCopy: TMenuItem;
    MenuPaste: TMenuItem;
    MenuOpen: TMenuItem;
    MenuSave: TMenuItem;
    MenuCut: TMenuItem;
    MenuStretch: TMenuItem;
    MenuAspect: TMenuItem;
    MenuAutoDisplay: TMenuItem;
    MenuCenter:TMenuItem;
    MenuLogo:TMenuItem;
    MenuPreview:TMenuItem;
    MenuBar4: TMenuItem;
    MenuEffects:TMenuItem;
    MenuFlip:TMenuItem;
    MenuMirror:TMenuItem;
{$IFDEF DELPHI_3_UP}
    ImageOpenDialog:TOpenPictureDialog;
    ImageSaveDialog:TSavePictureDialog;
{$ELSE}
    ImageOpenDialog:TOpenDialog;
    ImageSaveDialog:TSaveDialog;
{$ENDIF}
{    FMainMenuItem:TMenuItem;}
    fImageMenu:TMenuItem;
    procedure Preview(Sender: TObject);
    procedure Popup(Sender:TObject); Virtual;
    procedure OnCopyClick(Sender: TObject);
    procedure OnPasteClick(Sender: TObject);
    procedure OnOpenClick(Sender: TObject);
    procedure OnSaveClick(Sender: TObject);
    procedure OnCutClick(Sender: TObject);
    procedure OnStretchClick(Sender: TObject);
    procedure OnAspectClick(Sender: TObject);
    procedure OnAutoDisplayClick(Sender: TObject);
    procedure OnCenterClick(Sender: TObject);
    procedure OnLogoClick(Sender: TObject);
    procedure OnFlipClick(Sender: TObject);
    procedure OnMirrorClick(Sender: TObject);
    procedure Paint;override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
(*{$IFDEF DELPHI_3_UP}
    function DestRect: TRect;
    function DoPaletteChange: Boolean;
    procedure Progress(Sender: TObject; Stage: TProgressStage;
      PercentDone: Byte; RedrawNow: Boolean; const R: TRect; const Msg: string); dynamic;
{$ENDIF} *)
  public
    { Public declarations }
    Menu: TPopupMenu;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property DialogOptions:TDialogOptions read fDialogOptions write fDialogOptions;
    property Aspect:boolean read FAspect write SetAspect;
    property Flip:boolean read fFlip write setFlip;
    property Mirror:boolean read fMirror write setMirror default false;
    property hasPreview:boolean read getPreview write setPreview default true;
    property OnBeforeLoad:TImageDialogEvent read fBeforeLoad write fBeforeLoad;
    property OnAfterLoad:TImageDialogEvent read fAfterLoad write fAfterLoad;
    property OnBeforeSave:TImageDialogEvent read fBeforeSave write fBeforeSave;
    property OnAfterSave:TImageDialogEvent read fAfterSave write fAfterSave;
{    property MenuIndexItem:TMenuItem read fMainMenuItem write SetMenuitem;}
{$ifdef Delphi_3_Up}
    property OpenPictureDialog:TopenPictureDialog read AOpenDialog write AOpenDialog;
    property SavePictureDialog:TSavePictureDialog read ASaveDialog write ASaveDialog;
{$else}
    property OpenPictureDialog:TopenDialog read AOpenDialog write AOpenDialog;
    property SavePictureDialog:TSaveDialog read ASaveDialog write ASaveDialog;
{$endif}
    property OnPopup:TNotifyEvent read  APopup write APopup;
  end;
{------------------------------------------------------------------------------}

type
  TDBImageTwain = class(TDBImageplus)
  private
    { Private declarations }
    fAfterAcquire:TAfterScanEvent;
    fBeforeAcquire,
    fSelectSource:TBeforeScanEvent;
    fScanError:TScanErrorEvent;
  protected
    { Protected declarations }
    Source:integer;
    MenuBar4: TMenuItem;
    MenuAcquire: TMenuItem;
    MenuSelect: TMenuItem;
    procedure OnAcquireClick(Sender:TObject);
    procedure OnSelectClick(Sender: TObject);
    procedure Popup(Sender:TObject); override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Acquire:integer;
  published
    { Published declarations }
    property OnAfterAcquire: TAfterScanEvent read fAfterAcquire write fAfterAcquire;
    property OnBeforeAcquire:TBeforeScanEvent read fBeforeAcquire write fBeforeAcquire;
    property OnSelectSource:TBeforeScanEvent read fSelectSource write fSelectSource;
    property OnScanError:TScanErrorEvent read fScanError write fScanError;
  end;
{$IFDEF DELPHI_4}
procedure Register;
{$ENDIF}

implementation

uses Preview,gdaconst;
{$IFDEF DELPHI_4}
procedure Register;
Begin
 RegisterComponents('Graphics',[TDbImageplus,TDbImagetwain]);
end;
{$ENDIF}
{$IFNDEF Win32}
function ShellAbout(Wnd: HWnd; App, Stuff: PChar; Icon: HIcon): Integer;
  far; external 'shell';
{$ENDIF}
{------------------------------------------------------------------------------}
constructor TDBImagePlus.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  if not (csDesigning in ComponentState) then
  Hint:=LoadStr(sImageHint);
   OnPictureChange:= Picture.OnChange;
   Picture.OnChange := PictureChanged;
   AOpenDialog:=Nil;
   aSaveDialog:=Nil;
   aPopup:=Nil;
   OnDblClick:=Preview;
   fDialogOptions:=TDialogOptions.Create;
   Menu := TPopupMenu.Create(Self);
   Menu.OnPopup:=Popup;
   MenuCut := TMenuItem.Create(Menu);
   MenuCopy := TMenuItem.Create(Menu);
   MenuPaste := TMenuItem.Create(Menu);
   MenuOpen := TMenuItem.Create(Menu);
   MenuSave := TMenuItem.Create(Menu);
   MenuStretch := TMenuItem.Create(Menu);
   MenuAspect := TMenuItem.Create(Menu);
   MenuCenter := TMenuItem.Create(Menu);
   MenuAutoDisplay := TMenuItem.Create(Menu);
   MenuLogo := TMenuItem.Create(Menu);
   MenuBar := TMenuItem.Create(Menu);
   MenuBar1 := TMenuItem.Create(Menu);
   MenuBar2 := TMenuItem.Create(Menu);
   MenuBar3 := TMenuItem.Create(Menu);
   MenuBar4 := TMenuItem.Create(Menu);
   MenuPreview := TMenuItem.Create(Menu);
   MenuEffects:=TMenuItem.Create(Menu);
   MenuFlip:=TmenuItem.Create(Menu);
   MenuMirror:=TMenuItem.Create(Menu);
   MenuPreview := TMenuItem.Create(Menu);
    with MenuLogo do begin
      Caption := loadStr(sAbout);
      OnClick := OnLogoClick;
   end;
   Menu.Items.Add(MenuLogo);
   with MenuBar do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar);
   with MenuCut do begin
      Caption := loadstr(sCut);
      OnClick := OnCutClick;
   end;
   Menu.Items.Add(MenuCut);
   with MenuCopy do begin
      Caption := loadstr(sCopy);
      OnClick := OnCopyClick;
   end;
   Menu.Items.Add(MenuCopy);
   with MenuPaste do begin
      Caption := loadstr(sPaste);
      OnClick := OnPasteClick;
   end;
   Menu.Items.Add(MenuPaste);
   with MenuBar1 do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar1);
   with MenuOpen do begin
      Caption := loadstr(sOpen);
      OnClick := OnOpenClick;
   end;
   Menu.Items.Add(MenuOpen);
   with MenuSave do begin
      Caption := loadstr(sSaveas);
      OnClick := OnSaveClick;
   end;
   Menu.Items.Add(MenuSave);
   with MenuBar2 do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar2);
   with MenuAspect do begin
      Caption :=loadstr(sAspect);
      OnClick := OnAspectClick;
      Checked:=fAspect;
   end;
   Menu.Items.Add(MenuAspect);
   with MenuCenter do begin
      Caption := loadstr(sCenter);
      OnClick := OnCenterClick;
      Checked:=Center;
   end;
   Menu.Items.Add(MenuCenter);
   with MenuStretch do begin
      Caption := loadstr(sStretch);
      OnClick := OnStretchClick;
      Checked:=Stretch;
   end;
   Menu.Items.Add(MenuStretch);
   with MenuBar3 do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar3);
   with MenuPreview do begin
      Caption := loadstr(sPreview);
      OnClick:=Preview;
{$IFDEF DELPHI_2_UP}
      Default:=True;
{$ENDIF}
   end;
   Menu.Items.Add(MenuPreview);
   with MenuBar4 do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar4);
   with MenuEffects do begin
      Caption := loadstr(sEffects);
   //   OnClick:=nil;
   end;
   Menu.Items.Add(MenuEffects);
   with MenuFlip do begin
      Caption := loadstr(sImageFlip);
      OnClick:=OnFlipClick;
   end;
   MenuEffects.Add(MenuFlip);
   with MenuMirror do begin
      Caption := loadstr(sImageMirror);
      OnClick:=OnMirrorClick;
   end;
   MenuEffects.add(MenuMirror);
   if componentState = [csdesigning] then PopupMenu:=nil else PopupMenu := Menu;
end;

destructor TDBImagePlus.Destroy;
begin
  Menu.Free;
  inherited Destroy;
end;

procedure TDBImagePlus.OnAspectClick;
begin
 Aspect:= Not Aspect;
end;
procedure TdbImagePlus.SetAspect;
begin
 fAspect:= Value;
 invalidate;
end;
(*
procedure TDBImagePlus.SetMenuItem(Value:TMenuItem);

begin
 if value<>fMainMenuItem then
 begin
  fMainMenuItem:=Value;
 {DELPHI 1 Compatibility, I cannot get freenotification to work}
 {$IFDEF DELPHI_2_UP}
   FMainMenuItem.FreeNotification(Self);
 {$ENDIF}
 end;
end;  *)

procedure TDBImagePlus.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
{  if (AComponent is TDBImagePlus) and (Operation = opInsert) then
   if Owner=AComponent.Owner then TDBImagePlus(AComponent).MenuIndexItem:=fMainMenuItem;
  if (AComponent = FMainMenuItem) and (Operation = opRemove) then fMainMenuItem := nil;}
  inherited Notification(AComponent, Operation);
end;

procedure TDBImagePlus.CMEnter(var Message: TCMEnter);
{var anItem:word;}
begin
{  if assigned(fMainMenuItem) and (not (csDesigning in ComponentState)) then
   begin
   if not assigned(fImageMenu) then
    begin
     fImagemenu:=TMenuItem.Create(Self);
     fImageMenu.Caption:='Image';
     for anItem:=0 to Menu.Items.Count-1 do
      begin
       with Menu.Items[anItem] do
       fImageMenu.Add(NewItem(Caption,ShortCut,Checked,Enabled,OnClick,HelpContext,''));
      end;
     end;
    fMainMenuItem.Parent.Insert(fMainMenuItem.Parent.IndexOf(fMainMenuItem),FImageMenu);
   end;{tmenuitem}
  inherited;
end;

procedure TDBImagePlus.CMExit(var Message: TCMExit);
begin
{  if assigned(fMainMenuItem) and (not (csDesigning in ComponentState)) then
   begin
    fMainMenuItem.Parent.Remove(FImageMenu);
   end;}
  inherited;
end;
procedure TDBImagePlus.PictureChanged(Sender: TObject);
begin
 OnPictureChange(Sender);
  FPictureLoaded := picture.graphic<>nil;
end;
procedure TDBImagePlus.Paint;
var
x,y:integer;
x1,y1:real;
  H: Integer;
  Dest,FlipRect: TRect;
  DrawPict: TPicture;
begin
 with Canvas do
 begin
    Brush.Style := bsSolid;
    Brush.Color := Color;
{$ifdef win32}
    if FPictureLoaded or (csPaintCopy in ControlState) then
{$else}
    if FPictureLoaded then
{$endif}
    begin
      DrawPict := TPicture.Create;
      H := 0;
      try
{$ifdef win32}
        if (csPaintCopy in ControlState) and
          Assigned(Field) and (Field is TBlobField) then
{$else}
        if (Field<>nil) and (Field is TBlobField) then
{$endif}
        begin
          DrawPict.Assign(Field);
{$ifdef win32}
          if DrawPict.Graphic is TBitmap then
            DrawPict.Bitmap.IgnorePalette := QuickDraw; //!!
{$endif}
        end
        else
        begin
          DrawPict.Assign(Picture);
          if Focused and (DrawPict.Graphic is TBitmap) and
            (DrawPict.Bitmap.Palette <> 0) then
          begin { Control has focus, so realize the bitmap palette in foreground }
            H := SelectPalette(Handle, DrawPict.Bitmap.Palette, False);
            RealizePalette(Handle);
          end;
        end;

 if fAspect then
     begin
      try
       x1:=width/Drawpict.width;
       y1:=height/Drawpict.height;
      except
 {     for catching divide by zero, rare but it happens}
       x1:=0;y1:=0;
      end;
      { ignore warnings about un-initialized variables x1,y1}
       if x1 > y1 then
       begin
          {height is the best fit}
          Dest.top:=0;
          Dest.bottom:=height;
          x:=trunc(DrawPict.width*y1);
          Dest.left:=(width-x)div 2;
          Dest.right:=Dest.left+x;
       end else
       begin
          {width is the best fit}
          Dest.left:=0;
          Dest.right:=width;
          y:=trunc(DrawPict.height*x1);
          Dest.top:=(height-y)div 2;
          Dest.bottom:=Dest.top+y;
       end;
     end else
     if stretch then
         Dest:=ClientRect
     else
        begin
          SetRect(Dest, 0, 0, DrawPict.Width, DrawPict.Height);
          if Center then OffsetRect(Dest, (ClientWidth - DrawPict.Width) div 2,
            (ClientHeight - DrawPict.Height) div 2);
        end;
     begin
       if fFlip then
        begin
         FlipRect:=Dest;
         Dest.Top:=FlipRect.Bottom;
         Dest.Bottom:=FlipRect.Top;
        end;
       if fMirror then
        begin
         FlipRect:=Dest;
         Dest.Left:=FlipRect.Right;
         Dest.Right:=FlipRect.Left;
        end;
          FillRect(ClientRect);
          StretchDraw(Dest, DrawPict.Graphic);
          ExcludeClipRect(Handle, Dest.Left, Dest.Top, Dest.Right, Dest.Bottom);
          FillRect(ClientRect);
          SelectClipRgn(Handle, 0);
        end;
      finally
        if H <> 0 then SelectPalette(Handle, H, True);
        DrawPict.Free;
      end;
  end;
    if (GetParentForm(Self).ActiveControl = Self) and
      not (csDesigning in ComponentState)
{$ifdef win32}
       and not (csPaintCopy in ControlState)
{$endif}
      then
    begin
      Brush.Color := clWindowFrame;
      FrameRect(ClientRect);
    end
//  else inherited paint;
 end;
end;

procedure TDBImagePlus.Preview;
var Preview:TPreviewForm;
begin
{$IFDEF WIN32}
 try if (not assigned (picture.graphic)) or
{$ELSE}
 try if (picture.graphic=nil) or
{$ENDIF}
 picture.graphic.empty then exit;
 except
 exit;
 end;
 Application.Createform(TPreviewForm,Preview);
 try
 Preview.ImagePreview.Flip:=Flip;
 Preview.ImagePreview.Mirror:=Mirror;
 Preview.ImagePreview.Stretch:=Stretch;
 Preview.ImagePreview.Aspect:=Aspect;
 Preview.ImagePreview.Center:=Center;
 Preview.ImagePreview.Picture.Assign(Picture);
 Screen.OnActiveFormChange:=Preview.Notify;
 Preview.Show;
 except
  Screen.OnActiveFormChange:=Preview.ActiveFormEvent;
  preview.free;
 end;
end;
procedure TDBImagePlus.OnCopyClick;
{$IFDEF DELPHI_1} var A:boolean;{$ENDIF}
begin
 if picture = nil then else
{$IFDEF DELPHI_1}
if aspect then {cures a problem when copying to clipboard on
 Delphi 1 }
 begin
  a:=aspect;
  aspect:=false;
  PAINT;
  CopyToClipboard;
  aspect:=a;
 end else
 {$ENDIF}
  CopyToClipboard;
end;
procedure TDBImagePlus.OnPasteClick;
begin
 PasteFromClipBoard;
 invalidate;
end;

procedure TDBImagePlus.OnOpenClick;
var Allow:Boolean;
begin
 Allow:=True;
 if assigned(fBeforeLoad) then fBeforeLoad(Self,DialogOptions.FileName,Allow);
 if not Allow then Exit;
 if aOpenDialog = nil then
  begin
   try
{$IFDEF DELPHI_3_UP}
    aOpenDialog:=TOpenPictureDialog.Create(Self);
{$ELSE}
    aOpenDialog:=TOpenDialog.Create(Self);
{$ENDIF}
    with AOpendialog do
     begin
      Ctl3d:=DialogOptions.Ctl3d;
      FileEditStyle:=DialogOptions.FileEditStyle;
      FilterIndex:=DialogOptions.FilterIndex;
      HelpContext:=DialogOptions.HelpContext;
      Options:=DialogOptions.Options;
      Tag:=DialogOptions.Tag;
      Title:=DialogOptions.Title;
       InitialDir:=DialogOptions.Initialdir;
       HistoryList.Assign(DialogOptions.HistoryList);
       DefaultExt:=DialogOptions.DefaultExt;
       FileName:=DialogOptions.FileName;
       Filter:=DialogOptions.Filter;
     end;
   if aOpenDialog.Execute then
   begin
    onCutClick(Self);
    Picture.LoadFromFile(aOpenDialog.FileName);
    with DialogOptions do
     begin
      FilterIndex:=AOpenDialog.FilterIndex;
       HistoryList.Assign(AOpenDialog.HistoryList);
       FileName:=AOpenDialog.FileName;
     end;
     AOpenDialog.Free;
     AOpenDialog:=Nil;
     if assigned(fAfterLoad) then fAfterLoad(Self,DialogOptions.FileName,Allow);
   end;
   except
   end;
  end
 else
  begin
    if aOpenDialog.Execute then
   begin
    onCutClick(Self);
    Picture.LoadFromFile(aOpenDialog.FileName);
    if assigned(fAfterLoad) then fAfterLoad(Self,DialogOptions.FileName,Allow);
   end;
  end;
  paint;

{//original code
 if aOpenDialog = nil then
  begin
   if ImageOpenDialog.Execute then
    Picture.LoadFromFile(ImageOpenDialog.FileName)
   end
 else if aOpenDialog.Execute then
    Picture.LoadFromFile(aOpenDialog.FileName);}
end;
procedure TDBImagePlus.OnSaveClick;
var Allow:Boolean;
begin
 Allow:=True;
 if assigned(fBeforeSave) then fBeforeSave(Self,DialogOptions.FileName,Allow);
 if not Allow then Exit;
 if aSaveDialog = Nil then
  begin
   try
{$IFDEF DELPHI_3_UP}
    ASaveDialog:=TSavePictureDialog.Create(Self);
{$ELSE}
    ASaveDialog:=TSaveDialog.Create(Self);
{$ENDIF}
    with ASaveDialog do
     begin
      Ctl3d:=DialogOptions.Ctl3d;
      FileEditStyle:=DialogOptions.FileEditStyle;
      FilterIndex:=DialogOptions.FilterIndex;
      HelpContext:=DialogOptions.HelpContext;
      Options:=DialogOptions.Options;
      Tag:=DialogOptions.Tag;
      Title:=DialogOptions.Title;
       InitialDir:=DialogOptions.Initialdir;
       HistoryList.Assign(DialogOptions.HistoryList);
       DefaultExt:=DialogOptions.DefaultExt;
       FileName:=DialogOptions.FileName;
       Filter:=DialogOptions.Filter;
     end;
   if ASaveDialog.Execute then
   begin
    Picture.SaveToFile(ASaveDialog.FileName);
    with DialogOptions do
     begin
      FilterIndex:=ASaveDialog.FilterIndex;
      HelpContext:=ASaveDialog.HelpContext;
       HistoryList.Assign(ASaveDialog.HistoryList);
       FileName:=ASaveDialog.FileName;
     end;
     ASaveDialog.Free;
     ASaveDialog:=Nil;
    if assigned(fAfterSave) then fAfterSave(Self,DialogOptions.FileName,Allow);
    end;
   except
   end
  end
 else
  begin
   if aSaveDialog.Execute then
    Picture.SaveToFile(aSaveDialog.FileName);
   if assigned(fAfterSave) then fAfterSave(Self,DialogOptions.FileName,Allow);
  end;
end;
{begin
 if aSaveDialog = Nil then
  begin
   if ImageSaveDialog.Execute then
    Picture.SaveToFile(ImageSaveDialog.FileName)
   end
 else if aSaveDialog.Execute then
    Picture.SaveToFile(aSaveDialog.FileName);
end; }
procedure TDBImagePlus.OnCutClick;
begin
 CutToClipBoard;
end;
procedure TDBImagePlus.OnStretchClick;
begin
 Stretch:= Not Stretch;
 MenuStretch.Checked:=Stretch;
end;
procedure TDBImagePlus.OnCenterClick;
begin
 Center:= Not Center;
end;
procedure TdbImagePlus.OnFlipClick;
begin
 fFlip:=not fFlip;
 MenuFlip.Checked:=fFlip;
 Invalidate;
end;
procedure TdbImagePlus.OnMirrorClick;
begin
 fMirror:=Not fMirror;
 MenuMirror.Checked:=fMirror;
 Invalidate;
end;
procedure TdbImagePlus.OnAutoDisplayClick;
begin
 AutoDisplay:= Not AutoDisplay;
end;
procedure TDBImagePlus.OnLogoClick;
begin
  ShellAbout(Application.MainForm.Handle,
             'Components by Peter Ivan Dunne',
             'Copyright (c) 1999, Peter Ivan Dunne '#13'mailto:host@codesource.co.uk',
             Application.Icon.Handle);
end;
{ I test the state of the database components here and set menus accordingly}
procedure TDBImagePlus.Popup;
var RW:boolean;
begin
{ are we read write and do we have a valid data source}
 try RW:=(DataField >'') and
  (TTable(DataSource.DataSet).Readonly = False)
  and DataSource.DataSet.Active and (not ReadOnly)
 except RW:=false end;
 MenuCut.Visible:= RW;
 MenuPaste.Visible:= RW;
 MenuOpen.Visible:= RW;
 try MenuCut.Enabled:=RW and (Not
     (TTable(DataSource.DataSet).FieldbyName(DataField).isNull))
     and fPictureLoaded;
 except MenuCut.Enabled:=false end;
 MenuCopy.Enabled:=MenuCut.Enabled;
 try MenuPaste.Enabled:=((TTable(DataSource.DataSet).state in [dsInsert,dsEdit]) or DataSource.AutoEdit)
 except MenuPaste.Enabled:=false end;
 MenuSave.Enabled:=MenuCopy.Enabled;
 MenuPreview.Enabled:=MenuCopy.Enabled;
 MenuStretch.Checked:=Stretch;
 MenuAspect.Checked:=Aspect;
 MenuOpen.Enabled:=RW;
 MenuCenter.Checked:=Center;
 MenuAutoDisplay.Checked:=AutoDisplay;
 if @APopup <> Nil then
  try
  APopup(Sender);
  finally
  end;
end;
procedure TdbImagePlus.SetFlip;
begin
 fFlip:=value;
 MenuFlip.Checked:=value;
 invalidate;
end;
procedure TdbImagePlus.SetMirror;
begin
 fMirror:=value;
 MenuMirror.Checked:=value;
 invalidate;
end;
procedure TdbImagePlus.SetPreview;
begin
 MenuPreview.visible:=value;
 MenuBar3.Visible:=MenuPreview.Visible;
end;
function TdbImagePlus.GetPreview;
begin
 result:=menuPreview.visible;
end;

{------------------------------------------------------------------------------}

Constructor TDBImageTwain.Create;
begin
inherited Create(AOwner);
   MenuAcquire := TMenuItem.Create(Menu);
   MenuSelect := TMenuItem.Create(Menu);
   MenuBar4 := TMenuItem.Create(Menu);
   with MenuBar4 do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar4);
   with MenuAcquire do begin
      Caption := loadstr(sAcquire);
      OnClick := OnAcquireClick;
   end;
   Menu.Items.Add(MenuAcquire);
   with MenuSelect do begin
      Caption := loadstr(sSelectSource);
      OnClick := OnSelectClick;
   end;
   Menu.Items.Add(MenuSelect);
  source:=-1;
end;

destructor TDBImageTwain.Destroy;
begin
  inherited Destroy;
end;

procedure TDBImageTwain.OnAcquireClick(Sender:TObject);
var Allow:boolean;
begin
  Allow:=true;
 Try
   if DataSource.AutoEdit then
   begin
    if DataSource.DataSet.State in [dsInsert,dsEdit] then else
    DataSource.Edit;
{$IFDEF DELPHI_2_UP}
  if not Assigned(Picture) then exit;
{$ELSE}
  if Picture=NIL then exit;
{$ENDIF}
  if assigned(fBeforeAcquire) then fBeforeAcquire(Self,Allow);
  if Allow then
  if (LoadTwainSourceManager >0) Then
  Begin
    if (AcquireTwainToClipboard(getParentForm(self).Handle,TWAIN_ANYTYPE)>0)
    Then
     begin
      Picture.Bitmap.LoadFromClipboardFormat(
          cf_BitMap,
          ClipBoard.GetAsHandle(cf_Bitmap),
          0
        );
      DialogOptions.FileName:='Untitled.BMP';
      if assigned(fAfterAcquire) then fAfterAcquire(self,Picture.Bitmap);
     end;
    ClipBoard.Clear;
    UnLoadTwainSourceManager;
  end;
    Invalidate;
   end;
 except
   MessageDlg(Loadstr(sTwainScanFail),mtError,[mbOk],0);
 end;
end;

function TDBImageTwain.Acquire;
var Allow:boolean;
begin
  Allow:=true;
 Try
   if DataSource.AutoEdit then
   begin
    if DataSource.DataSet.State in [dsInsert,dsEdit] then else
    DataSource.Edit;
{$IFDEF DELPHI_2_UP}
  if not Assigned(Picture) then
   begin
    result:=$ffff;
    exit;
   end;
{$ELSE}
  if Picture=nil then
   begin
    result:=$ffff;
    exit;
   end;
{$ENDIF}
  if assigned(fBeforeAcquire) then fBeforeAcquire(Self,Allow);
  if Allow then try
  begin
  result:=LoadTwainSourceManager;
  if (result >0) Then
  Begin
   result:=AcquireTwainToClipboard(GetParentForm(self).handle,TWAIN_ANYTYPE);
   if result>0 then
     begin
      Picture.Bitmap.LoadFromClipboardFormat(
          cf_BitMap,
          ClipBoard.GetAsHandle(cf_Bitmap),
          0
        );
      DialogOptions.FileName:='Untitled.BMP';
      if assigned(fAfterAcquire) then fAfterAcquire(self,Picture.Bitmap);
     end;
    ClipBoard.Clear;
    UnLoadTwainSourceManager;
    Invalidate;
  end end
  except
    ClipBoard.Clear;
    UnLoadTwainSourceManager;
    if assigned(OnScanError) then OnScanError(Self,Result);
  end end
  except
    ClipBoard.Clear;
    UnLoadTwainSourceManager;
    if assigned(OnScanError) then OnScanError(Self,Result);
  end;
end;

procedure TDBImageTwain.OnSelectClick(Sender: TObject);
var allow:boolean;

begin
 allow:=true;
 try
 if assigned(fSelectSource) then fSelectSource(Self,Allow);
 if allow then
 SelectTwainImageSource(GetParentForm(self).handle);
 except
  MessageDlg(loadstr(sTwainSourceFail),mtError,[mbOk],0);
 end;
end;

procedure TDBImageTwain.Popup;
var RW:boolean;
begin
 inherited popup(Sender);
 try RW:=(DataField >'') and
  (TTable(DataSource.DataSet).Readonly = False)
  and DataSource.DataSet.Active and (not ReadOnly)
 except RW:=false end;
 MenuAcquire.Visible:= RW;
 MenuSelect.Visible:= RW;
 MenuBar4.Visible:= RW;
{$IFDEF WIN32}
 MenuAcquire.Enabled:=TwainLibraryLoaded;
{$ENDIF}
end;

{------------------------------------------------------------------------------}

end.
