unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, EkRtf, Db, Grids, DBGrids;

type
  TMainForm = class(TForm)
    CustInvRtf: TEkRtf;
    InvRtf: TEkRtf;
    OrderRtf: TEkRtf;
    OrderBtn: TButton;
    CustBtn: TButton;
    InvBtn: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label5: TLabel;
    VenBtn: TButton;
    Button4: TButton;
    VenRtf: TEkRtf;
    Label6: TLabel;
    InvScanBtn: TButton;
    Button5: TButton;
    InvScan: TEkRTF;
    Label7: TLabel;
    Label8: TLabel;
    StRTF: TEkRTF;
    StBtn: TButton;
    Button6: TButton;
    procedure OrderBtnClick(Sender: TObject);
    procedure CustBtnClick(Sender: TObject);
    procedure InvBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure VenBtnClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CustInvRtfScanBefore(ScanInfo: TEkScanInfo);
    procedure CustInvRtfScanEof(ScanInfo: TEkScanInfo);
    procedure CustInvRtfScanRecord(ScanInfo: TEkScanInfo);
    procedure InvScanBtnClick(Sender: TObject);
    procedure InvScanScanBefore(ScanInfo: TEkScanInfo);
    procedure InvScanScanEof(ScanInfo: TEkScanInfo);
    procedure InvScanScanRecord(ScanInfo: TEkScanInfo);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure StBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses Unit2, UCustSel, UGauge, URedit, DlgInfU, ShellAPI;

{$R *.DFM}

var MTotalExtPr, MTotalExtPrCust, MTotalExtPrAll:double;

function RunFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..250] of Char;
begin
 Result := ShellExecute(Application.MainForm.Handle, nil,
   StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
   StrPCopy(zDir, DefaultDir), ShowCmd);
end;



function getnumber:string;
var Hour,Min,Sec,MSec:Word;
  SHour,SMin,SSec,SMSec:string;
begin
DecodeTime(Now(), Hour, Min, Sec, MSec);
SHour:=inttostr(Hour);
SMin:=inttostr(Min); sSec:=inttostr(Sec); sMsec:=inttostr(MSec);
if Hour<10 then SHour:='0'+SHour;
if Min<10 then SMin:='0'+SMin;
if Sec<10 then Ssec:='0'+Ssec;
result:=SHour+smin+ssec;
end;

procedure TMainForm.CustBtnClick(Sender: TObject);
begin
  with DM do
  begin
    CustInvRtf.OutFile:=ExtractFilePath(Paramstr(0))+'\cu'+getnumber+'.rtf';
    CustSel.DSCust.DataSet:=CustByLastInvQuery;
    CustByLastInvQuery.Open;
       if CustSel.showmodal=mrOk then
       begin
          application.processmessages;
          if CustSel.CustGrid.SelectedRows.Count>0 then
             //Execute report
             CustInvRtf.ExecuteOpen([CustByLastInvQuery],SW_SHOW)
                         else showmessage('Customers not selected.');
       end;//if
    CustByLastInvQuery.Close;
  end;
end;

procedure TMainForm.CustInvRtfScanBefore(ScanInfo: TEkScanInfo);
begin
   With ScanInfo do
   begin
      if Number=1 then  //if first scan in the report
      begin
         //Use Rows selected for the report in the grid
         UseSelectedRows:=true;
         SelectedRows:=CustSel.CustGrid.SelectedRows;
         FGauge.Bar.Max:=SelectedRows.count;
         FGauge.Bar.Position:=0;
         FGauge.Bar.Step:=1;
         FGauge.Show;
      end;
   end;//with
end;

procedure TMainForm.CustInvRtfScanRecord(ScanInfo: TEkScanInfo);
begin
   With ScanInfo do
   begin
      if Number=1 then  //if first scan in the report
      begin
         FGauge.Bar.StepIt;
         //showmessage(DataSet.FieldByName('Company').AsString);
         application.ProcessMessages;
      end;
   end;//with
end;

procedure TMainForm.CustInvRtfScanEof(ScanInfo: TEkScanInfo);
begin
  //if first scan in the report
   application.ProcessMessages;
   With ScanInfo do if Number=1 then FGauge.Close;
end;


procedure TMainForm.OrderBtnClick(Sender: TObject);
begin
    OrderRtf.OutFile:=ExtractFilePath(Paramstr(0))+'\or'+getnumber+'.rtf';
    with DM.OrdersByDateQuery do
    begin
      Close;
      Open;
         OrderRTF.ExecuteOpen([DM.OrdersByDateQuery],SW_SHOW);
      Close;
     end;
end;

function CalcExtSum:Double;
begin
 Result:=0; Dm.Items.First;
 While not Dm.Items.Eof do begin Result:=Result+Dm.Items.FieldByName('ExtPrice').AsFloat; Dm.Items.Next; end;
end;

procedure TMainForm.InvBtnClick(Sender: TObject);
var Esum:Double;
    custno:integer;
begin
if DlgInv.ShowModal=mrOk then
     begin
     DM.items.Filter:='OrderNo='+DM.Orders.FieldByName('OrderNo').AsString;
     DM.items.filtered:=true;

     custno:=Dm.orders.fieldbyname('custno').AsInteger;
     Dm.cust.Locate('CustNo',custno,[]);
     InvRtf.OutFile:=ExtractFilePath(Paramstr(0))+'\in'+getnumber+'.rtf';

     //Calculate variable Esum
     Esum:=CalcExtSum();

     //Add variables to varlist
     InvRtf.VarList.Clear;
     InvRtf.VarList.Add('Esum='+FloatToStr(Esum));
     InvRtf.VarList.Add('Freight='+
            Dm.Orders.FieldByName('Freight').AsString);
     InvRtf.VarList.Add('Total='
       +FloatToStr(Esum+Dm.Orders.FieldByName('Freight').AsFloat));

     //Generate report
     InvRtf.ExecuteOpen([DM.Cust,DM.Orders,DM.Items], SW_SHOW);
     end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
RunFile('OrderRpt.doc','','',SW_SHOW);
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
RunFile('CustList.doc','','',SW_SHOW);
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
RunFile('InvRpt.doc','','',SW_SHOW);
end;

procedure TMainForm.VenBtnClick(Sender: TObject);
begin
    VenRtf.FalseValue:=''; //Nothing if false;
    VenRtf.TrueValue:=#252; //Symbol will be in column "preferred" if true
    VenRtf.OutFile:=ExtractFilePath(Paramstr(0))+'\vn'+getnumber+'.rtf';
    VenRTF.ExecuteOpen([DM.Vendor],SW_SHOW);
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
RunFile('Vendor.doc','','',SW_SHOW);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  if not FileExists(ExtractFilePath(Paramstr(0))+'\vendor.rtf') then
         showmessage('Some of Input files not found!. Place your compiled exe file into project source directory.');
end;


procedure TMainForm.InvScanBtnClick(Sender: TObject);
begin
  with DM do
  begin
    InvScan.OutFile:=ExtractFilePath(Paramstr(0))+'\in'+getnumber+'.rtf';
    CustSel.DSCust.DataSet:=CustByCompany;
    CustByCompany.Open;
       if CustSel.showmodal=mrOk then
       begin
          application.processmessages;
          if CustSel.CustGrid.SelectedRows.Count>0 then
             //Execute report
             begin
             InvScan.VarList.Clear;
             InvScan.VarList.Add('TotalExtPr=0');
             InvScan.VarList.Add('TotalExtPrCust=0');
             InvScan.VarList.Add('TotalExtPrAll=0');
             InvScan.ExecuteOpen([DM.CustByCompany, DM.Orders, DM.items],SW_SHOW);
             end  else showmessage('Customers not selected.');
       end;//if
    CustByCompany.Close;
  end;
end;

procedure TMainForm.InvScanScanBefore(ScanInfo: TEkScanInfo);
begin
   With ScanInfo do
   begin
      case Number of
      1: // scan(a)
      begin
         //Use Rows selected for the report in the grid
         UseSelectedRows:=true;
         SelectedRows:=CustSel.CustGrid.SelectedRows;
         FGauge.Bar.Max:=SelectedRows.count;
         FGauge.Bar.Position:=0;
         FGauge.Bar.Step:=1;
         FGauge.Show;
         MTotalExtPrAll:=0;
      end;
      2: //before scan(orders)
      begin
        MTotalExtPrCust:=0;
      end;
      3: //before scan(items)
      begin
        MTotalExtPr:=0;
      end;
      end; //case
   end;//with

end;

procedure TMainForm.InvScanScanRecord(ScanInfo: TEkScanInfo);
var MExtPr:Double;
begin
   With ScanInfo do
   begin
      case Number of
      1:  // scan(a) - customers
      begin
         DM.Orders.Filter:='CustNo='+DM.CustByCompany.FieldbyName('CustNo').AsString;
         DM.Orders.Filtered:=true;
         FGauge.Bar.StepIt;
         application.ProcessMessages;
      end;
      2: // scan(orders) record
        begin
          DM.items.Filter:='OrderNo='+DM.Orders.FieldByName('OrderNo').AsString;
          DM.items.filtered:=true;
        end;
      3: //scan(items) record
        begin
         MExtPr:=DM.items.FieldByName('ExtPrice').AsFloat;
         MTotalExtPr:=MTotalExtPr+MExtPr;
         MTotalExtPrCust:=MTotalExtPrCust+MExtPr;
         MTotalExtPrAll:=MTotalExtPrAll+MExtPr;
        end;
      end;//case
   end;//with

end;

procedure TMainForm.InvScanScanEof(ScanInfo: TEkScanInfo);
begin
  //if first scan in the report
   application.ProcessMessages;
   With ScanInfo do
    case Number of
    1:  //scan(a) eof
     begin
      DM.orders.filtered:=false;
      DM.orders.filter:='';
      DM.items.Filtered:=false;
      DM.items.filter:='';
      FGauge.Close;
      InvScan.VarList[2]:='TotalExtPrAll='+FloatToStr(MTotalExtPrAll);
     end;
    2: //scan(orders) eof
     begin
       InvScan.VarList[1]:='TotalExtPrCust='+FloatToStr(MTotalExtPrCust);
     end;
    3: //scan(items) eof
     begin
       InvScan.VarList[0]:='TotalExtPr='+FloatToStr(MTotalExtPr);
     end;
    end;//case
end;


procedure TMainForm.Button5Click(Sender: TObject);
begin
RunFile('Inv_scan.doc','','',SW_SHOW);
end;

procedure TMainForm.Button6Click(Sender: TObject);
begin
RunFile('stream.doc','','',SW_SHOW);
end;

procedure TMainForm.StBtnClick(Sender: TObject);
var S:TMemoryStream;
begin
  S:=TMemoryStream.create;
  StRTF.ExecuteStream([DM.Vendor],S);
  FRedit.REdit.Lines.LoadFromStream(s);
  S.Free;
  FRedit.show;
end;

end.
