//----------------------------------------------------------------------------
// imaging.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: imaging.pas
//----------------------------------------------------------------------------
#ifndef imagingHPP
#define imagingHPP
//----------------------------------------------------------------------------
#include <DsgnIntf.hpp>
#include <StdCtrls.hpp>
#include <Clipbrd.hpp>
#include <Menus.hpp>
#include <FiltEdit.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <ShellAPI.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Imaging
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TImageDialogEvent)(System::TObject* Sender,  System::AnsiString 
	FileName, bool &Allow);

typedef void __fastcall (__closure *TAfterScanEvent)(System::TObject* Sender, Graphics::TBitmap* Image
	);

typedef void __fastcall (__closure *TBeforeScanEvent)(System::TObject* Sender, bool &Allow);

typedef void __fastcall (__closure *TScanErrorEvent)(System::TObject* Sender, int Error);

class __declspec(delphiclass) TDialogOptions;
class __declspec(pascalimplementation) TDialogOptions : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	bool fCtl3d;
	TFileEditStyle fFileEditStyle;
	int fFilterIndex;
	int fHelpcontext;
	Classes::TStrings* fHistoryList;
	Dialogs::TOpenOptions fOptions;
	long fTag;
	char *fInitialDir;
	char *fDefaultExt;
	char *fFileName;
	char *fFilter;
	char *fTitle;
	bool fStoreFilter;
	void __fastcall SetLines(Classes::TStrings* Value);
	System::AnsiString __fastcall GetinitialDir(void);
	void __fastcall SetInitialDir( System::AnsiString Value);
	System::AnsiString __fastcall GetDefaultExt(void);
	void __fastcall SetDefaultExt( System::AnsiString Value);
	System::AnsiString __fastcall GetFileName(void);
	void __fastcall SetFileName( System::AnsiString Value);
	System::AnsiString __fastcall GetFilter(void);
	void __fastcall SetFilter( System::AnsiString Value);
	System::AnsiString __fastcall GetTitle(void);
	void __fastcall SetTitle( System::AnsiString Value);
	
public:
	__fastcall TDialogOptions(void);
	__fastcall virtual ~TDialogOptions(void);
	
__published:
	__property System::AnsiString DefaultExt = {read=GetDefaultExt, write=SetDefaultExt, nodefault};
	__property System::AnsiString Filter = {read=GetFilter, write=SetFilter, stored=fStoreFilter, nodefault
		};
	__property System::AnsiString InitialDir = {read=GetinitialDir, write=SetInitialDir, nodefault};
	__property System::AnsiString Title = {read=GetTitle, write=SetTitle, nodefault};
	__property System::AnsiString FileName = {read=GetFileName, write=SetFileName, nodefault};
	__property bool Ctl3d = {read=fCtl3d, write=fCtl3d, default=0};
	__property Dialogs::TFileEditStyle FileEditStyle = {read=fFileEditStyle, write=fFileEditStyle, default=0
		};
	__property int FilterIndex = {read=fFilterIndex, write=fFilterIndex, default=0};
	__property int HelpContext = {read=fHelpcontext, write=fHelpcontext, default=0};
	__property Classes::TStrings* HistoryList = {read=fHistoryList, write=SetLines, nodefault};
	__property Dialogs::TOpenOptions Options = {read=fOptions, write=fOptions, default=0};
	__property long Tag = {read=fTag, write=fTag, default=0};
};

class __declspec(delphiclass) TImagePlus;
class __declspec(pascalimplementation) TImagePlus : public Controls::TGraphicControl
{
	typedef Controls::TGraphicControl inherited;
	
private:
	bool FAspect;
	TImageDialogEvent fBeforeLoad;
	TImageDialogEvent fAfterLoad;
	TImageDialogEvent fBeforeSave;
	TImageDialogEvent fAfterSave;
	bool FAutoSize;
	bool FStretch;
	bool FCenter;
	Dialogs::TOpenDialog* AOpenDialog;
	Dialogs::TSaveDialog* ASaveDialog;
	Graphics::TPicture* FPicture;
	Classes::TNotifyEvent APopup;
	void __fastcall SetStretch(bool Value);
	Graphics::TCanvas* __fastcall GetCanvas(void);
	void __fastcall SetAutoSize(bool Value);
	void __fastcall SetCenter(bool Value);
	void __fastcall SetPicture(Graphics::TPicture* Value);
	void __fastcall PictureChanged(System::TObject* Sender);
	
protected:
	Menus::TMenuItem* MenuBar;
	Menus::TMenuItem* MenuBar1;
	Menus::TMenuItem* MenuBar2;
	Menus::TMenuItem* MenuBar3;
	Menus::TMenuItem* MenuCopy;
	Menus::TMenuItem* MenuPaste;
	Menus::TMenuItem* MenuOpen;
	Menus::TMenuItem* MenuSave;
	Menus::TMenuItem* MenuCut;
	Menus::TMenuItem* MenuStretch;
	Menus::TMenuItem* MenuAspect;
	Menus::TMenuItem* MenuCenter;
	Menus::TMenuItem* MenuLogo;
	Menus::TMenuItem* MenuPreview;
	TDialogOptions* fDialogOptions;
	void __fastcall Preview(System::TObject* Sender);
	virtual void __fastcall Popup(System::TObject* Sender);
	void __fastcall OnCopyClick(System::TObject* Sender);
	void __fastcall OnPasteClick(System::TObject* Sender);
	void __fastcall OnOpenClick(System::TObject* Sender);
	void __fastcall OnSaveClick(System::TObject* Sender);
	void __fastcall OnCutClick(System::TObject* Sender);
	void __fastcall OnStretchClick(System::TObject* Sender);
	void __fastcall OnAspectClick(System::TObject* Sender);
	void __fastcall OnCenterClick(System::TObject* Sender);
	void __fastcall OnLogoClick(System::TObject* Sender);
	void __fastcall SetAspect(bool Value);
	virtual HPALETTE __fastcall GetPalette(void);
	virtual void __fastcall Paint(void);
	
public:
	Menus::TPopupMenu* Menu;
	__fastcall virtual TImagePlus(Classes::TComponent* AOwner);
	__fastcall virtual ~TImagePlus(void);
	__property Graphics::TCanvas* Canvas = {read=GetCanvas, nodefault};
	
__published:
	__property Dialogs::TOpenDialog* OpenDialog = {read=AOpenDialog, write=AOpenDialog, nodefault};
	__property Dialogs::TSaveDialog* SaveDialog = {read=ASaveDialog, write=ASaveDialog, nodefault};
	__property TDialogOptions* DialogOptions = {read=fDialogOptions, write=fDialogOptions, nodefault};
	__property bool Aspect = {read=FAspect, write=SetAspect, default=0};
	__property TImageDialogEvent OnBeforeLoad = {read=fBeforeLoad, write=fBeforeLoad};
	__property TImageDialogEvent OnAfterLoad = {read=fAfterLoad, write=fAfterLoad};
	__property TImageDialogEvent OnBeforeSave = {read=fBeforeSave, write=fBeforeSave};
	__property TImageDialogEvent OnAfterSave = {read=fAfterSave, write=fAfterSave};
	__property Classes::TNotifyEvent OnPopup = {read=APopup, write=APopup};
	__property Align ;
	__property bool AutoSize = {read=FAutoSize, write=SetAutoSize, default=0};
	__property bool Center = {read=FCenter, write=SetCenter, default=0};
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property ParentShowHint ;
	__property Graphics::TPicture* Picture = {read=FPicture, write=SetPicture, nodefault};
	__property PopupMenu ;
	__property ShowHint ;
	__property bool Stretch = {read=FStretch, write=SetStretch, default=0};
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
};

class __declspec(delphiclass) TImageTwain;
class __declspec(pascalimplementation) TImageTwain : public TImagePlus
{
	typedef TImagePlus inherited;
	
private:
	TAfterScanEvent fAfterAcquire;
	TBeforeScanEvent fBeforeAcquire;
	TBeforeScanEvent fSelectSource;
	TScanErrorEvent fScanError;
	
protected:
	Menus::TMenuItem* MenuBar4;
	Menus::TMenuItem* MenuAcquire;
	Menus::TMenuItem* MenuSelect;
	virtual void __fastcall Popup(System::TObject* Sender);
	void __fastcall OnAcquireClick(System::TObject* Sender);
	void __fastcall OnSelectClick(System::TObject* Sender);
	
public:
	__fastcall virtual TImageTwain(Classes::TComponent* AOwner);
	__fastcall virtual ~TImageTwain(void);
	
__published:
	__property TAfterScanEvent OnAfterAcquire = {read=fAfterAcquire, write=fAfterAcquire};
	__property TBeforeScanEvent OnBeforeAcquire = {read=fBeforeAcquire, write=fBeforeAcquire};
	__property TBeforeScanEvent OnSelectSource = {read=fSelectSource, write=fSelectSource};
	__property TScanErrorEvent OnScanError = {read=fScanError, write=fScanError};
};

//-- var, const, procedure ---------------------------------------------------
#define TWAIN_BW (Byte)(1)
#define TWAIN_GRAY (Byte)(2)
#define TWAIN_RGB (Byte)(4)
#define TWAIN_PALETTE (Byte)(8)
#define TWAIN_ANYTYPE (Byte)(0)
#define TWAINLIB "EZTW32.DLL"
extern int __fastcall TwainloadLibrary(void);
extern bool __fastcall TwainUnloadLibrary(void);
extern int __fastcall AcquireTwainToClipboard(HWND hwnd, Cardinal pixmask);
extern int __fastcall SelectTwainImageSource(HWND hwnd);
extern int __fastcall LoadTwainSourceManager(void);
extern int __fastcall UnloadTwainSourceManager(void);
extern bool __fastcall TwainLibraryLoaded(void);
//-- template instantiations -------------------------------------------------
template class Dialogs::TOpenOptions ;

}	/* namespace Imaging */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Imaging;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// imaging
