unit imaging;
{       Copyright  1999 by Peter Ivan Dunne all rights reserved }
{       Portions Copyright (c) 1995,99 Borland International     }

{ ever wanted to use image components in your program
  only to find that you had to add the popup menu's & file dialog's
  which should have been part of the component ?
  I wrote TImagePlus & TDBimagePlus so I can forget all that coding and get
  on with the programming

  to use these components you simply install them on your component palette
  and use them as you would tImage or tDbImage
  the new properties are as follows
  Aspect (TImagePlus) like stretch except maintains aspect ratio
  OpenDialog, SaveDialog (Delphi 2)
  OpenPictureDialog, SavePictureDialog (Delphi 3,4,5)
  allows you to specify your own open & save dialogs
  if you do not specify any dialogs they are created as needed

  Note: assigning a popup menu defeats the built-in menu
  if you want to extend the menu then you can access the MENU variable of the
  TImagePlus or TDbImagePlus components

 who am I ?
    Peter Ivan Dunne
    35 year old computer technician
    My Email is
    shadowdancer@voyetra.freeserve.co.uk
    shadowdancer@freenetname.co.uk
    Copyright  1999 Peter Ivan Dunne
    Job offers ??
    Money ???
    Free Code ???

 Licence:
  for personal use only.
  May not be used for Profit
  May not be used by servants, agents or employees of the governments of the United Kingdom or
  the Republic of Ireland under any circumstances not even personal use!!
  If governments violate the rights of individuals then they should not expect our co-operation!

 Exceptions
  May be used by Registered charities without payment for their internal software
  Registered charities may distribute programs using this code provided the program(s)
  are provided without charge and only to their staff or other Registered Charities

 Warranty
  NONE - you use it at your own risk
  The author shall not be held liable for any costs/damages arising from the use
  or inability to use this code

 Support
  Email me with requests or bugs and I will try but unless I get paid!!
  Priority will always be given to bug squashing! (I hate em.)

 History
  1996 first version - Unreleased basic cut & paste functions
  1997 rewrite of code and changed the base class due to problems
       implementing the aspect ratio function, also added dialogs for open/save
  1999 rewrite (again) to make it work with Delphi versions 1-4
       also added Twain support using eztwain.dll
  2000 First Public Release
       I intend to add aspect to TDBImagePlus/TDBImageTwain
       Change base class for TImagePlus so I can get them to provide
       context menu support (sub-menu addition to main menu)
       Recent file list ??
       I am currently working on a set of Language neutral components for Delphi
       which support Unicode and dynamic language support using standardized
       dll files to provide automated translation of messages, captions, hints etc
       when this is ready (currently only working on Delphi 2 due to bugs)
       I will change these components to support full NLS capability
       Also in the pipe-line is an image filter component which makes use of
       the registry to update graphic format support without recompiling
       your application
 }

interface
{$IFDEF Win32}
{$R *.RES}
{$ELSE}
{$R *.R16}
{$ENDIF}
{$I Defines.inc}

uses
{$IFDEF Win32} Windows, ShellAPI, {$ELSE} WinTypes, WinProcs, {$ENDIF}
   Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
{$IFDEF Delphi_3_Up}
  ExtDlgs,
{$ENDIF}
{$IFNDEF DELPHI_3_UP}
 FiltEdit,
{$ENDIF}
{$IFDEF NLS}
  nlsControls,
{$Endif}
  Menus,ClipBrd,StdCtrls,DsgnIntf;
Type
  TImageDialogEvent = procedure (Sender: TObject; FileName:String;Var Allow:Boolean) of object;
  TAfterScanEvent = procedure (Sender: TObject; Image:TBitmap) of object;
  TBeforeScanEvent = procedure (Sender: TObject; Var Allow:boolean) of object;
  TScanErrorEvent = procedure (Sender: TObject;Error:Integer) of object;

  TDialogOptions = class(TPersistent)
   private
    fCtl3d:boolean;
    fFileEditStyle:TFileEditStyle;
    fFilterIndex:Integer;
    fHelpcontext:Integer;
    fHistoryList:TStrings;
    fOptions:TOpenOptions;
    fTag:Longint;
    fInitialDir:PChar;
    fDefaultExt:Pchar;
    fFileName:Pchar;
    fFilter:Pchar;
    fTitle:Pchar;
    fStoreFilter:boolean;
    procedure SetLines(Value: TStrings);
    function GetinitialDir:String;
    procedure SetInitialDir(Value:String);
    function GetDefaultExt:String;
    procedure SetDefaultExt(Value:String);
    function GetFileName:String;
    procedure SetFileName(Value:String);
    function GetFilter:String;
    procedure SetFilter(Value:String);
    function GetTitle:String;
    procedure SetTitle(Value:String);
  public
    constructor create;
    destructor destroy; override;
   published
    property DefaultExt:String read GetDefaultExt write SetDefaultExt;
    property Filter:String read GetFilter write SetFilter stored fStoreFilter;
    property InitialDir:String read GetInitialdir write SetInitialDir;
    property Title:String read GetTitle write SetTitle;
    property FileName:String read GetFileName write SetFileName;
    property Ctl3d:boolean read fCtl3d write fCtl3d default false;
    property FileEditStyle:TFileEditStyle read fFileEditStyle write fFileEditStyle default fsedit;
    property FilterIndex:Integer read fFilterIndex write fFilterIndex default 0;
    property HelpContext:Integer read fHelpcontext write fHelpContext default 0;
    property HistoryList:TStrings read fHistoryList write SetLines;
    property Options:TOpenOptions read fOptions write fOptions default [];
    property Tag:longInt read fTag write fTag default 0;
   end;

{$IFDEF NLS}
  TImagePlus = class(TNLSGraphicControl)
{$ELSE}
  TImagePlus = class(TGraphicControl)
{$ENDIF}
  private
    Dest:TRect;
    x,y:Longint;
    x1,y1:real;
{$IFDEF DELPHI_3_UP}
    Save: Boolean;
{$ENDIF}
    fFlip,fMirror:boolean;
    FAspect:Boolean;
    fBeforeLoad,fAfterLoad,
    fBeforeSave,fAfterSave:TImageDialogEvent;
    FAutoSize: Boolean;
    FStretch: Boolean;
    FCenter: Boolean;
{$IFDEF DELPHI_3_UP}
    FOnProgress: TProgressEvent;
    FIncrementalDisplay: Boolean;
    FTransparent: Boolean;
    FDrawing: Boolean;
{ Peter I. Dunne }
    AOpenDialog:TOpenPictureDialog;
    ASaveDialog:TSavePictureDialog;
{$ELSE}
    AOpenDialog:TOpenDialog;
    ASaveDialog:TSaveDialog;
{$ENDIF}
    FPicture: TPicture;
    APopup:TNotifyEvent;
    procedure SetStretch(Value:Boolean);
    function GetCanvas: TCanvas;
    procedure SetAutoSize(Value: Boolean);
    procedure SetCenter(Value: Boolean);
    procedure SetPicture(Value: TPicture);
    procedure PictureChanged(Sender: TObject);
    procedure setPreview(Value:boolean);
    function getPreview:boolean;
    procedure setFlip(value:boolean);
    procedure setMirror(value:boolean);
{$IFDEF DELPHI_3_UP}
    procedure SetTransparent(Value: Boolean);
{$ENDIF}
  protected
    MenuBar: TMenuItem;
    MenuBar1: TMenuItem;
    MenuBar2: TMenuItem;
    MenuBar3: TMenuItem;
    MenuCopy: TMenuItem;
    MenuPaste: TMenuItem;
    MenuOpen: TMenuItem;
    MenuSave: TMenuItem;
    MenuCut: TMenuItem;
    MenuStretch: TMenuItem;
    MenuAspect: TMenuItem;
    MenuCenter: TMenuItem;
    MenuLogo:TMenuItem;
    MenuPreview:TMenuItem;
    MenuBar4: TMenuItem;
    MenuEffects:TMenuItem;
    MenuFlip:TMenuItem;
    MenuMirror:TMenuItem;
    fDialogOptions:TDialogOptions;
    procedure Preview(Sender: TObject);
    procedure Popup(Sender:TObject); virtual;
    procedure OnCopyClick(Sender: TObject);
    procedure OnPasteClick(Sender: TObject);
    procedure OnOpenClick(Sender: TObject);
    procedure OnSaveClick(Sender: TObject);
    procedure OnCutClick(Sender: TObject);
    procedure OnStretchClick(Sender: TObject);
    procedure OnAspectClick(Sender: TObject);
    procedure OnCenterClick(Sender: TObject);
    procedure OnLogoClick(Sender: TObject);
    procedure OnFlipClick(Sender: TObject);
    procedure OnMirrorClick(Sender: TObject);
    procedure SetAspect(Value:Boolean);
    function GetPalette: HPALETTE; override;
    procedure Paint; override;
{$IFDEF DELPHI_3_UP}
    function DestRect: TRect;
    function DoPaletteChange: Boolean;
    procedure Progress(Sender: TObject; Stage: TProgressStage;
      PercentDone: Byte; RedrawNow: Boolean; const R: TRect; const Msg: string); dynamic;
{$ENDIF}
{$IFDEF DELPHI_4_UP}
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;
{$ENDIF}
  public
    Menu: TPopupMenu;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Canvas: TCanvas read GetCanvas;
  published
{$IFDEF Delphi_3_Up}
    property OpenPictureDialog:TopenPictureDialog read AOpenDialog write AOpenDialog;
    property SavePictureDialog:TSavePictureDialog read ASaveDialog write ASaveDialog;
{$ELSE}
    property OpenPictureDialog:TopenDialog read AOpenDialog write AOpenDialog;
    property SavePictureDialog:TSaveDialog read ASaveDialog write ASaveDialog;
{$ENDIF}
    property DialogOptions:TDialogOptions read fDialogOptions write fDialogOptions;
    property Aspect:boolean read FAspect write SetAspect default false;
    property Flip:boolean read fFlip write setFlip;
    property Mirror:boolean read fMirror write setMirror default false;
    property hasPreview:boolean read getPreview write setPreview default true;
    property OnBeforeLoad:TImageDialogEvent read fBeforeLoad write fBeforeLoad;
    property OnAfterLoad:TImageDialogEvent read fAfterLoad write fAfterLoad;
    property OnBeforeSave:TImageDialogEvent read fBeforeSave write fBeforeSave;
    property OnAfterSave:TImageDialogEvent read fAfterSave write fAfterSave;
    property OnPopup:TNotifyEvent read  aPopup write aPopup;
    property Align;
    property AutoSize: Boolean read FAutoSize write SetAutoSize default False;
    property Center: Boolean read FCenter write SetCenter default False;
    property DragCursor;
    property DragMode;
    property Enabled;
    property ParentShowHint;
    property Picture: TPicture read FPicture write SetPicture;
    property PopupMenu;
    property ShowHint;
    property Stretch: Boolean read FStretch write SetStretch default False;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
{$IFDEF DELPHI_3_UP}
    property IncrementalDisplay: Boolean read FIncrementalDisplay write FIncrementalDisplay default False;
    property Transparent: Boolean read FTransparent write SetTransparent default False;
    property OnProgress: TProgressEvent read FOnProgress write FOnProgress;
    property OnStartDrag;
{$ENDIF}
{$IFDEF DELPHI_4_UP}
    property Anchors;
    property Constraints;
    property DragKind;
    property OnEndDock;
    property OnStartDock;
{$ENDIF}
end;

{------------------------------------------------------------------------------}
{ Twain support }
const
     TWAIN_BW=1;      { 1-bit per pixel, B&W      (== TWPT_BW) }
     TWAIN_GRAY=2;    { 1,4, or 8-bit grayscale  (== TWPT_GRAY) }
     TWAIN_RGB=4;     { 24-bit RGB color         (== TWPT_RGB) }
     TWAIN_PALETTE=8; { 1,4, or 8-bit palette    (== TWPT_PALETTE) }
     TWAIN_ANYTYPE=0; { any of the above }
{$IFDEF WIN32}
     TWAINLIB='EZTW32.DLL';
{$ELSE}
     TWAINLIB='EZTWAIN.DLL';
{$ENDIF}

{------------------------------------------------------------------------------}
type
  TImageTwain = class(TImageplus)
  private
    { Private declarations }
    fAfterAcquire:TAfterScanEvent;
    fBeforeAcquire,
    fSelectSource:TBeforeScanEvent;
    fScanError:TScanErrorEvent;
  protected
    { Protected declarations }
    MenuBar4: TMenuItem;
    MenuAcquire: TMenuItem;
    MenuSelect: TMenuItem;
    procedure Popup(Sender:TObject); override;
    procedure OnAcquireClick(Sender:TObject);
    procedure OnSelectClick(Sender: TObject);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
//    function SetSource(Source:Integer):boolean;
    function Acquire:Integer;
  published
    { Published declarations }
    property OnAfterAcquire: TAfterScanEvent read fAfterAcquire write fAfterAcquire;
    property OnBeforeAcquire:TBeforeScanEvent read fBeforeAcquire write fBeforeAcquire;
    property OnSelectSource:TBeforeScanEvent read fSelectSource write fSelectSource;
    property OnScanError:TScanErrorEvent read fScanError write fScanError;
  end;
{$IFDEF WIN32}
function TwainloadLibrary:THandle;
function TwainUnloadLibrary:boolean;
function TwainLibraryLoaded:boolean;
{$ENDIF}
function AcquireTwainToClipboard(hwnd:HWND; pixmask: Cardinal): Integer;
function SelectTwainImageSource(hwnd:HWND): Integer;
function LoadTwainSourceManager:integer;
function UnloadTwainSourceManager:integer;

{$IFDEF DELPHI_4}
procedure Register;
{$ENDIF}

implementation
uses Consts,preview,gdaconst;

{$IFDEF DELPHI_4}
procedure Register;
Begin
 RegisterComponents('Graphics',[TImageplus,TImagetwain]);
end;
{$ENDIF}

(*----------------------------------------------------------------------------*)
{ Functions from 'EZTW32.DLL/EZTWAIN.DLL'}
(*----------------------------------------------------------------------------*)
{$IFDEF WIN32}
type
{ for some reason when I defined these directly as variables the
  twain functions complained about invalid handles and crashed
  defining them this way works, why???? dunno!}

 TTWAIN_AcquireToClipboard=function(hwnd: HWND; pixmask: Cardinal): Integer far pascal;
 TTWAIN_SelectImageSource=function(hwnd: HWND): Integer far pascal;
 TTWAIN_LoadSourceManager=function: integer far pascal;
 TTWAIN_UnloadSourceManager=function: integer far pascal;

var TWAIN_AcquireToClipboard:TTWAIN_AcquireToClipboard;
    TWAIN_SelectImageSource:TTWAIN_SelectImageSource;
    TWAIN_LoadSourceManager:TTWAIN_LoadSourceManager;
    TWAIN_UnloadSourceManager:TTWAIN_UnloadSourceManager;
    TWAIN_LOADED:BOOLEAN;
    TwainHandle:THandle;
{$ELSE}
(*----------------------------------------------------------------------------*)
{ Functions from 'EZTWAIN.DLL'}
(*----------------------------------------------------------------------------*)
function TWAIN_AcquireToClipboard(hwnd: HWND; pixmask: Cardinal): Integer;
  {Pascal;} far; external 'EZTWAIN.DLL' name 'TWAIN_AcquireToClipboard';
function TWAIN_SelectImageSource(hwnd: HWND): Integer;
  {Pascal;} far; external 'EZTWAIN.DLL' name 'TWAIN_SelectImageSource';
function TWAIN_LoadSourceManager: integer;
  {Pascal;} far; external 'EZTWAIN.DLL' name 'TWAIN_LoadSourceManager';
function TWAIN_UnloadSourceManager: integer;
  {Pascal;} far; external 'EZTWAIN.DLL' name 'TWAIN_UnloadSourceManager';
(*----------------------------------------------------------------------------*)
{$ENDIF}
(*----------------------------------------------------------------------------*)
{$IFDEF WIN32}
function TwainLoadLibrary:THandle;
begin
 if not Twain_Loaded then
  TwainHandle:=loadlibrary(TWAINLIB);
  Twain_Loaded:=(TwainHandle<>0);
  result:=TwainHandle;
  if Twain_Loaded then
  begin
   TWAIN_AcquireToClipboard:=GetProcAddress(TwainHandle,'TWAIN_AcquireToClipboard');
   TWAIN_SelectImageSource:=GetProcAddress(TwainHandle,'TWAIN_SelectImageSource');
   TWAIN_LoadSourceManager:=GetProcAddress(TwainHandle,'TWAIN_LoadSourceManager');
   TWAIN_UnloadSourceManager:=GetProcAddress(TwainHandle,'TWAIN_UnloadSourceManager');
  end;
end;
function TwainUnloadLibrary:boolean;
begin
 result:=freelibrary(TwainHandle);
 if result then
 freelibrary(TwainHandle);
 begin
   TWAIN_LOADED:=FALSE;
   TWAIN_AcquireToClipboard:=nil;
   TWAIN_SelectImageSource:=nil;
   TWAIN_LoadSourceManager:=nil;
   TWAIN_UnloadSourceManager:=nil;
 end;
end;
{$ENDIF}

function AcquireTwainToClipboard(hwnd:HWND;pixmask: Cardinal): Integer;
begin
{$IFDEF WIN32}
 if not Twain_Loaded then
  TwainLoadLibrary;
 if assigned (TWAIN_AcquireToClipboard)
 then
  result:=Twain_AcquireToClipboard(hwnd,pixmask) else result:=-1;
 {$ELSE}
  result:=Twain_AcquireToClipboard(hwnd,pixmask);
 {$ENDIF}
end;

function SelectTwainImageSource(hwnd:HWND): Integer;
begin
{$IFDEF WIN32}
 if not Twain_Loaded then
  TwainLoadLibrary;
 if assigned (TWAIN_SelectImageSource)
 then
  result:=Twain_SelectImageSource(HWND) else result:=-1;
 {$ELSE}
  result:=Twain_SelectImageSource(hwnd);
 {$ENDIF}
end;
function LoadTwainSourceManager:integer;
begin
{$IFDEF WIN32}
 if not Twain_Loaded then
  TwainLoadLibrary;
 if assigned (TWAIN_loadSourceManager)
 then
  result:=Twain_loadSourceManager else result:=-1;
 {$ELSE}
  result:=Twain_loadSourceManager;
 {$ENDIF}
end;
function UnloadTwainSourceManager:integer;
begin
{$IFDEF WIN32}
 if not Twain_Loaded then
  TwainLoadLibrary;
 if assigned (TWAIN_UnloadSourceManager)
 then
  result:=Twain_UnloadSourceManager else result:=-1;
 {$ELSE}
  result:=Twain_UnloadSourceManager;
 {$ENDIF}
end;
{$IFDEF WIN32}
function TwainLibraryLoaded:boolean;
begin
 result:=Twain_Loaded;
end;
{$ENDIF}
{$IFNDEF Win32}
function ShellAbout(Wnd: HWnd; App, Stuff: PChar; Icon: HIcon): Integer;
  far; external 'shell';
{$ENDIF}

constructor TDialogOptions.Create;
begin
 inherited create;
 fHistoryList:=TStringList.Create;
 Filter:=GraphicFilter(TGraphic);
 fStoreFilter:=False;
end;
destructor TDialogOptions.Destroy;
begin
 fHistoryList.free;
 inherited destroy;
end;

procedure TDialogOptions.SetLines(Value: TStrings);
begin
  FHistoryList.Assign(Value);
end;
function TDialogOptions.GetInitialDir:String;
begin
{$IFDEF DELPHI_2_UP}
{ The code here was changed for backward compatibility
  with Delphi 1 which cannot use the following typecast}
 result:=String(fInitialDir);
{$ELSE}
 if fInitialDir<>nil then
 result:=StrPas(fInitialDir)else result:='';
{$ENDIF}
end;
procedure TDialogOptions.SetInitialDir(Value:String);
var P:Pchar;
begin
{$IFDEF DELPHI_2_UP}
{ The code here was changed for backward compatibility
  with Delphi 1 which cannot use the following code}
 P := StrNew(PChar(Value));
{$ELSE}
{ Delphi 1 method of creating and assigning a Pchar string}
 P := StrAlloc(Length(Value)+1);
 StrPCopy(p,Value);
{ Safeguard for Delphi 1 to prevent invalid pointer problems}
 if fInitialDir<>nil then
{$ENDIF}
 StrDispose(fInitialDir);
 fInitialDir := P;
end;
function TDialogOptions.GetDefaultExt:String;
begin
{$IFDEF DELPHI_2_UP}
 result:=String(fDefaultExt);
{$ELSE}
 if fDefaultExt=nil then result:='' else
 result:=StrPas(fDefaultExt);
{$ENDIF}
end;
procedure TDialogOptions.SetDefaultExt(Value:String);
var P:Pchar;
begin
{$IFDEF DELPHI_2_UP}
 P := StrNew(PChar(Value));
{$ELSE}
 P := StrAlloc(Length(Value)+1);
 StrPCopy(p,Value);
 if fDefaultExt<>nil then
{$ENDIF}
 StrDispose(FDefaultExt);
 FDefaultExt := P;
end;
function TDialogOptions.GetFilename:String;
begin
{$IFDEF DELPHI_2_UP}
 result:=String(fDefaultExt);
{$ELSE}
 if fFileName=nil then result:='' else
 result:=StrPas(fFileName);
{$ENDIF}
end;
procedure TDialogOptions.SetFileName(Value:String);
var P:Pchar;
begin
{$IFDEF DELPHI_2_UP}
 P := StrNew(PChar(Value));
{$ELSE}
 P := StrAlloc(Length(Value)+1);
 StrPCopy(p,Value);
 if fFileName<>nil then
{$ENDIF}
 StrDispose(FFileName);
 FFileName := P;
end;
function TDialogOptions.GetFilter:String;
begin
{$IFDEF DELPHI_2_UP}
 result:=String(fFilter);
{$ELSE}
 if fFilter=nil then result:='' else
 result:=StrPas(fFilter);
{$ENDIF}
end;
procedure TDialogOptions.SetFilter(Value:String);
var P:Pchar;
begin
{$IFDEF DELPHI_2_UP}
 fStoreFilter:=True;
 P := StrNew(PChar(Value));
{$ELSE}
 P := StrAlloc(Length(Value)+1);
 StrPCopy(p,Value);
 if fFilter<>nil then
{$ENDIF}
 StrDispose(fFilter);
 fFilter := P;
end;
function TDialogOptions.GetTitle:String;
begin
{$IFDEF DELPHI_2_UP}
 result:=String(fTitle);
{$ELSE}
 if fTitle=nil then result:='' else
 result:=StrPas(fTitle);
{$ENDIF}
end;
procedure TDialogOptions.SetTitle(Value:String);
var P:Pchar;
begin
{$IFDEF DELPHI_2_UP}
 P := StrNew(PChar(Value));
{$ELSE}
 P := StrAlloc(Length(Value)+1);
 StrPCopy(p,Value);
 if fTitle<>nil then
{$ENDIF}
 StrDispose(fTitle);
 fTitle := P;
end;

constructor TImagePlus.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF DELPHI_2_UP}
  ControlStyle := ControlStyle + [csReplicatable];
{$ENDIF}
  if not (csDesigning in ComponentState) then
  Hint:=LoadStr(sImageHint);
  FPicture := TPicture.Create;
  FPicture.OnChange := PictureChanged;
  Height := 105;
  Width := 105;
  FAspect:=false;
   AOpenDialog:=Nil;
   aSaveDialog:=Nil;
   aPopup:=Nil;
   onDblClick:=Preview;
   fDialogOptions:=TDialogOptions.Create;
   Menu := TPopupMenu.Create(Self);
   Menu.OnPopup:=Popup;
   MenuCopy := TMenuItem.Create(Menu);
   MenuPaste := TMenuItem.Create(Menu);
   MenuOpen := TMenuItem.Create(Menu);
   MenuSave := TMenuItem.Create(Menu);
   MenuCut := TMenuItem.Create(Menu);
   MenuCenter := TMenuItem.Create(Menu);
   MenuStretch := TMenuItem.Create(Menu);
   MenuAspect := TMenuItem.Create(Menu);
   MenuLogo := TMenuItem.Create(Menu);
   MenuBar := TMenuItem.Create(Menu);
   MenuBar1 := TMenuItem.Create(Menu);
   MenuBar2 := TMenuItem.Create(Menu);
   MenuBar3 := TMenuItem.Create(Menu);
   MenuBar4 := TMenuItem.Create(Menu);
   MenuPreview := TMenuItem.Create(Menu);
   MenuEffects:=TMenuItem.Create(Menu);
   MenuFlip:=TmenuItem.Create(Menu);
   MenuMirror:=TMenuItem.Create(Menu);
   with MenuLogo do begin
      Caption := loadStr(sAbout);
      OnClick := OnLogoClick;
   end;
   Menu.Items.Add(MenuLogo);
   with MenuBar do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar);
   with MenuCut do begin
      Caption := loadstr(sCut);
      OnClick := OnCutClick;
   end;
   Menu.Items.Add(MenuCut);
   with MenuCopy do begin
      Caption := loadstr(sCopy);
      OnClick := OnCopyClick;
   end;
   Menu.Items.Add(MenuCopy);
   with MenuPaste do begin
      Caption := loadstr(sPaste);
      OnClick := OnPasteClick;
   end;
   Menu.Items.Add(MenuPaste);
   with MenuBar1 do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar1);
   with MenuOpen do begin
      Caption := loadstr(sOpen);
      OnClick := OnOpenClick;
   end;
   Menu.Items.Add(MenuOpen);
   with MenuSave do begin
      Caption := loadstr(sSaveas);
      OnClick := OnSaveClick;
   end;
   Menu.Items.Add(MenuSave);
   with MenuBar2 do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar2);
   with MenuAspect do begin
      Caption :=loadstr(sAspect);
      OnClick := OnAspectClick;
      Checked:=fAspect;
   end;
   Menu.Items.Add(MenuAspect);
   with MenuCenter do begin
      Caption := loadstr(sCenter);
      OnClick := OnCenterClick;
      Checked:=Center;
   end;
   Menu.Items.Add(MenuCenter);
   with MenuStretch do begin
      Caption := loadstr(sStretch);
      OnClick := OnStretchClick;
      Checked:=Stretch;
   end;
   Menu.Items.Add(MenuStretch);
   with MenuBar3 do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar3);
   with MenuPreview do begin
      Caption := loadstr(sPreview);
      OnClick:=Preview;
{$IFDEF DELPHI_2_UP}
      Default:=True;
{$ENDIF}
   end;
   Menu.Items.Add(MenuPreview);
   with MenuBar4 do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar4);
   with MenuEffects do begin
      Caption := loadstr(sEffects);
   //   OnClick:=nil;
   end;
   Menu.Items.Add(MenuEffects);
   with MenuFlip do begin
      Caption := loadstr(sImageFlip);
      OnClick:=OnFlipClick;
   end;
   MenuEffects.Add(MenuFlip);
   with MenuMirror do begin
      Caption := loadstr(sImageMirror);
      OnClick:=OnMirrorClick;
   end;
   MenuEffects.add(MenuMirror);
   if componentState = [csdesigning] then PopupMenu:=nil else PopupMenu := Menu;
end;

destructor TImagePlus.Destroy;
begin
  FPicture.Free;
  Menu.Free;
  inherited Destroy;
end;

procedure TImagePlus.Preview;
var Preview:TPreviewForm;
begin
{$IFDEF WIN32}
 try if (not assigned (picture.graphic)) or
{$ELSE}
 try if (picture.graphic=nil) or
{$ENDIF}
 picture.graphic.empty then exit;
 except
 exit;
 end;
 Application.Createform(TPreviewForm,Preview);
 try
 Preview.ImagePreview.Flip:=Flip;
 Preview.ImagePreview.Mirror:=Mirror;
 Preview.ImagePreview.Stretch:=Stretch;
 Preview.ImagePreview.Aspect:=Aspect;
 Preview.ImagePreview.Center:=Center;
 Preview.ImagePreview.Picture.Assign(Picture);
 Screen.OnActiveFormChange:=Preview.Notify;
 Preview.Show;
 except
 Screen.OnActiveFormChange:=Preview.ActiveFormEvent;
 preview.free;
 end;
end;

{$IFDEF DELPHI_3_UP}
function TImagePlus.DestRect: TRect;
begin
  if Stretch then
    Result := ClientRect
  else if Center then
    Result := Bounds((Width - Picture.Width) div 2, (Height - Picture.Height) div 2,
      Picture.Width, Picture.Height)
  else
    Result := Rect(0, 0, Picture.Width, Picture.Height);
end;

function TImagePlus.DoPaletteChange: Boolean;
var
  ParentForm: TCustomForm;
  Tmp: TGraphic;
begin
  Result := False;
  Tmp := Picture.Graphic;
  if Visible and (not (csLoading in ComponentState)) and (Tmp <> nil) and
    (Tmp.PaletteModified) then
  begin
    if (Tmp.Palette = 0) then
      Tmp.PaletteModified := False
    else
    begin
      ParentForm := GetParentForm(Self);
      if Assigned(ParentForm) and ParentForm.Active and Parentform.HandleAllocated then
      begin
        if FDrawing then
          ParentForm.Perform(wm_QueryNewPalette, 0, 0)
        else
          PostMessage(ParentForm.Handle, wm_QueryNewPalette, 0, 0);
        Result := True;
        Tmp.PaletteModified := False;
      end;
    end;
  end;
end;

procedure TImagePlus.Progress(Sender: TObject; Stage: TProgressStage;
  PercentDone: Byte; RedrawNow: Boolean; const R: TRect; const Msg: string);
begin
  if FIncrementalDisplay and RedrawNow then
  begin
    if DoPaletteChange then Update
    else Paint;
  end;
{$IFDEF DELPHI_3}
  if Assigned(FOnProgress) then FOnProgress(Sender, Stage, PercentDone, RedrawNow, R, Msg);
{$ENDIF}
end;

procedure TImagePlus.SetTransparent(Value: Boolean);
begin
  if Value <> FTransparent then
  begin
    FTransparent := Value;
    PictureChanged(Self);
  end;
end;

{$ENDIF}

function TImagePlus.GetPalette: HPALETTE;
begin
  Result := 0;
  if FPicture.Graphic is TBitmap then
    Result := TBitmap(FPicture.Graphic).Palette;
end;

{$IFDEF DELPHI_2_UP}
{$WARNINGS OFF}
{$ENDIF}
procedure TImagePlus.Paint;
var FlipRect:TRect;
begin
  if csDesigning in ComponentState then
    with inherited Canvas do
    begin
      Pen.Style := psDash;
      Brush.Style := bsClear;
      Rectangle(0, 0, Width, Height);
    end else
  if picture.Graphic=nil then
    with inherited Canvas do
    begin
      Pen.Style := psdot;
      Brush.Style := bsClear;
      Rectangle(0, 0, Width, Height);
    end;
{$IFDEF DELPHI_3_UP}
   Dest:=DestRect;
{$ENDIF}
   if FAspect then
   begin
   if not (picture.graphic = nil) then
    begin
     try
      x1:=width / picture.width;
      y1:=height / picture.height;
     except
      x1:=width;
      y1:=height;
     end;
      if x1 > y1 then
      begin
         {height is the best fit}
         Dest.top:=0;
         Dest.bottom:=height;
         x:=trunc(picture.width*y1);
         Dest.left:=(width-x)div 2;
         Dest.right:=Dest.left+x;
      end else
      begin
         {width is the best fit}
         Dest.left:=0;
         Dest.right:=width;
         y:=trunc(picture.height*x1);
         Dest.top:=(height-y)div 2;
         Dest.bottom:=Dest.top+y;
      end;
    end;
   end else if Stretch then
    Dest := ClientRect
  else if Center then
    Dest := Bounds((Width - Picture.Width) div 2, (Height - Picture.Height) div 2,
      Picture.Width, Picture.Height)
  else
    Dest := Rect(0, 0, Picture.Width, Picture.Height);
  if fFlip then
   begin
    FlipRect:=Dest;
    Dest.Top:=FlipRect.Bottom;
    Dest.Bottom:=FlipRect.Top;
   end;
  if fMirror then
   begin
    FlipRect:=Dest;
    Dest.Left:=FlipRect.Right;
    Dest.Right:=FlipRect.Left;
   end;
{$IFDEF DELPHI_3_UP}
  Save := FDrawing;
  FDrawing := True;
{$ENDIF}
  try
   if fAspect then ControlStyle := ControlStyle - [csOpaque];
    with inherited Canvas do
      StretchDraw(Dest, Picture.Graphic);
  finally
{$IFDEF DELPHI_3_UP}
    FDrawing := Save;
{$ENDIF}
  end;
end;
{$IFDEF DELPHI_2_UP}
{$WARNINGS ON}
{$ENDIF}

function TImagePlus.GetCanvas: TCanvas;
var
  Bitmap: TBitmap;
begin
  if Picture.Graphic = nil then
  begin
    Bitmap := TBitmap.Create;
    try
      Bitmap.Width := Width;
      Bitmap.Height := Height;
      Picture.Graphic := Bitmap;
    finally
      Bitmap.Free;
    end;
  end;
  if Picture.Graphic is TBitmap then
    Result := TBitmap(Picture.Graphic).Canvas
  else
{$IFDEF Delphi_3_Up}
   raise EInvalidOperation.Create((SImageCanvasNeedsBitmap));
{$ELSE}
   raise EInvalidOperation.Create(LoadStr(SImageCanvasNeedsBitmap));
{$ENDIF}
end;

procedure TImagePlus.SetAutoSize(Value: Boolean);
begin
  FAutoSize := Value;
  PictureChanged(Self);
end;

procedure TImagePlus.SetCenter(Value: Boolean);
begin
  if FCenter <> Value then
  begin
    FCenter := Value;
    Invalidate;
  end;
end;

procedure TImagePlus.SetPicture(Value: TPicture);
begin
  FPicture.Assign(Value);
end;

procedure TImagePlus.SetStretch(Value: Boolean);
begin
 if FStretch <> Value then
  begin
   FStretch := Value;
   MenuStretch.Checked:=Value;
   Invalidate;
  end;
end;

procedure TImagePlus.PictureChanged(Sender: TObject);
{$IFDEF DELPHI_3_UP}
var
  G: TGraphic;
begin
  if AutoSize and (Picture.Width > 0) and (Picture.Height > 0) then
    SetBounds(Left, Top, Picture.Width, Picture.Height);
  G := Picture.Graphic;
  if G <> nil then
  begin
    if not ((G is TMetaFile) or (G is TIcon)) then
      G.Transparent := FTransparent;
    if (not G.Transparent) and (Stretch or (G.Width >= Width)
      and (G.Height >= Height)) then
      ControlStyle := ControlStyle + [csOpaque]
    else
      ControlStyle := ControlStyle - [csOpaque];
    if DoPaletteChange and FDrawing then Update;
  end
  else ControlStyle := ControlStyle - [csOpaque];
  if not FDrawing then Invalidate;
{$else}
begin
  if AutoSize and (Picture.Width > 0) and (Picture.Height > 0) then
    SetBounds(Left, Top, Picture.Width, Picture.Height);
  if (Picture.Graphic is TBitmap) and (Picture.Width = Width) and
    (Picture.Height = Height) then
    ControlStyle := ControlStyle + [csOpaque] else
    ControlStyle := ControlStyle - [csOpaque];
  Invalidate;
{$ENDIF}
end;

procedure TImagePlus.OnCopyClick;
begin
 if picture = nil then else
 ClipBoard.Assign(Picture)
end;

procedure TImagePlus.OnLogoClick;
begin
  ShellAbout(Application.MainForm.Handle,
             'Components by Peter Ivan Dunne',
             'Copyright (c) 1999, Peter Ivan Dunne '#13'mailto:host@codesource.co.uk',
             Application.Icon.Handle);
end;
procedure TImagePlus.OnFlipClick;
begin
 fFlip:=not fFlip;
 MenuFlip.Checked:=fFlip;
 Invalidate;
end;
procedure TImagePlus.OnMirrorClick;
begin
 fMirror:=Not fMirror;
 MenuMirror.Checked:=fMirror;
 Invalidate;
end;
procedure TImagePlus.OnPasteClick;
begin
 Picture.Assign(ClipBoard);
{$IFDEF DELPHI_2_UP}
 DialogOptions.FileName:='Untitled.BMP';
{$ENDIF}
end;

procedure TImagePlus.OnOpenClick;
var Allow:Boolean;
begin
 Allow:=True;
 if assigned(fBeforeLoad) then fBeforeLoad(Self,DialogOptions.FileName,Allow);
 if not Allow then Exit;
 if aOpenDialog = nil then
  begin
   try
{$IFDEF DELPHI_3_UP}
    aOpenDialog:=TOpenPictureDialog.Create(Self);
{$ELSE}
    aOpenDialog:=TOpenDialog.Create(Self);
{$ENDIF}
    with AOpendialog do
     begin
      Ctl3d:=DialogOptions.Ctl3d;
      FileEditStyle:=DialogOptions.FileEditStyle;
      FilterIndex:=DialogOptions.FilterIndex;
      HelpContext:=DialogOptions.HelpContext;
      Options:=DialogOptions.Options;
      Tag:=DialogOptions.Tag;
      Title:=DialogOptions.Title;
       InitialDir:=DialogOptions.Initialdir;
       HistoryList.Assign(DialogOptions.HistoryList);
       DefaultExt:=DialogOptions.DefaultExt;
       FileName:=DialogOptions.FileName;
       Filter:=DialogOptions.Filter;
     end;
   if aOpenDialog.Execute then
   begin
    onCutClick(Self);
    Picture.LoadFromFile(aOpenDialog.FileName);
    with DialogOptions do
     begin
      FilterIndex:=AOpenDialog.FilterIndex;
       HistoryList.Assign(AOpenDialog.HistoryList);
       FileName:=AOpenDialog.FileName;
     end;
     AOpenDialog.Free;
     AOpenDialog:=Nil;
     if assigned(fAfterLoad) then fAfterLoad(Self,DialogOptions.FileName,Allow);
   end;
   except
   end;
  end
 else
  begin
    if aOpenDialog.Execute then
   begin
    onCutClick(Self);
    Picture.LoadFromFile(aOpenDialog.FileName);
    if assigned(fAfterLoad) then fAfterLoad(Self,DialogOptions.FileName,Allow);
   end;
  end;
  paint;
end;

procedure TImagePlus.OnSaveClick;
var Allow:Boolean;
begin
 Allow:=True;
 if assigned(fBeforeSave) then fBeforeSave(Self,DialogOptions.FileName,Allow);
 if not Allow then Exit;
 if aSaveDialog = Nil then
  begin
   try
{$IFDEF DELPHI_3_UP}
    ASaveDialog:=TSavePictureDialog.Create(Self);
{$ELSE}
    ASaveDialog:=TSaveDialog.Create(Self);
{$ENDIF}
    with ASaveDialog do
     begin
      Ctl3d:=DialogOptions.Ctl3d;
      FileEditStyle:=DialogOptions.FileEditStyle;
      FilterIndex:=DialogOptions.FilterIndex;
      HelpContext:=DialogOptions.HelpContext;
      Options:=DialogOptions.Options;
      Tag:=DialogOptions.Tag;
      Title:=DialogOptions.Title;
       InitialDir:=DialogOptions.Initialdir;
       HistoryList.Assign(DialogOptions.HistoryList);
       DefaultExt:=DialogOptions.DefaultExt;
       FileName:=DialogOptions.FileName;
       Filter:=DialogOptions.Filter;
     end;
   if ASaveDialog.Execute then
   begin
    Picture.SaveToFile(ASaveDialog.FileName);
    with DialogOptions do
     begin
      FilterIndex:=ASaveDialog.FilterIndex;
      HelpContext:=ASaveDialog.HelpContext;
       HistoryList.Assign(ASaveDialog.HistoryList);
       FileName:=ASaveDialog.FileName;
     end;
     ASaveDialog.Free;
     ASaveDialog:=Nil;
    if assigned(fAfterSave) then fAfterSave(Self,DialogOptions.FileName,Allow);
    end;
   except
   end
  end
 else
  begin
   if aSaveDialog.Execute then
    Picture.SaveToFile(aSaveDialog.FileName);
   if assigned(fAfterSave) then fAfterSave(Self,DialogOptions.FileName,Allow);
  end;
end;

procedure TImagePlus.OnCutClick;
begin
 if picture = nil then else
 ClipBoard.Assign(Picture);
 DialogOptions.FileName:='';
 Picture.Assign(nil);
end;

procedure TImagePlus.OnStretchClick;
begin
 Stretch:= Not Stretch;
 MenuStretch.Checked:=Stretch;
end;
procedure TImagePlus.OnCenterClick;
begin
 Center:= Not Center;
 MenuCenter.Checked:=Center;
end;
procedure TImagePlus.OnAspectClick;
begin
 Aspect:= Not Aspect;
 MenuAspect.Checked:=Aspect;
end;
{ this is where I set the menu states according to current status}
procedure TImagePlus.Popup;
begin
 MenuStretch.Checked:=Stretch;
 MenuCenter.Checked:=Center;
 MenuAspect.Checked:=Aspect;
{$IFDEF DELPHI_2_UP}
  if  Assigned(Picture.Graphic) then
{$ELSE}
  if Picture.graphic<>NIL then
{$ENDIF}
  begin
   MenuCut.Enabled:=(not Picture.Graphic.Empty);
   MenuCopy.Enabled:=(not Picture.Graphic.Empty) and
  (not (Picture.Graphic is TIcon));
  end else
  begin
   MenuCut.Enabled:=false;
   MenuCopy.Enabled:=false;
  end;
 MenuSave.Enabled:=MenuCopy.Enabled;
 MenuPreview.Enabled:=MenuCopy.Enabled;
 MenuPaste.Enabled:=clipboard.HasFormat(CF_Picture);
 if @APopup <> Nil then
  try
  APopup(Sender);
  finally
  end;
end;
procedure TImagePlus.SetAspect(Value:Boolean);
begin
 if FAspect<> Value then
  begin
   FAspect:=Value;
   Invalidate;
  end;
 end;

{$IFDEF DELPHI_4_UP}

function TImagePlus.CanAutoSize(var NewWidth, NewHeight: Integer): Boolean;
begin
  Result := True;
  if not (csDesigning in ComponentState) or (Picture.Width > 0) and
    (Picture.Height > 0) then
  begin
    if Align in [alNone, alLeft, alRight] then
      NewWidth := Picture.Width;
    if Align in [alNone, alTop, alBottom] then
      NewHeight := Picture.Height;
  end;
end;
{$ENDIF}
procedure TImagePlus.SetFlip;
begin
 fFlip:=value;
 MenuFlip.Checked:=value;
 invalidate;
end;
procedure TImagePlus.SetMirror;
begin
 fMirror:=value;
 MenuMirror.Checked:=value;
 invalidate;
end;
procedure TImagePlus.SetPreview;
begin
 MenuPreview.visible:=value;
 MenuBar3.Visible:=MenuPreview.Visible;
end;
function TImagePlus.GetPreview;
begin
 result:=menuPreview.visible;
end;
{------------------------------------------------------------------------------}

Constructor TImageTwain.Create;
begin
inherited Create(AOwner);
   MenuAcquire := TMenuItem.Create(Menu);
   MenuSelect := TMenuItem.Create(Menu);
   MenuBar4 := TMenuItem.Create(Menu);
   with MenuBar4 do begin
      Caption := '-';
   end;
   Menu.Items.Add(MenuBar4);
   with MenuAcquire do begin
      Caption := loadstr(sAcquire);
      OnClick := OnAcquireClick;
   end;
   Menu.Items.Add(MenuAcquire);
   with MenuSelect do begin
      Caption := loadstr(sSelectSource);
     OnClick := OnSelectClick;
   end;
   Menu.Items.Add(MenuSelect);
end;

destructor TImageTwain.Destroy;
begin
  inherited Destroy;
end;

procedure TImageTwain.OnAcquireClick(Sender:TObject);
var Allow:boolean;
begin
  Allow:=true;
{$IFDEF DELPHI_2_UP}
  if not Assigned(Picture) then exit;
{$ELSE}
  if Picture=NIL then exit;
{$ENDIF}
  if assigned(fBeforeAcquire) then fBeforeAcquire(Self,Allow);
  if Allow then try
  if (LoadTwainSourceManager >0) Then
  Begin
    if (AcquireTwainToClipboard(GetParentForm(self).handle,TWAIN_ANYTYPE)>0)
    Then
     begin
      Picture.Bitmap.LoadFromClipboardFormat(
          cf_BitMap,
          ClipBoard.GetAsHandle(cf_Bitmap),
          0
        );
      DialogOptions.FileName:='Untitled.BMP';
      if assigned(fAfterAcquire) then fAfterAcquire(self,Picture.Bitmap);
     end;
    ClipBoard.Clear;
    UnLoadTwainSourceManager;
  end;
  except
    MessageDlg(Loadstr(sTwainScanFail),mtError,[mbOk],0);
    ClipBoard.Clear;
    UnLoadTwainSourceManager;
  end;
end;

Function TImageTwain.Acquire:integer;
var Allow:boolean;
begin
  Allow:=true;
{$IFDEF DELPHI_2_UP}
  if not Assigned(Picture) then
   begin
    result:=$ffff;
    exit;
   end;
{$ELSE}
  if Picture=nil then
   begin
    result:=$ffff;
    exit;
   end;
{$ENDIF}
  if assigned(fBeforeAcquire) then fBeforeAcquire(Self,Allow);
  if Allow then try
  begin
  result:=LoadTwainSourceManager;
  if (result >0) Then
  Begin
   result:=AcquireTwainToClipboard(GetParentForm(self).handle,TWAIN_ANYTYPE);
   if result>0 then
     begin
      Picture.Bitmap.LoadFromClipboardFormat(
          cf_BitMap,
          ClipBoard.GetAsHandle(cf_Bitmap),
          0
        );
      DialogOptions.FileName:='Untitled.BMP';
      if assigned(fAfterAcquire) then fAfterAcquire(self,Picture.Bitmap);
     end;
    ClipBoard.Clear;
    UnLoadTwainSourceManager;
    Invalidate;
  end end
  except
    ClipBoard.Clear;
    UnLoadTwainSourceManager;
    if assigned(OnScanError) then OnScanError(Self,Result);
  end;
end;

procedure TImageTwain.OnSelectClick(Sender: TObject);
var allow:boolean;

begin
 allow:=true;
 try
 if assigned(fSelectSource) then fSelectSource(Self,Allow);
 if allow then
 SelectTwainImageSource(getParentForm(self).handle);
 except
 MessageDlg(loadstr(sTwainSourceFail),mtError,[mbOk],0);
 end;
end;

procedure TImageTwain.Popup;
begin
 inherited Popup(Sender);
{$IFDEF WIN32}
 MenuAcquire.Enabled:=TwainLibraryLoaded;
{$ENDIF}
end;
{$IFDEF WIN32}
initialization
 TWAIN_LOADED:=FALSE;
 TWAIN_AcquireToClipboard:=nil;
 TWAIN_SelectImageSource:=nil;
 TWAIN_LoadSourceManager:=nil;
 TWAIN_UnloadSourceManager:=nil;
{$ENDIF}
end.
