unit preview;

interface

uses
{$IFDEF WIN32}
  Windows,
{$ELSE}
 WinTypes, WinProcs,
{$ENDIF}
 Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  imaging, ExtCtrls, StdCtrls;

type
  TPreviewForm = class(TForm)
    ImagePreview: TImagePlus;
    procedure CloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Notify(Sender:TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    ActiveFormEvent:TNotifyEvent;
  end;

var
  PreviewForm: TPreviewForm;

implementation

{$R *.DFM}

procedure TPreviewForm.CloseClick(Sender: TObject);
begin
 Screen.OnActiveFormChange:=ActiveFormEvent;
 Close;
end;
procedure TPreviewForm.Notify(Sender:TObject);
begin
 Screen.OnActiveFormChange:=CloseClick;
end;

procedure TPreviewForm.FormShow(Sender: TObject);
begin
{$IFDEF WIN32}
 try if (not assigned (imagepreview.picture.graphic)) or
{$ELSE}
 try if (imagepreview.picture.graphic=nil) or
{$ENDIF}
 imagepreview.picture.graphic.empty then exit
 except exit end;
 clientHeight:=ImagePreview.Picture.Graphic.Height;
 clientWidth:=ImagePreview.Picture.Graphic.Width;
end;

procedure TPreviewForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
{$IFDEF WIN32}
 try if (not assigned (imagepreview.picture.graphic)) or
{$ELSE}
 try if (imagepreview.picture.graphic=nil) or
{$ENDIF}
 imagepreview.picture.graphic.empty then exit
 except exit end;
if key in ['1'..'9'] then
  begin
   clientHeight:=ImagePreview.Picture.Graphic.Height * strtoint(key);
   clientWidth:=ImagePreview.Picture.Graphic.Width * strtoint(key);
  end;
end;

procedure TPreviewForm.FormDestroy(Sender: TObject);
begin
 Screen.OnActiveFormChange:=ActiveFormEvent;
end;

procedure TPreviewForm.FormCreate(Sender: TObject);
begin
 ActiveFormEvent:=Screen.OnActiveFormChange;
end;

procedure TPreviewForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 action:=cafree
end;

end.
