{ Compiler Directives }

{.$DEFINE LocalHost}
{ Define LocalHost for testing internet applications locally. }

{$DEFINE rjHtmlParserComponent}
{.$DEFINE rjWebBotComponent}
{ Undefine these directives if you do not need design time components
  but want to create the objects at runtime instead. }

{.$DEFINE Beta}
{ Is it a beta version? }

{$DEFINE Demo}

{$DEFINE RangeChecking}
{ This define determines whether Code operations will check for Ranges
  (in Lists, for example) and result in an Error-Message in case of violations.
  If Debug is defined, it will automatically define RangeChecking as well.}

{$DEFINE CheckFree}
{ If Defined, all rjObjects keep track if they will were freed before the
  application quits. }

{$DEFINE Debug}
{ Enables full debugging information and turns RangeChecking on. }

{.$DEFINE Final}
{ Set Final for the final compilation of your project.
  Debug and Beta will automatically turned off. }

{$DEFINE rjVectorFastQuickSort}

{ **************************************************************************** }

{$IFDEF Final}
{$UNDEF Beta}
{$UNDEF CheckFree}
{$UNDEF Debug}
{$UNDEF LocalHost}
{$UNDEF RangeChecking}
{$ENDIF}

{$IFDEF Debug}

{$DEFINE CheckFree}
{$DEFINE RangeChecking}

{$D+}                                   // Enable debug information
{$L+}
{$C+}
{$Q-}                                   // Enable Overflow check
{$R-}                                   // Enable RangeChecks

{$ELSE}

{$D-}                                   // Disable debug information
{$L-}
{$C-}
{$Q-}                                   // Disable Overflow check
{$R-}                                   // Disable RangeChecks

{$ENDIF}

{$A+}                                   { - Use DWORD alignment whereever possible }

{$B-}                                   { - Short-circuit boolean expressions }
{$H+}                                   { - Huge string support}
{$I+}                                   { - I/O checking via exceptions }

{$IFDEF RangeChecking}
{$V+}                                   { - Enable var string checking }
{$ELSE}
{$V-}                                   { - Disable var string checking }
{$ENDIF}

{$O+}                                   { - Optimization On }

{$T-}
{ The $T directive controls the types of pointer values generated by the @ operator.
  In the $T- state, the result type of the @ operator is always an untyped pointer
  that is compatible with all other pointer types. When @ is applied to a variable
  reference in the $T+ state, the type of the result is ^T, where T is compatible
  only with other pointers to the type of the variable. }

{$W-}                                   { - No Windows realmode stack frame }
{$X+}                                   { - Enable extended syntax }

{ Version Information }

{$IFDEF VER130}
{$DEFINE DELPHI5}
{$ENDIF}

{$IFDEF VER120}
{$DEFINE DELPHI4}
{$ENDIF}

{$IFDEF VER100}
{$DEFINE DELPHI3}
{$ENDIF}

{$IFDEF VER90}
{$DEFINE DELPHI2}
{$ENDIF}

{$IFDEF VER80}
{$DEFINE DELPHI1}
{$ENDIF}

{$IFDEF DELPHI5}
{$DEFINE DELPHI5_UP}
{$DEFINE DELPHI4_UP}
{$DEFINE DELPHI3_UP}
{$DEFINE DELPHI2_UP}
{$DEFINE DELPHI1_UP}
{$ENDIF}

{$IFDEF DELPHI4}
{$DEFINE DELPHI4_UP}
{$DEFINE DELPHI3_UP}
{$DEFINE DELPHI2_UP}
{$DEFINE DELPHI1_UP}
{$ENDIF}

{$IFDEF DELPHI3}
{$DEFINE DELPHI3_UP}
{$DEFINE DELPHI2_UP}
{$DEFINE DELPHI1_UP}
{$ENDIF}

