{ Copyright Ralf Junker <ralfjunker@gmx.de> 2000
  http://www.zeitungsjunge.de/delphi/ }

unit rjCheckFree;

{$I rj.inc}

interface

procedure RegisterObjectCreate (const AObject: TObject);
procedure RegisterObjectFree (const AObject: TObject);

implementation

uses
 Windows,
 
 rjConsts,
 rjVObject;

var
 CreatedObjects     : TObjectVector = nil;
 
 { ********** }
 
procedure RegisterObjectCreate (const AObject: TObject);
begin
 if (CreatedObjects <> nil) and
  not CreatedObjects.HasItem (AObject) then
  CreatedObjects.Add (AObject);
end;

{ ********** }

procedure RegisterObjectFree (const AObject: TObject);
begin
 if CreatedObjects <> nil then CreatedObjects.RemoveAllOf (AObject);
end;

{ ********** }

procedure CheckAllFree;
var
 i                  : Integer;
 s                  : AnsiString;
begin
 if (CreatedObjects <> nil) and (CreatedObjects.Count > 0) then
  begin
   for i := 0 to CreatedObjects.Count - 1 do
    s := s + CreatedObjects[i].ClassName + CRLF;

   { Now free these objects.}
   while CreatedObjects.IsNotEmpty do
    CreatedObjects.FirstItem.Free;

   MessageBox (0, Pointer ('The following objects were not freed:' + CRLF + CRLF + s),
    'CheckFree Warning', MB_ICONWARNING or MB_OK)
  end;
 
 CreatedObjects.Free;
 CreatedObjects := nil;
end;

{ **************************************************************************** }

initialization
 CreatedObjects := TObjectVector.Create;
 
finalization
 CheckAllFree;
 
end.

