{ Copyright Ralf Junker <ralfjunker@gmx.de> 2000 
  http://www.zeitungsjunge.de/delphi/ }

unit rjConsts;

interface

{$I rj.inc}

const
 
 CR                 = AnsiChar (13);    {Code fr Wagenrcklauf  / carriage-return}
 LF                 = AnsiChar (10);    {Code fr Zeilenvorschub / line-feed}
 CRLF               = CR + LF;
 
 { Ansi Character Sets }
 ANSI_DIGITS        = [AnsiChar ('0')..AnsiChar ('9')];
 ANSI_HEX           = ANSI_DIGITS + [AnsiChar ('A')..AnsiChar ('F'), AnsiChar ('a')..AnsiChar ('f')];
 AnsiLowAlpha       = [AnsiChar ('a')..AnsiChar ('z'), AnsiChar (''), AnsiChar (''), AnsiChar (''), AnsiChar ('')];
 AnsiHighAlpha      = [AnsiChar ('A')..AnsiChar ('Z'), AnsiChar (''), AnsiChar (''), AnsiChar ('')];
 AnsiAlpha          = AnsiLowAlpha + AnsiHighAlpha;
 AnsiAlphaNumeric   = AnsiAlpha + ANSI_DIGITS;
 AnsiUpperChars     = [AnsiChar (#1)..AnsiChar ('`'), AnsiChar ('{')..AnsiChar (''), AnsiChar (''), AnsiChar (''), AnsiChar ('')..AnsiChar (''), AnsiChar ('')..AnsiChar ('')];
 ANSI_WHITE_SPACE     = [AnsiChar (#1)..AnsiChar (#32)]; // Does NOT include Non-Breaking-Space (#160)!
 AnsiQuotes         = [AnsiChar ('"'), AnsiChar ('''')];
 AnsiWordSeparators = ANSI_WHITE_SPACE + ANSI_DIGITS + [AnsiChar ('.'), AnsiChar ('"'), AnsiChar ('-'), AnsiChar ('/')];
 
 DOS_PATH_SEPARATOR = AnsiChar ('\');
 UNIX_PATH_SEPARATOR = AnsiChar ('/');
 
 PATH_SEPARATOR     = DOS_PATH_SEPARATOR;
 
 TICKS_PER_SECOND   = 1000;
 
 BUFFER_SIZE        = $2000;            // Default size for buffers.
 
 BITS_PER_BYTE      = 8;
 BYTES_PER_CARDINAL = SizeOf (Cardinal);
 BITS_PER_CARDINAL  = BYTES_PER_CARDINAL * BITS_PER_BYTE;
 
implementation

end.

