{ Copyright Ralf Junker <ralfjunker@gmx.de> 2000
  http://www.zeitungsjunge.de/delphi/ }

unit rjTypes;

interface

{$I rj.inc}

type
 
 TBuffer = record
  Buffer: PChar;
  Size: Integer;
  Position: Integer;
 end;
 
 { Events }
 TProcEvent = procedure of object;
 TBooleanFunc = function: Boolean of object;
 
 TIntegerEvent = function (const Sender: TObject): Integer of object;
 
 { Functions }
 TAnsiStringIntegerFunction = function (const s: AnsiString): Integer;
 TAnsiStringCardinalFunction = function (const s: AnsiString): Cardinal;
 
 { Base Record Types }
 
 PBase08 = ^TBase08;
 TBase08 = Byte;
 
 PBase16 = ^TBase16;
 TBase16 = Word;
 
 PBase32 = ^TBase32;
 TBase32 = Cardinal;
 
 PBase64 = ^TBase64;
 TBase64 = Int64;
 
 PBase96 = ^TBase96;
 TBase96 = record
  One: Cardinal;
  Two: Cardinal;
  Three: Cardinal;
 end;
 
 PBase128 = ^TBase128;
 TBase128 = record
  One: Cardinal;
  Two: Cardinal;
  Three: Cardinal;
  Four: Cardinal;
 end;
 
 PBase192 = ^TBase192;
 TBase192 = record
  One: Cardinal;
  Two: Cardinal;
  Three: Cardinal;
  Four: Cardinal;
  Five: Cardinal;
  Six: Cardinal;
 end;
 
 TBase08Array = array[0..MaxInt div SizeOf (TBase08) - 1] of TBase08;
 TBase16Array = array[0..MaxInt div SizeOf (TBase16) - 1] of TBase16;
 TBase32Array = array[0..MaxInt div SizeOf (TBase32) - 1] of TBase32;
 TBase64Array = array[0..MaxInt div SizeOf (TBase64) - 1] of TBase64;
 TBase96Array = array[0..MaxInt div SizeOf (TBase96) - 1] of TBase96;
 
 PBase8Array = ^TBase08Array;
 PBase16Array = ^TBase16Array;
 PBase32Array = ^TBase32Array;
 PBase64Array = ^TBase64Array;
 PBase96Array = ^TBase96Array;
 
 { Variant Base Record Types }
 {
 TBase08v = packed record case Byte of
   0: (AsShortInt: ShortInt);
   1: (AsByte: Byte);
   2: (AsByteBool: ByteBool);
   3: (AsAnsiChar: AnsiChar);
 end;
 
 TBase16v = packed record case Byte of
   0: (AsSmallInt: SmallInt);
   1: (AsWord: Word);
   2: (AsWordBool: WordBool);
   3: (AsDefault: SmallInt);
 end;
 
 TBase32v = packed record case Byte of
   0: (AsInteger: Integer);
   1: (AsCardinal: Cardinal);
   2: (AsSingle: Single);
   3: (AsLongBool: LongBool);
   4: (AsDefault: Integer);
 end;
 
 TBase64v = packed record case Byte of
   0: (AsInt64: Int64);
   1: (AsDouble: Double);
   2: (AsDateTime: TDateTime);
 end;
 
 TBase08vArray = array[ 0..MaxInt div SizeOf (TBase08) - 1] of TBase08;
 TBase16vArray = array[ 0..MaxInt div SizeOf (TBase16) - 1] of TBase16;
 TBase32vArray = array[ 0..MaxInt div SizeOf (TBase32) - 1] of TBase32;
 TBase64vArray = array[ 0..MaxInt div SizeOf (TBase64) - 1] of TBase64;
 
 PBase8vArray = ^TBase08vArray;
 PBase16vArray = ^TBase16vArray;
 PBase32vArray = ^TBase32vArray;
 PBase64vArray = ^TBase64vArray;
 }
 { List of Types }
 
 PByte = ^Byte;
 PByteArray = ^TByteArray;
 TByteArray = array[0..MaxInt div SizeOf (Byte) - 1] of Byte;
 
 PShortInt = ^ShortInt;
 PShortIntArray = ^TShortIntArray;
 TShortIntArray = array[0..MaxInt div SizeOf (ShortInt) - 1] of ShortInt;
 
 PAnsiCharArray = ^TAnsiCharArray;
 TAnsiCharArray = array[0..MaxInt div SizeOf (AnsiChar) - 1] of AnsiChar;
 
 PWord = ^Word;
 PWordArray = ^TWordArray;
 TWordArray = array[0..MaxInt div SizeOf (Word) - 1] of Word;
 
 PSmallInt = ^SmallInt;
 PSmallIntArray = ^TSmallIntArray;
 TSmallIntArray = array[0..MaxInt div SizeOf (SmallInt) - 1] of SmallInt;
 
 { 32 Bit Types ********** }
 
 PPointerArray = ^TPointerArray;
 TPointerArray = array[0..MaxInt div SizeOf (Pointer) - 1] of Pointer;
 
 PObject = ^TObject;
 PObjectArray = ^TObjectArray;
 TObjectArray = array[0..MaxInt div SizeOf (TObject) - 1] of TObject;
 
 PInteger = ^Integer;
 PIntegerArray = ^TIntegerArray;
 TIntegerArray = array[0..MaxInt div SizeOf (Integer) - 1] of Integer;
 
 PCardinal = ^Cardinal;
 PCardinalArray = ^TCardinalArray;
 TCardinalArray = array[0..MaxInt div SizeOf (Cardinal) - 1] of Cardinal;
 
 PSingle = ^Single;
 PSingleArray = ^TSingleArray;
 TSingleArray = array[0..MaxInt div SizeOf (Single) - 1] of Single;
 
 // PAnsiString = ^AnsiString; // In System.pas.
 PAnsiStringArray = ^TAnsiStringArray;
 TAnsiStringArray = array[0..MaxInt div SizeOf (AnsiString) - 1] of AnsiString;
 
 { 64 Bit Types ********** }
 
 // PInt64 = ^Int64; // In System.pas.
 PInt64Array = ^TInt64Array;
 TInt64Array = array[0..MaxInt div SizeOf (Int64) - 1] of Int64;
 
 PDouble = ^Double;
 PDoubleArray = ^TDoubleArray;
 TDoubleArray = array[0..MaxInt div SizeOf (Double) - 1] of Double;
 
 PAnsistringBase32 = ^TAnsistringBase32;
 TAnsistringBase32 = record
  Name: AnsiString;
  Number1: TBase32;
 end;
 PAnsistringBase32Array = ^TAnsistringBase32Array;
 TAnsistringBase32Array = array[0..MaxInt div SizeOf (TAnsistringBase32) - 1] of TAnsistringBase32;
 
 PAnsiStringBase32Hack = ^TAnsiStringBase32Hack;
 TAnsiStringBase32Hack = record
  Name: Pointer;
  Number1: TBase32;
 end;
 
 PAnsiStringInteger = ^TAnsistringInteger;
 TAnsistringInteger = record
  Name: AnsiString;
  Number1: Integer;
 end;
 PAnsistringIntegerArray = ^TAnsistringIntegerArray;
 TAnsistringIntegerArray = array[0..MaxInt div SizeOf (TAnsistringInteger) - 1] of TAnsistringInteger;
 
 TAnsiStringIntegerHack = record
  Name: Pointer;
  Number1: Integer;
 end;
 
 PAnsiStringCardinal = ^TAnsiStringCardinal;
 TAnsiStringCardinal = record
  Name: AnsiString;
  Number: Cardinal;
 end;
 PAnsiStringCardinalArray = ^TAnsistringCardinalArray;
 TAnsistringCardinalArray = array[0..MaxInt div SizeOf (TAnsiStringCardinal) - 1] of TAnsiStringCardinal;
 
 { AnsiStringObject }
 PAnsiStringObject = ^TAnsistringObject;
 TAnsistringObject = record
  Name: AnsiString;
  Object1: TObject;
 end;
 PAnsistringObjectArray = ^TAnsistringObjectArray;
 TAnsistringObjectArray = array[0..MaxInt div SizeOf (TAnsistringObject) - 1] of TAnsistringObject;
 
 TAnsiStringObjectHack = record
  Name: Pointer;
  Object1: TObject;
 end;
 
 { AnsiStringBase32Base32 }
 PAnsiStringBase32Base32 = ^TAnsiStringBase32Base32;
 TAnsiStringBase32Base32 = record
  Name: AnsiString;
  Base1: TBase32;
  Base2: TBase32;
 end;
 PAnsiStringBase32Base32Array = ^TAnsiStringBase32Base32Array;
 TAnsiStringBase32Base32Array = array[0..MaxInt div SizeOf (TAnsiStringBase32Base32) - 1] of TAnsiStringBase32Base32;
 
 TAnsiStringBase32Base32Hack = record
  Name: Pointer;
  Base1: TBase32;
  Base2: TBase32;
 end;
 
 { AnsiStringIntegerBase32 }
 PAnsiStringIntegerBase32 = ^TAnsiStringIntegerBase32;
 TAnsiStringIntegerBase32 = record
  Name: AnsiString;
  Number1: Integer;
  Base2: TBase32;
 end;
 PAnsiStringIntegerBase32Array = ^TAnsiStringIntegerBase32Array;
 TAnsiStringIntegerBase32Array = array[0..MaxInt div SizeOf (TAnsiStringIntegerBase32) - 1] of TAnsiStringIntegerBase32;
 
 TAnsiStringIntegerBase32Hack = record
  Name: Pointer;
  Number1: Integer;
  Base2: TBase32;
 end;
 
 { AnsiStringInteger2 }
 PAnsiStringInteger2 = ^TAnsiStringInteger2;
 TAnsiStringInteger2 = record
  Name: AnsiString;
  Number1: Integer;
  Number2: Integer;
 end;
 PAnsiStringInteger2Array = ^TAnsiStringInteger2Array;
 TAnsiStringInteger2Array = array[0..MaxInt div SizeOf (TAnsiStringInteger2) - 1] of TAnsiStringInteger2;
 
 TAnsiStringInteger2Hack = record
  Name: Pointer;
  Number1: Integer;
  Number2: Integer;
 end;
 
 { AnsiString2 }
 PAnsiString2 = ^TAnsiString2;
 TAnsiString2 = record
  Name: AnsiString;
  Value1: AnsiString;
 end;
 PAnsiString2Array = ^TAnsiString2Array;
 TAnsiString2Array = array[0..MaxInt div SizeOf (TAnsiString2) - 1] of TAnsiString2;
 
 TAnsiString2Hack = record
  Name: Pointer;
  Value1: Pointer;
 end;
 
 PAnsiString2Base32 = ^TAnsiString2Base32;
 TAnsiString2Base32 = record
  Name: AnsiString;                     // The two strings Name and Value MUST directly follow each other.
  Value1: AnsiString;                   // We use a Int64-cast to zero their memory further below!
  Base1: TBase32;
 end;
 PAnsiString2Base32Array = ^TAnsiString2Base32Array;
 TAnsiString2Base32Array = array[0..MaxInt div SizeOf (TAnsiString2Base32) - 1] of TAnsiString2Base32;
 
 TAnsiString2Base32Hack = record
  Name: Pointer;
  Value1: Pointer;
  Base1: TBase32;
 end;
 
 PAnsiString2Integer = ^TAnsiString2Integer;
 TAnsiString2Integer = record
  Name: AnsiString;
  Value1: AnsiString;
  Number1: Integer;
 end;
 PAnsiString2IntegerArray = ^TAnsiString2IntegerArray;
 TAnsiString2IntegerArray = array[0..MaxInt div SizeOf (TAnsiString2Integer) - 1] of TAnsiString2Integer;
 
 TAnsiString2IntegerHack = record
  Name: Pointer;
  Value1: Pointer;
  Number1: Integer;
 end;
 
 PAnsiString2Cardinal = ^TAnsiString2Cardinal;
 TAnsiString2Cardinal = record
  Name: AnsiString;
  Value1: AnsiString;
  Number1: Cardinal;
 end;
 PAnsiString2CardinalArray = ^TAnsiString2CardinalArray;
 TAnsiString2CardinalArray = array[0..MaxInt div SizeOf (TAnsiString2Cardinal) - 1] of TAnsiString2Cardinal;
 
 PAnsiString3 = ^AnsiString3;
 AnsiString3 = record
  Name: AnsiString;
  Value1: AnsiString;
  Value2: AnsiString;
 end;
 PAnsiString3Array = ^TAnsiString3Array;
 TAnsiString3Array = array[0..MaxInt div SizeOf (AnsiString3) - 1] of AnsiString3;
 
 { PDoubleString = ^TDoubleString;
  TDoubleString = record
   Key: AnsiString;
   Value: AnsiString;
  end;
  PDoubleStringArray = ^TDoubleStringArray;
  TDoubleStringArray = array[ 0..MaxInt div SizeOf (TDoubleString) - 1] of TDoubleString;
  }
 PInteger2 = ^TInteger2;
 TInteger2 = record
  Number1: Integer;
  Number2: Integer;
 end;
 
 TAnsiCharSet = set of AnsiChar;
 
 { **************************************************************************** }
 
 PHashBase00 = ^THashBase00;
 THashBase00 = record
  Name: AnsiString;
  Next: Integer;
 end;
 PHashBase00Array = ^THashBase00Array;
 THashBase00Array = array[0..MaxInt div SizeOf (THashBase00) - 1] of THashBase00;
 
 { ********** }
 
 PHashBase08 = ^THashBase08;
 THashBase08 = record
  Name: AnsiString;
  Next: Integer;
  Item: TBase08;
 end;
 PHashBase08Array = ^THashBase08Array;
 THashBase08Array = array[0..MaxInt div SizeOf (THashBase08) - 1] of THashBase08;
 
 { ********** }
 
 PHashBase16 = ^THashBase16;
 THashBase16 = record
  Name: AnsiString;
  Next: Integer;
  Item: TBase16;
 end;
 PHashBase16Array = ^THashBase16Array;
 THashBase16Array = array[0..MaxInt div SizeOf (THashBase16) - 1] of THashBase16;
 
 PHashWord = ^THashWord;
 THashWord = record
  Name: AnsiString;
  Next: Integer;
  Item: Word;
 end;
 PHashWordArray = ^THashWordArray;
 THashWordArray = array[0..MaxInt div SizeOf (THashWord) - 1] of THashWord;
 
 { ********** }
 
 PHashBase32 = ^THashBase32;
 THashBase32 = record
  Name: AnsiString;
  Next: Integer;
  Item: TBase32;
 end;
 PHashBase32Array = ^THashBase32Array;
 THashBase32Array = array[0..MaxInt div SizeOf (THashBase32) - 1] of THashBase32;
 
 { ********** }
 
 PHashBase64 = ^THashBase64;
 THashBase64 = record
  Name: AnsiString;
  Next: Integer;
  Item: TBase64;
 end;
 PHashBase64Array = ^THashBase64Array;
 THashBase64Array = array[0..MaxInt div SizeOf (THashBase64) - 1] of THashBase64;
 
 { ********** }
 
 PHashInteger = ^THashInteger;
 THashInteger = record
  Name: AnsiString;
  Next: Integer;
  Item: Integer;
 end;
 PHashIntegerArray = ^THashIntegerArray;
 THashIntegerArray = array[0..MaxInt div SizeOf (THashInteger) - 1] of THashInteger;
 
 { ********** }
 
 PHashInt64 = ^THashInt64;
 THashInt64 = record
  Name: AnsiString;
  Next: Integer;
  Item: Int64;
 end;
 PHashInt64Array = ^THashInt64Array;
 THashInt64Array = array[0..MaxInt div SizeOf (THashInt64) - 1] of THashInt64;
 
 { ********** }
 
 PHashAnsiChar = ^THashAnsiChar;
 THashAnsiChar = record
  Name: AnsiChar;
  Next: Integer;
  Item: AnsiChar;
 end;
 PHashAnsiCharArray = ^THashAnsiCharArray;
 THashAnsiCharArray = array[0..MaxInt div SizeOf (THashAnsiChar) - 1] of THashAnsiChar;
 
 { ********** }
 
 PHashAnsiString = ^THashAnsiString;
 THashAnsiString = record
  Name: AnsiString;
  Next: Integer;
  Item: AnsiString;
 end;
 PHashAnsiStringArray = ^THashAnsiStringArray;
 THashAnsiStringArray = array[0..MaxInt div SizeOf (THashAnsiString) - 1] of THashAnsiString;
 
 { ********** }
 
 PHashBase128 = ^THashBase128;
 THashBase128 = record
  Name: AnsiString;
  Next: Integer;
  Item: TBase128;
 end;
 PHashBase128Array = ^THashBase128Array;
 THashBase128Array = array[0..MaxInt div SizeOf (THashBase128) - 1] of THashBase128;
 
implementation

end.

