{ Copyright Ralf Junker <ralfjunker@gmx.de> 2000 
  http://www.zeitungsjunge.de/delphi/ }

unit rjVAnsiString2Base32;

interface

{$I rj.inc}

uses
 {$IFDEF RangeChecking}
 Consts,
 {$ENDIF}
 Classes,
 
 rjVectors,
 rjVBase96,
 rjStreams,
 rjTypes;

type
 PBaseNumber1 = ^TBaseNumber1;
 TBaseNumber1 = Cardinal;

 PBaseType = PAnsiString2Base32;
 TBaseType = TAnsiString2Base32;
 TBaseTypeHack = TAnsiString2Base32Hack;
 PBaseArray = PAnsiString2Base32Array;
 
 {$DEFINE DynamicItems}
 
 TBaseTypeVector = class (ABase96Vector)
  {$I rjVDeAlloc.def}
  {$I rjVAllocRecordNameValue1Base1.def}
  {$DEFINE Name}{$I rjVHandleRecordDefinedType.def}{$UNDEF Name}
  {$DEFINE Value1}{$I rjVHandleRecordDefinedType.def}{$UNDEF Value1}
  {$I rjVHandleRecordNameValue1.def}

 public
  function ReadFromBinaryStream (const Stream: TStream): Boolean; override;
  procedure WriteToBinaryStream (const Stream: TStream); override;
 end;
 AAnsiString2Base32Vector = TBaseTypeVector;
 
 {$I rjVCompareRecordNameValue1.def}
 {$I rjVCompareRecordName.def}
 {$I rjVCompareRecordValue1.def}
 
implementation

uses rjStrings;

const
 BASE_X_INIT_DEFAULT_VALUE = 0;
 
 { **************************************************************************** }
 { TAnsiString2Base32Vector
 { **************************************************************************** }
 
 {$I rjVDeAlloc.imp}
 {$I rjVAllocRecordNameValue1Base1.imp}
 {$DEFINE Name}{$I rjVHandleRecordDefinedType.imp}{$UNDEF Name}
 {$DEFINE Value1}{$I rjVHandleRecordDefinedType.imp}{$UNDEF Value1}
 {$I rjVHandleRecordNameValue1.imp}
 
function TBaseTypeVector.ReadFromBinaryStream (const Stream: TStream): Boolean;
var
 i                  : Integer;
 p                  : PBaseType;
 Reader             : TrjReader;
begin
 Clear;
 Reader := TrjReader.Create (Stream);
 try
  try
   i := Reader.ReadInteger;
   while i > 0 do
    begin
     p := AddEmpty;
     p^.Name := Reader.ReadBinaryAnsiString;
     p^.Value1 := Reader.ReadBinaryAnsiString;
     p^.Base1 := TBaseNumber1 (Reader.ReadCardinal);
     Dec (i);
    end;
   Result := True;
  except
   Result := False;
   if FCount > 1 then DeleteRange (FCount - 1, 1);
  end;
 finally
  Reader.Free;
 end;
end;

{ ********** }

procedure TBaseTypeVector.WriteToBinaryStream (const Stream: TStream);
var
 i                  : Integer;
 p                  : PBaseType;
 Writer             : TrjWriter;
begin
 Writer := TrjWriter.Create (Stream);
 try
  i := FCount;
  Writer.WriteInteger (i);

  p := FVector;
  while i > 0 do
   begin
    Writer.WriteBinaryAnsiString (p^.Name);
    Writer.WriteBinaryAnsiString (p^.Value1);
    Writer.WriteCardinal (Cardinal (p^.Base1));
    Inc (Cardinal (p), SizeOf (TBaseType));
    Dec (i);
   end;

 finally
  Writer.Free;
 end;
end;

{ **************************************************************************** }
{ Compare / Same Functions
{ **************************************************************************** }

{$I rjVCompareRecordNameValue1.imp}
{$I rjVCompareRecordName.imp}
{$I rjVCompareRecordValue1.imp}

end.

