{ Copyright Ralf Junker <ralfjunker@gmx.de> 2000
  http://www.zeitungsjunge.de/delphi/ }

unit rjVAnsiStringBase32;

interface

{$I rj.inc}

uses
 {$IFDEF RangeChecking}
 Consts,
 {$ENDIF}
 Classes,
 
 rjVectors,
 rjVBase64,
 rjTypes;

type
 PBaseNumber1 = PBase32;
 TBaseNumber1 = TBase32;
 
 PBaseType = PAnsistringBase32;
 TBaseType = TAnsistringBase32;
 TBaseTypeHack = TAnsiStringBase32Hack;
 PBaseArray = PAnsistringBase32Array;
 
 {$DEFINE DynamicItems}
 
 TBaseTypeVector = class (ABase64Vector)
  {$I rjVDeAlloc.def}
  {$I rjVAllocRecordNameBase1.def}
  {$DEFINE Name}{$I rjVHandleRecordDefinedType.def}{$UNDEF Name}
 public
  function ReadFromBinaryStream (const Stream: TStream): Boolean; override;
  procedure WriteToBinaryStream (const Stream: TStream); override;
 end;
 AAnsiStringBase32Vector = TBaseTypeVector;
 
 {$I rjVCompareRecordNameNumber1.def}
 {$I rjVCompareRecordName.def}
 
implementation

uses rjStreams, rjStrings;

{ **************************************************************************** }
{ TAnsiStringBase32Vector
{ **************************************************************************** }

{$I rjVDeAlloc.imp}
{$I rjVAllocRecordNameBase1.imp}
{$DEFINE Name}{$I rjVHandleRecordDefinedType.imp}{$UNDEF Name}

{ ********** }

function TBaseTypeVector.ReadFromBinaryStream (const Stream: TStream): Boolean;
var
 i                  : Integer;
 Reader             : TrjReader;
begin
 Reader := TrjReader.Create (Stream);
 try
  try
   i := Reader.ReadInteger;
   Clear;
   while i > 0 do
    begin
     with
      AddEmpty^ do
      begin
       Name := Reader.ReadBinaryAnsiString;
       Number1 := TBaseNumber1 (Reader.ReadCardinal);
      end;
     Dec (i);
    end;
   Result := True;
  except
   Result := False;
   if FCount > 0 then DeleteRange (FCount - 1, 1);
  end;
 finally
  Reader.Free;
 end;
end;

{ ********** }

procedure TBaseTypeVector.WriteToBinaryStream (const Stream: TStream);
var
 i                  : Integer;
 p                  : PBaseType;
 Writer             : TrjWriter;
begin
 Writer := TrjWriter.Create (Stream);
 try
  i := FCount;
  Writer.WriteInteger (i);

  p := FVector;
  while i > 0 do
   begin
    Writer.WriteBinaryAnsiString (p^.Name);
    Writer.WriteCardinal (Cardinal (p^.Number1));
    Inc (Cardinal (p), SizeOf (TBaseType));
    Dec (i);
   end;

 finally
  Writer.Free;
 end;
end;

{ **************************************************************************** }
{ Compare / Same Functions
{ **************************************************************************** }

{$I rjVCompareRecordNameNumber1.imp}
{$I rjVCompareRecordName.imp}

end.

