{ Copyright Ralf Junker <ralfjunker@gmx.de> 2000 
  http://www.zeitungsjunge.de/delphi/ }

unit rjVAnsiStringBase32Base32;

{$I rj.inc}

interface

uses
 {$IFDEF RangeChecking}
 Consts,
 {$ENDIF}
 Classes,
 
 rjVectors,
 rjVBase96,
 rjStreams,
 rjTypes;

type
 
 PBaseNumber1 = ^TBaseNumber1;
 TBaseNumber1 = Cardinal;

 PBaseNumber2 = ^TBaseNumber2;
 TBaseNumber2 = Cardinal;

 PBaseType = PAnsiStringBase32Base32;
 TBaseType = TAnsiStringBase32Base32;
 TBaseTypeHack = TAnsiStringBase32Base32Hack;
 PBaseArray = PAnsiStringBase32Base32Array;
 
 {$DEFINE DynamicItems}
 
 TBaseTypeVector = class (ABase96Vector)
  {$I rjVDeAlloc.def}
  {$I rjVAllocRecordNameBase1Base2.def}
  {$DEFINE Name}{$I rjVHandleRecordDefinedType.def}{$UNDEF Name}

 public
  function ReadFromBinaryStream (const Stream: TStream): Boolean; override;
  procedure WriteToBinaryStream (const Stream: TStream); override;
 end;
 AAnsiStringBase32Base32Vector = TBaseTypeVector;
 
 {$I rjVCompareRecordNameBase1Base2.def}
 {$I rjVCompareRecordName.def}
 
const
 BASE_X_INIT_DEFAULT_VALUE = 0;
 
 VCompareDefault    : TUntypedCompareFunc = VCompareRecordNameBaseXBaseX;
 VMatchDefault      : TUntypedMatchFunc = VMatchRecordNameBaseXBaseX;
 
implementation

uses rjStrings;

{ **************************************************************************** }
{ TAnsiString2Base32Vector
{ **************************************************************************** }

{$I rjVDeAlloc.imp}
{$I rjVAllocRecordNameBase1Base2.imp}
{$DEFINE Name}{$I rjVHandleRecordDefinedType.imp}{$UNDEF Name}

function TBaseTypeVector.ReadFromBinaryStream (const Stream: TStream): Boolean;
var
 i                  : Integer;
 p                  : PBaseType;
 Reader             : TrjReader;
begin
 Clear;
 Reader := TrjReader.Create (Stream);
 try
  try
   i := Reader.ReadInteger;
   while i > 0 do
    begin
     p := AddEmpty;
     p^.Name := Reader.ReadBinaryAnsiString;
     p^.Base1 := TBaseNumber1 (Reader.ReadCardinal);
     p^.Base2 := TBaseNumber2 (Reader.ReadCardinal);
     Dec (i);
    end;
   Result := True;
  except
   Result := False;
   if FCount > 1 then DeleteRange (FCount - 1, 1);
  end;
 finally
  Reader.Free;
 end;
end;

{ ********** }

procedure TBaseTypeVector.WriteToBinaryStream (const Stream: TStream);
var
 i                  : Integer;
 p                  : PBaseType;
 Writer             : TrjWriter;
begin
 Writer := TrjWriter.Create (Stream);
 try
  i := FCount;
  Writer.WriteInteger (i);

  p := FVector;
  while i > 0 do
   begin
    Writer.WriteBinaryAnsiString (p^.Name);
    Writer.WriteCardinal (Cardinal (p^.Base1));
    Writer.WriteCardinal (Cardinal (p^.Base2));
    Inc (Integer (p), SizeOf (TBaseType));
    Dec (i);
   end;

 finally
  Writer.Free;
 end;
end;

{ **************************************************************************** }
{ Compare / Same Functions
{ **************************************************************************** }

{$I rjVCompareRecordNameBase1Base2.imp}
{$I rjVCompareRecordName.imp}

end.

