{ Copyright Ralf Junker <ralfjunker@gmx.de> 2000 
  http://www.zeitungsjunge.de/delphi/ }

unit rjVAnsiStringObject;

interface

{$I rj.inc}

uses
 {$IFDEF RangeChecking}
 Consts,
 {$ENDIF}
 Classes,
 
 rjTypes,
 rjVectors,
 rjVAnsiStringBase32;

type
 PBaseObject1 = PObject;
 TBaseObject1 = TObject;
 
 PBaseType = PAnsiStringObject;
 TBaseType = TAnsistringObject;
 TBaseTypeHack = TAnsiStringObjectHack;
 PBaseArray = PAnsistringObjectArray;
 
 TBaseTypeVector = class (AAnsiStringBase32Vector)
  {$I rjVBaseType.def}
  {$I rjVAllocRecordNameObject1.def}
  {$I rjVHandleRecordNameObject1.def}
  {$DEFINE Object1}{$I rjVHandleRecordDefinedType.def}{$UNDEF Number1}
 end;
 TAnsiStringObjectVector = TBaseTypeVector;
 
 TAnsiStringObjectOwnerVector = class (TAnsiStringObjectVector)
 public
  procedure DeleteRange (const Index, Count: Integer); override;
 end;
 
 {$I rjVCompareRecordNameObject1.def}
 {$I rjVCompareRecordObject1.def}
 
const
 VCompareDefault    : TUntypedCompareFunc = VCompareRecordNameObject1;
 VMatchDefault      : TUntypedMatchFunc = VMatchRecordNameObject1;
 
implementation

uses rjStrings;

{ **************************************************************************** }
{ TAnsiStringObjectVector
{ **************************************************************************** }

{$I rjVBaseType.imp}
{$I rjVAllocRecordNameObject1.imp}
{$I rjVHandleRecordNameObject1.imp}
{$DEFINE Object1}{$I rjVHandleRecordDefinedType.imp}{$UNDEF Number1}

{ **************************************************************************** }
{ TAnsiStringObjectOwnerVector
{ **************************************************************************** }

procedure TAnsiStringObjectOwnerVector.DeleteRange (const Index, Count: Integer);
var
 i                  : Integer;
 p                  : PBaseType;
begin
 {$IFDEF RangeChecking}
 if (Index < 0) or (Index + Count > FCount) then Error (SRangeError, [Index, Count]);
 {$ENDIF}
 
 p := @PBaseArray (FVector)[Index];
 i := Count;
 while i > 0 do
  begin
   if p^.Object1 <> nil then p^.Object1.Free;
   Inc (Cardinal (p), SizeOf (p^));
   Dec (i);
  end;
 
 inherited DeleteRange (Index, Count);
end;

{ **************************************************************************** }
{ Compare / Same Functions
{ **************************************************************************** }

{$I rjVCompareRecordNameObject1.imp}
{$I rjVCompareRecordObject1.imp}

end.

