{ Copyright Ralf Junker <ralfjunker@gmx.de> 2000 
  http://www.zeitungsjunge.de/delphi/ }

unit rjVBase96;

interface

{$I rj.inc}

uses
 {$IFDEF RangeChecking}
 Consts,
 {$ENDIF}
 Classes,
 
 rjBase,
 rjStreams,
 rjVectors,
 rjTypes;

type
 TBaseType = TBase96;
 PBaseArray = PBase96Array;
 
 {$DEFINE SpecialCompare}
 
 {$I rjVBaseX.def}
 
type
 ABase96Vector = ABaseXVector;
 
 {$I rjVCompareDefault.def}
 
const
 BASE_X_INIT_DEFAULT_VALUE    : TBase96 = (One: 0; Two: 0; Three: 0);
 
implementation

{$I rjVBaseX.imp}

{ **************************************************************************** }
{ Compare / Same Functions
{ **************************************************************************** }

function VCompareDefault (const Item1, Item2): Integer;
begin
 if TBase96 (Item1).One < TBase96 (Item2).One then
  Result := -1
 else
  if TBase96 (Item1).One > TBase96 (Item2).One then
   Result := 1
  else
   if TBase96 (Item1).Two < TBase96 (Item2).Two then
    Result := -1
   else
    if TBase96 (Item1).Two > TBase96 (Item2).Two then
     Result := 1
    else
     if TBase96 (Item1).Three < TBase96 (Item2).Three then
      Result := -1
     else
      if TBase96 (Item1).Three > TBase96 (Item2).Three then
       Result := 1
      else
       Result := 0;
end;

{ ********** }

function VMatchDefault (const Item1, Item2): Boolean;
begin
 Result := (TBase96 (Item1).One = TBase96 (Item2).One) and
  (TBase96 (Item1).Two = TBase96 (Item2).Two) and
  (TBase96 (Item1).Three = TBase96 (Item2).Three);
end;

end.

