{ Copyright Ralf Junker <ralfjunker@gmx.de> 2000 
  http://www.zeitungsjunge.de/delphi/ }

unit rjVObject;

{$I rj.inc}

interface

uses
 {$IFDEF RangeChecking}
 Consts,
 {$ENDIF}
 Classes,
 
 rjVectors,
 rjVBase32,
 rjTypes;

type
 
 PBaseType = PObject;
 TBaseType = TObject;
 PBaseArray = PObjectArray;
 
 TBaseTypeVector = class (ABase32Vector)
  {$I rjVGenericAllocX.def }
  {$I rjVGenericBaseType.def}
  {$I rjVNoStreaming.def}
 end;
 TObjectVector = TBaseTypeVector;
 
 TObjectOwnerVector = class (TObjectVector)
 public
  procedure DeleteRange (const Index, Count: Integer); override;
 end;
 
implementation

{ **************************************************************************** }
{ TObjectVector
{ **************************************************************************** }

{$I rjVGenericBaseType.imp}
{$I rjVGenericAllocX.imp }
{$I rjVNoStreaming.imp}

{ **************************************************************************** }
{ TObjectOwnerVector
{ **************************************************************************** }

procedure TObjectOwnerVector.DeleteRange (const Index, Count: Integer);
var
 i                  : Integer;
 p                  : PBaseType;
begin
 {$IFDEF RangeChecking}
 if (Index < 0) or (Index + Count > FCount) then Error (SRangeError, [Index, Count]);
 {$ENDIF}
 
 p := @PBaseArray (FVector)[Index];
 i := Count;
 while i > 0 do
  begin
   if p^ <> nil then p^.Free;
   Inc (Cardinal (p), SizeOf (p^));
   Dec (i);
  end;
 
 inherited DeleteRange (Index, Count);
end;

end.

