{ Copyright Ralf Junker <ralfjunker@gmx.de> 2000 
  http://www.zeitungsjunge.de/delphi/ }

unit rjVPointer;

{$I rj.inc}

interface

uses
 Consts,
 
 rjVectors,
 rjVBase32,
 rjTypes;

type
 
 TBaseType = Pointer;
 PBaseArray = PPointerArray;
 
 TBaseTypeVector = class (TBase32Vector)
  {$I rjVGenericBaseType.def}
  {$I rjVGenericAllocX.def}
 protected
  function Compare (const Index: Integer; const Item): Integer; override;
  function Same (const Index: Integer; const Item): Boolean; override;
 end;
 
 TPointerVector = TBaseTypeVector;
 
implementation

const
 CustomDefaultValue      = nil;
 
 {$I rjVGenericBaseType.imp}
 {$I rjVGenericAllocX.imp}
 
function TBaseTypeVector.Compare (const Index: Integer; const Item): Integer;
begin
 if TBase32 (PBaseArray (FVector)^[Index]) < TBase32 (Item) then
  Result := -1
 else
  if TBase32 (PBaseArray (FVector)^[Index]) > TBase32 (Item) then
   Result := 1
  else
   Result := 0;
end;

function TBaseTypeVector.Same (const Index: Integer; const Item): Boolean;
begin
 Result := TBase32 (PBaseArray (FVector)^[Index]) = TBase32 (Item);
end;

end.

